﻿#include <iostream>
#include <string>

using namespace std;

int main() {
    string input;
    getline(cin, input);

    long long max_depth = 0;
    long long current_depth = 0;

    for (char c : input) {
        if (c == '{') {
            current_depth++;
            if (current_depth > max_depth) {
                max_depth = current_depth;
            }
        }
        else if (c == '}') {
            current_depth--;
        }
    }
    cout << max_depth - 1 << endl;
    return 0;
}
