﻿#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

double triangleArea(long long ax, long long ay, long long bx, long long by, long long cx, long long cy) {
    return abs(ax * (by - cy) + bx * (cy - ay) + cx * (ay - by)) / 2.0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); 

    long long n = 0;
    cin >> n;

    if (n != 3) {
        cout << 0 << endl;
        return 0;
    }

    long long ax = 0, ay = 0;
    long long bx = 0, by = 0;
    long long cx = 0, cy = 0;

    cin >> ax >> ay >> bx >> by >> cx >> cy;

    double area = triangleArea(ax, ay, bx, by, cx, cy);

    if (area == 0) {
        cout << 0 << endl;
    }
    else {
        cout << area << endl;
    }

    return 0;
}
