def main():
    n = int(input().strip())
    
    words = [input().strip() for _ in range(n)]
    
    has_letter = [False] * 26
    
    for word in words:
        first_letter = word[0]
        index = ord(first_letter) - ord('a')
        has_letter[index] = True
    
    ans = []
    for i in range(5):
        row = ""
        for j in range(6):
            index = i * 6 + j
            if index < 26:
                row += chr(ord('a') + index) if has_letter[index] else '.'
            else:
                break
        ans.append(row)
    
    print("\n".join(ans))




if __name__ == "__main__":
    main()
