def main():
    n = int(input())
    piles = list(map(int, input().split()))
    
    if n == 1:
        return "Alice"
    
    min_pile = min(piles)
    max_pile = max(piles)
    
    if min_pile == max_pile:
        print("Alice" if n % 2 == 1 else "Dmitry")
        return
    
    all_different = len(set(piles)) == n
    if all_different:
        print("Alice")
        return
    
    print("Alice" if min_pile % 2 == 1 else "Dmitry")

if __name__ == "__main__":
    main()