#include <iostream>
#include <vector>

using namespace std;

int main() {
  int n;
  cin >> n;

  vector<vector<int>> matrix(n, vector<int>(n));
  
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> matrix[i][j];
    }
  }
  
  
  bool result = true;
  for (int i = 0; i < n && result; ++i) {
    for (int j = i + 1; j < n && result; ++j) {
      for (int k = 0; k < n && result; ++k) {
        if (k != i && k != j && matrix[i][j] > matrix[i][k] + matrix[k][j]) {
          result = false;
          break;
        }
      }
    }
  }

  if (result) {
    cout << "Yes" << endl;
  } else {
    cout << "No" << endl;
  }

  return 0;
}

