#include <iostream>
#include <vector>
#include <unordered_map>

#define ll long long

using namespace std;

vector<int> brackets;

int value(int order_num)
{
	if (order_num)
	{
		ll sum_br{1};
		for (auto i = order_num - 1; i >= 0; --i)
		{
			sum_br += brackets[i];
		}
		return sum_br;
	}
	else
		return 1;
}

int main(int argc, char** argv)
{
	ll start_brackets{}, max{};

	for (auto i = 0; i < 15; ++i)
	{
		brackets.push_back(value(i));
	}

	string text;

	cin >> text;

	for (auto simbol : text)
	{
		switch (simbol)
		{
		case '{':
			start_brackets++;
			break;
		case '}':
			break;
		case ',':
			break;
		default:
			break;
		}
	}

	auto answer = find(brackets.begin(), brackets.end(), start_brackets);

	cout << distance(brackets.begin(), answer);

	return 0;
}

