def ordinal_to_n(ordinal):
    ordinal = ordinal.strip()

    def count_elements(s):
        count = 0
        depth = 0
        in_set = False

        for char in s:
            if char == '{':
                if depth == 0:
                    in_set = True
                depth += 1
            elif char == '}':
                depth -= 1
                if depth == 0:
                    in_set = False
            elif char == ',' and depth == 1:
                count += 1

        if depth == 0 and in_set:
            count += 1

        return count

    if ordinal == '{}':
        return 0

    element_count = count_elements(ordinal) + 1
    return element_count


input_ordinal = input()
result = ordinal_to_n(input_ordinal)
print(result)
