#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void minimizeNumber(vector<pair<string, long long>>& test_cases) {
    for (auto& test_case : test_cases) {
        string s = test_case.first;
        long long k = test_case.second;
        int n = s.size();
        string result;

        for (int i = 0; i < n; ++i) {
            int max_index = min(i + k, n - 1);
            char min_digit = '9' + 1;  
            int min_index = -1;

            for (int j = i; j <= max_index; ++j) {
                if (s[j] < min_digit) {
                    min_digit = s[j];
                    min_index = j;
                }
            }

            if (min_index != -1) {
                result += min_digit;

                k -= (min_index - i);

                s.erase(min_index, 1);
            }
        }

        cout << result << endl;
    }
}

int main() {
    int t;
    cin >> t; 
    vector<pair<string, long long>> test_cases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        test_cases[i] = {s, k};
    }

    minimizeNumber(test_cases); 

    return 0;
}