#include <iostream>
#include <string>
#include <deque>

std::string m(std::string s, int k) {
    int n = s.length();
    std::deque<char> result;

    for (int i = 0; i < n; ++i) {
        
        if (result.size() < i) {
            result.push_back(s[i]);
            continue;
        }

        
        int min_index = i;
        for (int j = i + 1; j < std::min(n, i + k + 1); ++j) {
            if (s[j] < s[min_index]) {
                min_index = j;
            }
        }

        
        while (min_index > i) {
            std::swap(s[min_index], s[min_index - 1]);
            min_index--;
            k--;
            if (k <= 0) {
                break;
            }
        }

        
        result.push_back(s[i]);
    }

    
    return std::string(result.begin(), result.end());
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        std::string s;
        int k;
        std::cin >> s >> k;

        std::string result = m(s, k);
        std::cout << result << std::endl;
    }

    return 0;
}