def factorial(n, mod):
    result = 1
    for i in range(2, n + 1):
        result = (result * i) % mod
    return result
def power_mod(a, b, mod):
    result = 1
    while b > 0:
        if b % 2 == 1:
            result = (result * a) % mod
        a = (a * a) % mod
        b //= 2
    return result
def arrangements(r, g, b):
    MOD = 998244353
    counts = sorted([r, g, b])
    r, g, b = counts[2], counts[1], counts[0]
    if r > g + b + 1:
        return 0
    total_places = g + b + 1
    fact = [1] * (total_places + 1)
    for i in range(2, total_places + 1):
        fact[i] = (fact[i - 1] * i) % MOD
    result = (fact[total_places] * power_mod(fact[g], MOD - 2, MOD)) % MOD
    result = (result * power_mod(fact[b], MOD - 2, MOD)) % MOD
    return result
r, g, b = map(int, input().split())
print(arrangements(r, g, b))
