#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

#define int long long

const int N = 1e5 + 7;
const int D = 10;

string s;
int n, k;
vector<int> p[D];
int ptr[D];
int delta[D];
int ptr2[D][D];

void clear_all() {
  s.clear();
  for (int d = 0; d < D; ++d) {
    p[d].clear();
    ptr[d] = 0;
    delta[d] = 0;
    fill(ptr2[d], ptr2[d] + D, 0);
  }
}

void run_solve() {
  int t;
  cin >> t;
  while (t--) {
    clear_all();
    cin >> s >> k;
    // s.clear();
    // for (char d = '9'; d >= '1'; --d) {
    //   for (int i = 0; i < 10000; ++i) {
    //     s.push_back(d);
    //   }
    // }
    n = s.size();
    for (int i = 0; i < s.size(); ++i) {
      p[s[i] - '0'].push_back(i);
    }
    string ans;
    for (int i = 0; i < n; ++i) {
      int bd = D;
      for (int d = 0; d < D; ++d) {
        if (ptr[d] != p[d].size() && p[d][ptr[d]] - delta[d] <= k) {
          bd = min(bd, d);
        }
      }
      ans.push_back(bd + '0');
      k -= p[bd][ptr[bd]] - delta[bd];
      for (int d = 0; d < D; ++d) {
        if (ptr[d] < p[d].size() && p[bd][ptr2[d][bd]] < p[d][ptr[d]]) {
          ++delta[d];
          ++ptr2[d][bd];
        }
      }
      ++ptr[bd];
      for (int d = 0; d < D; ++d) {
        while (ptr2[bd][d] < ptr[d] && p[d][ptr2[bd][d]] < p[bd][ptr[bd]]) {
          ++delta[bd];
          ++ptr2[bd][d];
        }
      }
    }
    cout << ans << '\n';
  }
}