﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

bool isCorrect(string s) {

    int mas[5] = { 0, 0, 0, 0, 0 }; // R A C I -
    for (int i = 0; i < s.size(); i++) {
        switch (s[i])
        {
        case 'R':
            mas[0]++;
            break;
        case 'A':
            mas[1]++;
            break;
        case 'C':
            mas[2]++;
            break;
        case 'I':
            mas[3]++;
            break;
        case '-':
            mas[4]++;
            break;
        }
    }
    if (s.size() < 3) { return false; }
    if (mas[1] != 1) { return false; }
    if (!(mas[2] > 0 && mas[3] > 0)) { return false; }
    return true;
}

int main() {
    int n, m;
    cin >> n >> m;
    string cur;
    bool result = true;
    getline(cin, cur);
    for (int i = 0; i < n; i++) {
        getline(cin, cur);
        if (!isCorrect(cur))
            result = false;
    }
    if (result)
        cout << "Yes" << endl;
    else cout << "No" << endl;
}

