numbers = [
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011"  
]
def get_numbers(indicators):
    possible_numbers = []

    for digit, patte in enumerate(numbers):
        can_display = True
        for p, ind in zip(patte, indicators):
            if p == '1' and ind == '0':
                can_display = False
                break
        if can_display:
            possible_numbers.append(digit)

    return possible_numbers


def check(num1, num2):
    return abs(num1 - num2) == 1


def main():
    indi_1 = input().strip()
    indi_2 = input().strip()

    possible_numbers1 = get_numbers(indi_1)
    possible_numbers2 = get_numbers(indi_2)

    for num1 in possible_numbers1:
        for num2 in possible_numbers2:
            if check(num1, num2):
                print(1)
                return

    print(0)


if __name__ == "__main__":
    main()
