#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
using namespace std;
#define int long long
template <class T, class V, class Container> basic_ostream <T, V> & operator << (basic_ostream <T, V> & os, Container const& x) { os << "[ "; for (auto& y : x) os << y << " "; return os << "]"; }
template <class T, class V> ostream & operator << (ostream & os, pair<T, V> const& p) { return os << "{" << p.first << "," << p.second << "}"; }
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) { cerr << " " << H; deb_out(T...); }
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(__VA_ARGS__)
int mod=1000000007;
int nod(int a,int b)
{
    if(a<0){a=-a;}
    if(b<0){b=-b;}
    if(b==0){return a;}
    return nod(b,a%b);
}
int nok(int a,int b)
{
    if(a==0||b==0){return 0;}
    return a/nod(a,b)*b;
}
int Nod(vector<int> a)
{
    if(a.size()==0){return 0;}
    if(a.size()==1){return a[0];}
    vector<int> b;
    vector<int> c;
    int n=a.size();
    for(int i=0;i<n/2;i++)
    {
        b.push_back(a[i]);
    }
    for(int i=n/2;i<n;i++)
    {
        c.push_back(a[i]);
    }
    return nod(Nod(b),Nod(c));
}
int Nok(vector<int> a)
{
    if(a.size()==0){return 1;}
    if(a.size()==1){return a[0];}
    vector<int> b;
    vector<int> c;
    int n=a.size();
    for(int i=0;i<n/2;i++)
    {
        b.push_back(a[i]);
    }
    for(int i=n/2;i<n;i++)
    {
        c.push_back(a[i]);
    }
    return nok(Nok(b),Nok(c));
}
int fastpow(int a,int b)
{
    if(a==0){return 0;}
    if(b==0){return 1;}
    if(b==1){return a;}
    int c=fastpow(a,b/2);
    if(b%2==0)
    {
        return (c*c)%mod;
    }
    return (((c*c)%mod)*a)%mod;
}
int C(int n,int k,vector<int> &fact)
{
    return (fact[n]*fastpow(( (fact[k])*fact[n-k])%mod,mod-2))%mod;
}
int dfs(vector<vector<int> > &son,int x )
{
    for(int i=0;i<son[x].size();i++)
    {
        dfs(son,son[x][i]);
    }
}
vector<pair<int,int> > del(int n)
{
    vector<pair<int,int> > c;
    int h=2;
    int x=1;
    while(n>1)
    {
        while(n%h!=0&&h<=sqrt(n))
        {
            h++;
            x=1;
        }
        if(n%h!=0)
        {
            h=n;
            x=1;
        }
        if(x==0)
        {
            c[c.size()-1].second++;
        }
        else
        {
            pair<int,int> p;
            p.first=h;
            p.second=1;
            c.push_back(p);
            x=0;
        }
        n/=h;
    }
    return c;
}
signed main()
{
    vector<int> a(26);
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        string s;
        cin>>s;
        char b=s[0];
        a[b-'a']=1;
    }
    for(int i=0;i<5;i++){
            for(int j=0;j<6;j++){
                int k=6*i+j;
                if(i==4 && j>1)
                    continue;
                if(a[k]==1){
                    cout<<char('a'+k);
                }
                else{
                    cout<<'.';
                }
            }
            cout<<"\n";
    }
}
