#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
using namespace std;
#define int long long
template <class T, class V, class Container> basic_ostream <T, V> & operator << (basic_ostream <T, V> & os, Container const& x) { os << "[ "; for (auto& y : x) os << y << " "; return os << "]"; }
template <class T, class V> ostream & operator << (ostream & os, pair<T, V> const& p) { return os << "{" << p.first << "," << p.second << "}"; }
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) { cerr << " " << H; deb_out(T...); }
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(VA_ARGS)
int mod=1000000007;
int nod(int a,int b)
{
    if(a<0){a=-a;}
    if(b<0){b=-b;}
    if(b==0){return a;}
    return nod(b,a%b);
}
int nok(int a,int b)
{
    if(a==0||b==0){return 0;}
    return a/nod(a,b)*b;
}
int Nod(vector<int> a)
{
    if(a.size()==0){return 0;}
    if(a.size()==1){return a[0];}
    vector<int> b;
    vector<int> c;
    int n=a.size();
    for(int i=0;i<n/2;i++)
    {
        b.push_back(a[i]);
    }
    for(int i=n/2;i<n;i++)
    {
        c.push_back(a[i]);
    }
    return nod(Nod(b),Nod(c));
}
int Nok(vector<int> a)
{
    if(a.size()==0){return 1;}
    if(a.size()==1){return a[0];}
    vector<int> b;
    vector<int> c;
    int n=a.size();
    for(int i=0;i<n/2;i++)
    {
        b.push_back(a[i]);
    }
    for(int i=n/2;i<n;i++)
    {
        c.push_back(a[i]);
    }
    return nok(Nok(b),Nok(c));
}
int fastpow(int a,int b)
{
    if(a==0){return 0;}
    if(b==0){return 1;}
    if(b==1){return a;}
    int c=fastpow(a,b/2);
    if(b%2==0)
    {
        return (c*c)%mod;
    }
    return (((c*c)%mod)*a)%mod;
}
int C(int n,int k,vector<int> &fact)
{
    return (fact[n]*fastpow(( (fact[k])*fact[n-k])%mod,mod-2))%mod;
}
int dfs(vector<vector<int> > &son,int x )
{
    for(int i=0;i<son[x].size();i++)
    {
        dfs(son,son[x][i]);
    }
}
vector<pair<int,int> > del(int n)
{
    vector<pair<int,int> > c;
    int h=2;
    int x=1;
    while(n>1)
    {
        while(n%h!=0&&h<=sqrt(n))
        {
            h++;
            x=1;
        }
        if(n%h!=0)
        {
            h=n;
            x=1;
        }
        if(x==0)
        {
            c[c.size()-1].second++;
        }
        else
        {
            pair<int,int> p;
            p.first=h;
            p.second=1;
            c.push_back(p);
            x=0;
        }
        n/=h;
    }
    return c;
}
signed main()
{
    int test;
    cin>>test;
    while(test--){
    string s;
    cin>>s;
    int k;
    cin>>k;
    int n=s.size();
    vector<int> a(n);
    vector<set<int>> digits(10);
    for(int i=0;i<n;i++){
        a[i] = s[i] -'0';
        digits[a[i]].insert(i);
    }
    /*int u, v;
    cin>>u>>v;
    for(int i=1;i<10;i++){
            auto it = digits[i].lower_bound(u);
            int r=n+1;
            if(it!=digits[i].end())
             r=*it;
            if(r>v)
               {
                continue;
               }
            else
            {
                cout<<i<<" "<<r;
                break;
            }
    }*/
    int p1=0;
    int p2=k;
    while(p2>p1 && p1<n-1){
        if(p2>n-1){
            p2=n-1;
        }
        int u=p1;
        int v=p2;
        int cur_dig=-1;
        int cur_pos=-1;
        for(int i=1;i<10;i++){
            auto it = digits[i].lower_bound(u);
            int r=n+1;
            if(it!=digits[i].end())
             r=*it;
            if(r>v)
               {
                continue;
               }
            else
            {
                cur_pos=r;
                cur_dig=i;
                break;
            }
    }
    digits[cur_dig].erase(cur_pos);
    digits[a[p1]].erase(p1);
    digits[cur_dig].insert(p1);
    digits[a[p1]].insert(cur_pos);
    a[cur_pos]=a[p1];
    a[p1]=cur_dig;
    //cout<<cur_pos<<" "<< p1<<endl;
    k-=(cur_pos-p1);
     p1++;
    p2=p1+k;

    }
    for(auto e:a)
        cout<<e;
    cout<<"\n";
    }

}
