#include <bits/stdc++.h>
#include <cstdio>

#define print_lst_1x(lst) for (auto el: lst){cout << el << ' ';} cout << endl;
#define print_lst_2x(lst) for (auto el: lst){for (auto zn: el) {cout << zn << ' ';} cout << '\n';} cout << endl;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef std::vector<int> vi;
typedef std::vector<ll> vll;
typedef std::vector<std::vector<int>> vvi;
typedef std::pair<int, int> pii;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
#define ordered_set tree<int, null_type,less_equal<int>, rb_tree_tag,tree_order_statistics_node_update>

using namespace std;

template <typename Ty>
istream& operator>>(istream& is, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        is >> arr[i];
    }
    return is;
}

template <typename Ty>
istream& operator>>(istream& is, std::pair<Ty, Ty>& arr){
    is >> arr.first>>arr.second;
    return is;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i] << " ";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<std::vector<Ty>>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i]<< "\n";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os,std::pair<Ty,Ty>& arr){
    os << arr.first<<" "<<arr.second;
    return os;
}

//   
/*
int solve_q(){
    int n;
    scanf("%d", &n);
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        printf("%d\n", m);
        fflush(stdout);
        int ans;
        scanf("%d", &ans);
        if (ans == 0) {
            return 0;
        }
        if (ans == 1)
            l = m;
        else r = m;
    }
    return 0;
}
 */

//#include "solve_func.hpp"




void solve_gg() {
    int n; cin >> n;
    vi a(n); cin >> a;
    for (int i = 0; i < n; ++i) {
        if (a[i] % 2) {
            cout << "Alice";
            return;
        }
    }
    cout << "Dmitry";
}


string stress_hh(string& num, ll k) {
    vector<int> a;
    for (auto c : num) {
        a.push_back(c - '0');
    }
    int n = (int)a.size();
    while (k > 0) {
        bool found = false;
        for (int i = 0; i + 1 < n; ++i) {
            if (a[i] > a[i + 1]) {
                swap(a[i], a[i + 1]);
                k--;
                found = true;
                break;
            }
        }
        if (!found) break;
    }
    string ans;
    for (auto el : a)
        ans += to_string(el);
    return ans;
}

void solve_hh(/*string& num, ll k*/) {
    string num; cin >> num;
    vector<int> a;
    for (auto c : num) {
        a.push_back(c - '0');
    }
    ll k; cin >> k;

    if (k == 0 || (int)num.size() == 0) {
        cout << num << '\n';
        return;
        //return num;
    }

    ordered_set st;
    int n = (int)a.size();
    st.insert(a[0]);
    int indexlast = n;
    int last = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= *st.find_by_order((int)st.size() - 1))
            st.insert(a[i]);
        else {
            int cnthod = (int)st.size() - (int)st.order_of_key(a[i] + 1);
            if (k >= cnthod) {
                k -= cnthod;
                st.insert(a[i]);
            } else {
                indexlast = i - k;
                last = a[i];
                break;
            }
        }
    }
    string ans;
    for (int i = 0; i < indexlast; ++i)
        ans += to_string(*st.find_by_order(i));
    if (indexlast < n) {
        ans += to_string(last);
        for (int i = indexlast; i < (int)st.size(); ++i)
            ans += to_string(*st.find_by_order(i));
        for (int i = (int)st.size() + 1; i < n; ++i)
            ans += to_string(a[i]);
    }
    cout << ans << '\n';
    //return ans;
}

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve_ii(){
    ll my = 0;
    ll lust;
    ll n;
    cin>>n;
    vll a(n); cin>>a;
    ll i1,j1; cin>>i1>>j1;i1--; j1--;
    ll i = min(i1,j1), j = max(i1, j1);
    bool rev = (i != i1);
    lust = i;
    vector<string> ans;
    for(int k = i; k <= j; k ++){
        if(my == 1){
            cout<<"Impossible\n";return;
        }
        if(my == 0){
            if(k + 1 <n)
            my = abs(a[k] - a[k+1]);
            if (j == k){
                if(!rev)
                    ans.push_back("Kaban-" + to_string((my == 0 ? 2 : my))+ " "+ to_string(lust + 1) +" " + to_string(j + 1));
                else
                    ans.push_back("Kaban-" + to_string((my == 0 ? 2 : my))+ " "+ to_string(j + 1) +" " + to_string(lust + 1));
            }
        }
        else{
            ll temp = my;
            if(abs(a[k] - a[k+1]) != 0)
                my = gcd(my, abs(a[k] - a[k+1]));
            if(my == 1){
                if(!rev)
                    ans.push_back("Kaban-" + to_string(temp)+ " "+ to_string(lust + 1) +" " + to_string(k + 1));
                else
                    ans.push_back("Kaban-" + to_string(temp)+ " "+ to_string(k + 1) +" " + to_string(lust + 1));
                if (k + 1 < n)
                    my = abs(a[k] - a[k+1]);
                lust = k ;
            }
            else if (j == k){
                if(!rev)
                    ans.push_back("Kaban-" + to_string((my == 0 ? 2 : my))+ " "+ to_string(lust + 1) +" " + to_string(j + 1));
                else
                    ans.push_back("Kaban-" + to_string((my == 0 ? 2 : my))+ " "+ to_string(j + 1) +" " + to_string(lust + 1));
            }
        }
    }
    if(rev)
        reverse(ans.begin(), ans.end());
    for(auto j: ans) cout<<j<<"\n";
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve_ii();
    }
    /*
    for (int l = 10; l <= 20; ++l) {
        vector<int> a(l);
        ll k;
        int test = 0;
        while (true) {
            cout << "TEST " << ++test << '\n';
            for (int i = 0; i < l; ++i)
                a[i] = (rand() % 9 + 1);
            k = rand() % 100;
            string num;
            for (auto el : a)
                num += to_string(el);

            cout << num << ' ' << k << '\n';

            string res1 = solve_hh(num, k);
            string res2 = stress_hh(num, k);

            if (res1 != res2) {
                cout << "WRONG ANSWER\n";
                cout << num << ' ' << k << '\n';
                cout << "STRESS " << res2 << '\n';
                cout << "MYSOLU " << res1 << '\n';
                exit(0);
            }
        }

    }
     */
    return 0;
}