#include <bits/stdc++.h>
#include <cstdio>

#define print_lst_1x(lst) for (auto el: lst){cout << el << ' ';} cout << endl;
#define print_lst_2x(lst) for (auto el: lst){for (auto zn: el) {cout << zn << ' ';} cout << '\n';} cout << endl;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef std::vector<int> vi;
typedef std::vector<ll> vll;
typedef std::vector<std::vector<int>> vvi;
typedef std::pair<int, int> pii;


using namespace std;

template <typename Ty>
istream& operator>>(istream& is, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        is >> arr[i];
    }
    return is;
}

template <typename Ty>
istream& operator>>(istream& is, std::pair<Ty, Ty>& arr){
    is >> arr.first>>arr.second;
    return is;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i] << " ";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<std::vector<Ty>>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i]<< "\n";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os,std::pair<Ty,Ty>& arr){
        os << arr.first<<" "<<arr.second;
    return os;
}

//   
/*
int solve_q(){
    int n;
    scanf("%d", &n);
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        printf("%d\n", m);
        fflush(stdout);
        int ans;
        scanf("%d", &ans);
        if (ans == 0) {
            return 0;
        }
        if (ans == 1)
            l = m;
        else r = m;
    }
    return 0;
}
 */

//#include "solve_func.hpp"




void solve_gg() {
    int n; cin >> n;
    vi a(n); cin >> a;
    for (int i = 0; i < n; ++i) {
        if (a[i] % 2) {
            cout << "Alice";
            return;
        }
    }
    cout << "Dmitry";
}




vector<vector<pair<ll,ll>>> node;
priority_queue<vector<ll>> qu;
int vis = 0;
void procces(int u)
{
    vis |= (1 << u);
    for (auto i : node[u])
    {
        if (i.first == 0) continue;
        if ((vis & (1 << i.second)) == 0)
        {
            qu.push({-i.first,i.second, u});
        }
    }
}


void solve_k() {
    ll n;
    cin >> n;
    node.resize(n);
    for (int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j ++) {
            ll a;
            cin >> a;
            //if (i == j) continue;
            node[i].push_back({a,j});
        }
    }
    bool yes = true;
    vi pr{0};
    procces(0);
    while (!qu.empty())
    {
        auto v = qu.top(); qu.pop();
        if ((vis & (1 << v[1])) == 0)
        {
            for (auto u : pr){
                if(node[u][v[1]].first != -v[0] + node[u][v[2]].first){
                    yes = false;
                    break;
                }
            }
            procces(v[1]);
        }
    }
    cout << (yes ? "Yes" : "No");

}
int main(){
    solve_k();
    return 0;
}