#include <iostream>
#include <iomanip>
#include <string>
#include <vector>

struct Point {
	int x;
	int y;
	bool isUsed;

	Point(int x = 0, int y = 0, bool isUsed = false) : x(x), y(y), isUsed(isUsed) {}

};

int main() {
	
	int n;
	std::cin >> n;

	std::vector<Point> mas;

	Point x_min{ 1001 ,0,false };
	Point x_max{ -1001,0,false };
	Point y_max{ 0, 0,false };

	if (n < 3) {
		std::cout << 0;
		return 0;
	}

	for (int i = 0; i < n; i++) {
		Point tmp;

		std::cin >> tmp.x >> tmp.y;

		if (tmp.y == 0) {

			if (tmp.x < x_min.x) {	
				x_min = tmp;
				x_min.isUsed = true;

			}
			
			if (tmp.x > x_max.x) {
				x_max = tmp;
				x_max.isUsed = true;
			}


		}
		else if (std::abs(tmp.y) > std::abs(y_max.y)) {
			y_max = tmp;
			y_max.isUsed = true;
		}
	}

	
	if (!x_max.isUsed || !x_min.isUsed || ( x_min.x == x_max.x )) {
		std::cout << 0;
		return 0;
	}

	//double ans = (double)std::abs(y_max.x * (x_min.y - x_max.y) + x_min.x * (x_max.y - y_max.y) + x_max.x * (y_max.y - x_min.y)) / 2;
	double ans = (double)std::abs((y_max.x - x_max.x)*(x_min.y-x_max.y) - (x_min.x-x_max.x)*(y_max.y-x_max.y)) / 2;
	std::cout << ans;
	return 0;

}



