///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

deque<pii> pos[10];

void solve() {
    string s;
    int k;
    cin >> s >> k;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
    	pos[s[i] - '0'].push_back(make_pair(i, 0));
    }
    for (int i = 0; i < n; ++i) {
    	int best = 10;
    	for (int x = 1; x <= 9; ++x) {
    		if (pos[x].empty()) continue;
    		pii state = pos[x].front();
    		int actualPos = state.first + state.second;
    		if (actualPos - i <= k) {
    			best = min(best, x);
    		}
    	}
    	assert(best != 10);

    	cout << best;

    	pii state = pos[best].front();
    	int startPos = state.first, shift = state.second;
    	int actualPos = startPos + shift;
    	k -= (actualPos - i);

    	pos[best].pop_front();
    	if (!pos[best].empty()) {
    		pos[best].front().second += shift;
    	}
    	
    	for (int x = 1; x <= 9; ++x) {
    		if (pos[x].empty()) continue;
    		if (pos[x].front().first > startPos) continue;

    		int lef = -1, rig = pos[x].size();
    		while (lef + 1 < rig) {
    			int mid = (lef + rig) / 2;
    			if (pos[x][mid].first < startPos) lef = mid;
    			else rig = mid;
    		}

    		pos[x].front().second++;
    		if (rig != (int)pos[x].size()) {
    			pos[x][rig].second--;
    		}
    	}
    }
    cout << "\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        