///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

const int MAX_N = 2e5 + 5;
const int LOG = 18;

int n;
int a[MAX_N];
int b[MAX_N];

int sp[LOG][MAX_N];
int lenfor[MAX_N];

int get_gcd(int l, int r) {
	int len = lenfor[r - l + 1];
	return __gcd(sp[len][l], sp[len][r - (1 << len) + 1]);
}


int get_rig(int i) {
	int lef = i - 1, rig = n;
	while (lef + 1 < rig) {
		int mid = (lef + rig) / 2, g = get_gcd(i, mid);
		if (g > 1 || g == 0) lef = mid;
		else rig = mid;
	}
	return lef;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
    	cin >> a[i];
    }
    for (int i = 1; i <= n - 1; ++i) {
    	b[i] = abs(a[i + 1] - a[i]);
    }
    for (int i = 2; i < MAX_N; ++i) {
    	lenfor[i] = lenfor[i >> 1] + 1;
    }
    for (int j = 0; j < LOG; ++j) {
    	for (int i = 1; i + (1 << j) - 1 <= n - 1; ++i) {
    		if (j == 0) sp[j][i] = b[i];
    		else sp[j][i] = __gcd(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
    	}
    }
    int s, f;
    cin >> s >> f;
	vector<vector<int>> ans;
	bool rev = false;
	if (s > f) {
		swap(s, f);
		rev = true;
	}
	while (s < f) {
		int t = get_rig(s) + 1;
		t = min(t, f);
		if (s == t) {
			cout << "Impossible\n";
			return;
		}
		ans.push_back({get_gcd(s, t - 1), s, t});
		s = t;
	}
	if (rev) reverse(all(ans));
    for (auto &v : ans) {
    	if (rev) swap(v[1], v[2]);
    	v[0] = max(v[0], 2);
    	cout << "Kaban-" << v[0] << " " << v[1] << " " << v[2] << "\n";
    }
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        