///bs:-input,console
#include <bits/stdc++.h>
#include <cstdio>
#include <cstdlib>
#include <ext/pb_ds/assoc_container.hpp>
#include <string>
#include <unordered_map>
#include <vector>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

struct Edge {
	int target;
	ll cost;
};

struct Node {
	int x;
	vector<Edge> children;
};

//void dfs(int x, unordered_map<int, Node> &graph, uno)

void solve() {
    int k = 0;

    string buf;
    getline(cin, buf);
    int n = atoi(buf.data() + 20);
    // cerr << "n = " << n << endl;
    vector<pair<int, Edge>> edges;
    int min_x = n;
    while (true) {
    	getline(cin, buf);
    	if (buf.size() < 14) break;

    	int x, y;
    	sscanf(buf.data(), " if (i == %d) i = %d;", &x, &y);

    	auto e = Edge{y, 1};
    	edges.emplace_back(x, e);

    	min_x = min(min_x, x);
    	k++;
    }

    unordered_map<int, int> after;
    unordered_map<int, Edge> go;
    for (int i = k - 1; i >= 0; --i) {
    	auto [x, e] = edges[i];

    	if (go.count(e.target) == 0) {
    		go[x] = Edge{e.target, 1};
    	} else {
			go[x] = Edge{go[e.target].target, go[e.target].cost + 1};
    	}
    }

    vector<int> xx;
    for (auto &p : go) {
    	p.second.target++;
    	p.second.cost += (k + 3);

    	xx.push_back(p.first);
    	xx.push_back(p.second.target);
    }

    if (min_x != 0) {
    	go[0] = Edge{min_x, 1ll * min_x * (k + 3)};
    }

    xx.push_back(0);
    xx.push_back(n);

    sort(all(xx));
    xx.resize(unique(all(xx)) - xx.begin());
    for (int i = 0; i + 1 < sz(xx); ++i) {
    	int a = xx[i];
    	if (go.count(a) == 0) {
    		int b = xx[i + 1];
    		go[a] = Edge{b, 1ll * (b - a) * (k + 3)};
    	}
    	// cerr << a _ go[a].target _ go[a].cost << '\n';
    }

    int x = 0;
    unordered_set<int> used;
    ll ans = 0;
    while (x != n) {
    	if (used.count(x) != 0) {
    		cout << "-1\n";
    		return;
    	}

    	used.insert(x);
    	ans += go[x].cost;
    	x = go[x].target;
    }
    cout << ans + 2 << "\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        