
#include <bits/stdc++.h>

// #define FSTREAM
#define MULTITEST

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    string s;
    int k = 0;
    cin >> s >> k;
    // cout << s << ' ' << k << endl;
    vector<pair<int, size_t>> offset(10, {-1, 0});
    set<size_t> positions;
    for (size_t digit = 1; digit < 10; ++digit) {
        for (size_t i = 0; i < s.size(); ++i) {
            if ((s[i] - '1') + 1 == digit) {
                offset[digit] = {i, i};
                break;
            }
        }
    }
    string ans = "";
    for (size_t i = 0; i < s.size(); ++i) {
        // printf("------------ Iteration: %d ----------------\n", i);
        // for (size_t digit = 1; digit < 10; ++digit) {
        //     printf("Digit: %d, offset: %d, position: %d\n", digit, offset[digit].first, offset[digit].second);
        // }
        size_t current_digit = 0;
        for (size_t digit = 1; digit < 10; ++digit) {
            if (offset[digit].first == 0) {
                current_digit = digit;
                break;
            }
        }
        // printf("Current digit: %d\n", current_digit);
        size_t selected_digit = current_digit;
        for (size_t digit = 1; digit < current_digit; ++digit) {
            if (offset[digit].first == -1) {
                continue;
            }
            if (offset[digit].first <= k) {
                selected_digit = digit;
                k -= offset[digit].first;
                break;
            }
        }
        ans += char(selected_digit - 1 + '1');
        size_t prev_offset = offset[selected_digit].first;
        offset[selected_digit].first = -1;
        size_t selected_position = offset[selected_digit].second;
        positions.insert(selected_position);
        for (size_t j = offset[selected_digit].second + 1; j < s.size(); ++j) {
            if ((s[j] - '1') + 1 == selected_digit) {
                size_t extra = distance(positions.lower_bound(j + 1), positions.end());
                offset[selected_digit] = {j + extra - i - 1, j};
                break;
            }
        }
        for (size_t digit = 1; digit < 10; ++digit) {
            if (offset[digit].first == -1 || digit == selected_digit) {
                continue;
            }
            if (digit == current_digit && selected_digit != current_digit) {
                continue;
            }
            if (selected_position < offset[digit].second) {
                offset[digit].first--;
            }
        }
        // cout << ans << endl;
    }
    cout << ans << endl;
}

signed main() {
#ifdef FSTREAM
    freopen("input.txt", "r", stdin);
#endif
    size_t t = 1;
#ifdef MULTITEST
    cin >> t;
#endif
    for (size_t i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}