

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


void solve() {
    string _, n_str;
    cin 
        >> _ /*for*/ 
        >> _ /*(int*/ 
        >> _ /*i*/ 
        >> _ /*=*/ 
        >> _ /*0;*/
        >> _ // i
        >> _ // <
        >> n_str // d
        >> _ // i++)
        >> _ // {
        ;
    getline(cin, _);
    int n = atoi(n_str.substr(0, n_str.size() - 1).c_str());

    vector<int> x, y;
    while (true) {
        string line;
        getline(cin, line);
        if (line[0] == '}') {
            break;
        }
        stringstream ss(line);
        string x_str, y_str;
        ss
        >> _; // if??
        if (_ == "work")
            break;
        ss
        >> _ // (i
        >> _ // ==
        >> x_str // x)
        >> _ // i 
        >> _ // =
        >> y_str // y;
        ;

        x.push_back(atoi(x_str.substr(0, x_str.size() - 1).c_str()));
        y.push_back(atoi(y_str.substr(0, y_str.size() - 1).c_str()));
    }
    
    unordered_map<int, int> to;
    unordered_map<int, int> moves;
    auto get = [&to](int from) {
        if (to.find(from) == to.end())
            return from;
        else return to[from];
    };
    auto get_moves = [&moves](int from) {
        if (moves.find(from) == moves.end())
            return 0;
        else return moves[from];
    };

    for (int i = (int)(x.size()) - 1; i >= 0; i--) {
        to[x[i]] = get(y[i]);
        moves[x[i]] = 1 + get_moves(y[i]);
    }

    vector<int> jumps = x;
    sort(all(jumps));
    vector<int> jump_used(x.size(), 0);
    
    ll ops = 1;
    int i = 0;
    while (true) {
        ops++;
        if (i >= n) break;

        int next_jump_index = lower_bound(all(jumps), i) - jumps.begin();
        if (next_jump_index == jumps.size()) {
            ll iters = n - i;
            ll ops_on_iter =
                jumps.size() // i == x_l
            + 1 // work
            + 1 // i++
            + 1 // i < n
            ;
            
            ops += iters * ops_on_iter;
            break;
        }
        if (jump_used[next_jump_index]) {
            cout << -1;
            return;
        }
        jump_used[next_jump_index] = 1;
        
        ll iters = jumps[next_jump_index] - i;
        ll ops_on_iter =
            jumps.size() // i == x_l
          + 1 // work
          + 1 // i++
          + 1 // i < n
          ;
        
        ops += iters * ops_on_iter;

        ops += jumps.size() + get_moves(jumps[next_jump_index]);
        i = to[jumps[next_jump_index]];

        ops++; // work

        ops++;
        i++;
    }

    cout << ops << endl;
}
