#include <iostream>
#include <vector>

[[maybe_unused]] static auto _ = []() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  return nullptr;
}();

void minNum(std::string& s, unsigned int k) {
    for (int i=0; i<s.length(); i++) {
        if (k==0) {
            break;
        }
        
        char minN = s[i];
        unsigned int minI = i;
        
        unsigned int dist = (s.length() < i+k+1) ? s.length() : i+k+1;
        
        for (int j=i+1; j<dist; j++) {
            if (s[j] < minN) {
                minN = s[j];
                minI = j;
            }
        }
        
        if (minI != i) {
            unsigned int currMoves = minI - i;
            if (currMoves <= k) {
                for (int j=minI; j>i; j--) {
                    s[j] = s[j-1];
                }
                s[i] = minN;
                k -= currMoves;
            }
        }
    }
}

int main() {
	int n;
	std::cin >> n;
	for (int i=0; i<n; i++) {
		unsigned int k;
	
		std::string s;
		std::cin >> s;
		std::cin >> k;
		
		minNum(s, k);
		
    	std::cout << s << std::endl;
	}
	return 0;
}