#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>


#define int long long


using namespace std;


int32_t main () {
    int n;
    cin >> n;
    vector<vector<int>> v(n, vector<int>(n));
    vector<vector<int>> d(n, vector<int>(n, -1));
    vector<pair<int, pair<int, int>>> edges;
    int m = n * (n-1)/2;
    for (int i = 0; i< n; ++i) {
        for (int j = 0 ; j < n; ++j) {
            cin >> v[i][j];
            if(i > j){
                edges.push_back({v[i][j], {j, i}});
            }
        }
    }
    sort(edges.begin(), edges.end());
    // for(int i = 0; i < m; i++){
    //     cout << edges[i].first << " " << edges[i].second.first << " " << edges[i].second.second << ' ';
    // }

    for(int i = 0; i < m; ++i){
        pair<int, pair<int, int>> a = edges[i];
        int first = a.second.first;
        int second = a.second.second;

        if(d[first][second] == -1){
            d[first][second] = a.first;
            d[second][first] = a.first;
            for(int j = 0; j < n; ++j){
                if(d[first][j] != -1 && first != j && second != j){
                    d[second][j] = d[first][j] + a.first;
                    d[j][second] = d[first][j] + a.first;
                }
                if(d[second][j] != -1 && first != j && second != j){
                    d[first][j] = d[second][j] + a.first;
                    d[j][first] = d[second][j] + a.first;
                }
            }

        }
        else{
            if(d[first][second] != a.first){
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes";

    return 0;
}