#include <iostream>
#include <string>
#include <algorithm>

using namespace std;


int find_ordinal_depth(const string& s, int start, int end) {
    if (start + 1 == end) {
        return 0;
    }

    int depth = 0;
    int balance = 0;
    int element_start = start + 1; 

    for (int i = start + 1; i < end; ++i) {
        if (s[i] == '{') {
            balance++;
        }
        else if (s[i] == '}') {
            balance--;
        }

        if (balance == 0 && (s[i] == '}' || s[i + 1] == ',' || i + 1 == end)) {
            depth = max(depth, find_ordinal_depth(s, element_start, i + 1));
            element_start = i + 2; 
        }
    }

    return depth;
}

int main() {
    string ordinal_string;
    cin >> ordinal_string;

    int n = find_ordinal_depth(ordinal_string, 0, ordinal_string.size());
    cout << n << '\n';

    return 0;
}
