#include <bits/stdc++.h>
    

using   std::cin, std::cout, std::sqrt, std::exp, std::sin, std::cos, std::pow, std::endl, std::flush,
        std::vector, std::set, std::map, std::unordered_set, std::unordered_map, std::pair, std::string,
        std::sort, std::unique, std::find, std::count, std::lower_bound, std::upper_bound, std::memcpy, std::memset;

template<typename T>
std::istream& operator>>(std::istream& is, vector<T>& vec)
{
    for (T& elem : vec)
        is >> elem;
    return is;
}

template<typename T>
std::ostream& operator<<(std::ostream& os, const vector<T>& vec)
{
    for (const T& elem : vec)
	    os << elem << ' ';
    return os;
}

template<typename T>
const T& max(const T& arg1, const T& arg2)
{
    if (arg1 > arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& max(const T& arg1, const T& arg2, Args... args)
{
    return max(max(arg1, arg2), args...);
}

template<typename T>
const T& min(const T& arg1, const T& arg2)
{
    if (arg1 < arg2)
        return arg1;
    return arg2;
}

template<typename T, typename... Args>
const T& min(const T& arg1, const T& arg2, Args... args)
{
    return min(min(arg1, arg2), args...);
}


namespace std
{
    template<typename T1, typename T2>
    struct hash<std::pair<T1,T2>>
    {
        size_t operator()(const std::pair<T1,T2>& pr) const
        {
            std::hash<T1> h1;
            std::hash<T2> h2;
            return h1(pr.first) ^ h2(pr.second);
        }
    };
}

using pii = pair<int,int>;
using pll = pair<long long, long long>;
using pdd = pair<double, double>;
int main()
{
    std::ios::sync_with_stdio(0);
    cin.tie(0);
    
    vector<string> s(2);
    cin >> s;

    auto digit = [](int d) -> vector<bool>
    {
        vector<bool> res(7, true);
        switch (d)
        {
            case 0:
                res[3] = 0;
                return res;
            case 1:
                return {0,0,1,0,0,1,0};
            case 2:
                res[1] = 0;
                res[5] = 0;
                return res;
            case 3:
                res[1] = 0;
                res[4] = 0;
                return res;
            case 4:
                res[0] = 0;
                res[4] = 0;
                res[6] = 0;
                return res;
            case 5:
                res[2] = 0;
                res[4] = 0;
                return res;
            case 6:
                res[2] = 0;
                return res;
            case 7:
                return {1,0,1,0,0,1,0};
            case 8:
                return res;
            case 9:
                res[4] = 0;
                return res;
            case -1:
                return vector<bool>(7,0);
        }
    };
    auto f1 = [&](int x) -> vector<vector<bool>>
    {
        vector<vector<bool>> res(2);
        if (x < 10)
            res = {digit(-1), digit(x)};
        else
            res = {digit(x/10), digit(x%10)};

        return res;
    };

    auto f2 = [&](int x) -> vector<vector<bool>>
    {
        auto res = f1(x);
        for (int i = 0; i < 2; i++)
            for (int j = 0; j < 7; j++)
                if (s[i][j] == '0')
                    res[i][j] = 0;
        return res;
    };

    int mx = 0;
    for (int y = 0; y < 100; y++)
    {
        for (int x = 0; x < 100; x++)
        {
            for (int k = 0; y - k > 0 && x + k < 100; k++)
            {
                if (f1(x+k) != f2(y-k))
                {
                    mx = max(mx, k-1);
                    break;
                }
            }
        }
    }

    auto print = [&](int d)
    {
        vector<string> ss(5, string(3, ' '));
        auto res = digit(d);
        cout << ' ' << (res[0] ? '-' : ' ') << " \n";
        cout << (res[1] ? '|' : ' ') << ' ' << (res[2] ? '|' : ' ') << '\n';
        cout << ' ' << (res[3] ? '-' : ' ') << " \n";
        cout << (res[4] ? '|' : ' ') << ' ' << (res[5] ? '|' : ' ') << '\n';
        cout << ' ' << (res[6] ? '-' : ' ') << " \n";
    };
    // for (int d = 0; d < 10; d++)
    // {
    //     cout << d << '\n';
    //     print(d);
    // }
    cout << mx << '\n';
    return 0;
}
