#include<bits/stdc++.h>

#define all(x) x.begin(), x.end()

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;


void solve() {
    ll n; cin >> n;
        vector<vector<pair<ll, ll>>> g(n);
        for(int i = 0; i < n; ++i){
            for (int j = 0; j < n; ++j){
                ll x; cin >> x;
                g[i].push_back({x, j});
                g[j].push_back({x, i});
            }
        }
        vector<ll> d(n, 1e18);
        set<pair<ll, ll>> q;
        d[0LL] = 0LL;
        q.insert({0LL, 0LL});
        while(!q.empty()){
            auto it = begin(q);
            ll v = it->S;
            q.erase(it);
            for(auto e: g[v]){
                ll i = e.S, len = e.F;
                if (d[i] > d[v] + len){
                    q.erase({d[i], i});
                    d[i] = d[v] + len;
                    q.insert({d[i], i});
                }
            }
        }
        
        for (auto v : g[0])
        {
            if (v.first != d[v.second])
            {
                cout << "No";
                return;
            }
        }
        cout << "Yes";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
