#include "iostream"
#include "deque"
using namespace std;

int main(){
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--){
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        vector<deque<int>> pos_digit(10);
        for(int i = 0; i < n; ++i){
            int digit = s[i] - '0';
            pos_digit[digit].push_back(i);
        }

        int current = 0;
        while(current < n && k > 0){
            for(int d = 1; d <= 9; ++d){
                if(pos_digit[d].empty()) continue;

                int pos = pos_digit[d].front();

                if(pos < current){
                    pos_digit[d].pop_front();
                    continue;
                }

                long long cost = pos - current;
                if(cost > k){
                    continue;
                }

                pos_digit[d].pop_front();

                char min_char = s[pos];
                for(int i = pos; i > current; --i){
                    s[i] = s[i-1];

                    int moved_digit = s[i] - '0';
                    if(moved_digit != d){
                        auto &dq = pos_digit[moved_digit];
                        for(auto it = dq.begin(); it != dq.end(); ++it){
                            if(*it == i-1){
                                *it = i;
                                break;
                            }
                        }
                    }
                }
                s[current] = min_char;
                k -= cost;
                break;
            }
            current++;
        }

        cout << s << "\n";
    }
}