#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        vector<vector<int>> next(10, vector<int>(n + 1, n));

        for (int d = 0; d < 10; ++d)
            next[d][n] = n;

        for (int i = n - 1; i >= 0; --i) {
            int digit = s[i] - '0';
            for (int d = 0; d < 10; ++d) {
                if (digit == d)
                    next[d][i] = i;
                else
                    next[d][i] = next[d][i + 1];
            }
        }

        for (int i = 0; i < n && k > 0; ++i) {
            int max_pos = min(n - 1, i + (int)k);
            bool found = false;
            for (int d = 1; d <= 9; ++d) {
                int pos = next[d][i];
                if (pos > max_pos)
                    continue;
                if (pos != i) {
                    char min_char = s[pos];
                    for (int j = pos; j > i; --j) {
                        s[j] = s[j - 1];
                    }
                    s[i] = min_char;
                    k -= pos - i;
                }
                found = true;
                break;
            }
            if (!found)
                continue;
        }

        cout << s << '\n';
    }
    return 0;
}