#include <iostream>
#include <vector>

using namespace std;

int n;
vector<vector<long long>> d;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    cin >> n;
    d.resize(n, vector<long long>(n));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> d[i][j];

    for (int i = 0; i < n; ++i) {
        if (d[i][i] != 0) {
            cout << "No";
            return 0;
        }
        for (int j = i + 1; j < n; ++j) {
            if (d[i][j] != d[j][i] || d[i][j] <= 0) {
                cout << "No";
                return 0;
            }
        }
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            for (int k = 0; k < n; ++k) {
                if (i == j || j == k || i == k) continue;
                if (d[i][j] + d[j][k] - d[i][k] < 0) {
                    cout << "No";
                    return 0;
                }
            }

    cout << "Yes";
    return 0;
}