import java.util.*
import kotlin.math.abs

fun main() {
    val all = ArrayList<Pair<Int, Int>>()
    val ox = TreeSet<Pair<Int, Int>>(Comparator.comparingInt { it.first })
    val n = readln().toInt()
    repeat(n) {
        val (x, y) = readln().split(" ").map { it.toInt() }
        if (y == 0) {
            ox.add(Pair(x, y))
        }
        all.add(Pair(x, y))
    }

    var max = 0.0
    val minOx = ox.first()
    val maxOx = ox.last()
    for (p in all) {
        max = maxOf(max, square(maxOx, minOx, p))
    }
    println(max)
}

fun square(a: Pair<Int, Int>, b: Pair<Int, Int>, c: Pair<Int, Int>): Double {
    val x1 = a.first
    val x2 = b.first
    val x3 = c.first
    val y1 = a.second
    val y2 = b.second
    val y3 = c.second
    if (a == b || b == c || c == a) return 0.0
    val squareFin = 0.5 * abs((x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1))
    return squareFin
}