#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>
#include <list>
using namespace std;

inline int min(int a, int b) {
	return a < b ? a : b;
}

string f2(string s, int k) {
	string res = "";
	multiset<char> st;
	for (int i = 0; i < s.length() && i <= k; ++i) {
		st.insert(s[i]);
	}
	list<pair<char, int>> lst1;
	list<pair<char, int>> lst2;
	for (int i = 0; i < s.length() && i <= k; ++i) {
		lst1.push_back(make_pair(s[i], i));
	}
	for (int i = 0; i < s.length(); ++i) {
		lst2.push_back(make_pair(s[i], i));
	}
	auto nxt = next(lst2.begin(), min(k + 1, (int)s.length()));
	int i = 0;
	while (!st.empty() && k > 0) {
		// cout << st.size() << endl;
		char mn = *st.begin();
		st.erase(st.begin());
		res += mn;
		if (mn == lst1.front().first) {
			lst1.pop_front();
			lst2.pop_front();
			if (nxt != lst2.end()) {
				lst1.push_back(*nxt);
				st.insert(nxt->first);
				++nxt;
			}
		}
		else {
			auto it1 = lst1.begin();
			auto it2 = lst2.begin();
			while (it1 != lst1.end()) {
				if (it1->first == mn) {
					k -= it1->second - i;
					lst1.erase(it1);
					lst2.erase(it2);
					break;
				}
				it1->second++;
				it2->second++;
				++it1;
				++it2;
			}
			while (lst1.size() > k + 1) {
				if (lst1.back() == *prev(nxt)) {
					--nxt;
				}
				st.erase(st.lower_bound(lst1.back().first));
				lst1.pop_back();
			}
		}
		++i;
	}
	for (auto& p : lst2) {
		res += p.first;
	}
	return res;
}

string f(string s, int k) {
	string res = "";
	bool phase2 = false;
	for (char dig = '1'; dig <= '9' && k > 0; ++dig) {
		int sub = 0;
		for (int i = 0; i < s.length() && k > 0; ++i) {
			if (dig == s[i]) {
				if (k >= i - sub) {
					k -= i - sub;
					res += dig;
					++sub;
				}
				else {
					phase2 = true;
					int cnt = sub;
					string nw = "";
					for (int j = 0; j < s.length(); ++j) {
						if (dig != s[j]) {
							nw += s[j];
						}
						else if (cnt > 0) {
							--cnt;
						}
						else {
							nw += s[j];
						}
					}
					s = nw;
					break;
				}
			}
		}
		if (phase2) break;
		string nw = "";
		for (int i = 0; i < s.length(); ++i) {
			if (dig != s[i]) {
				nw += s[i];
			}
		}
		s = nw;
	}
	if (!phase2) {
		return res + s;
	}
	else {
		return res + f2(s, k);
	}
}

void solve() {
	string s;
	cin >> s;
	long long k;
	cin >> k;
	if (k >= (long long)s.length() * s.length()) {
		sort(s.begin(), s.end());
		cout << s << '\n';
		return;
	}
	cout << f(s, k) << '\n';
}

int main() {
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	
	return 0;
}