#include <iostream>
#include <vector>

using namespace std;

string is_wooden_matrix(int n, const vector<vector<int>>& matrix) {
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                if ((matrix[i][j] > matrix[i][k] + matrix[j][k] ||
                    matrix[i][k] > matrix[i][j] + matrix[j][k] ||
                    matrix[j][k] > matrix[i][k] + matrix[i][j]) &&
                        (matrix[i][j] != 0) && (matrix[i][k] != 0) && (matrix[j][k] != 0))
                         {
                    return "No";
                }
            }
        }
    }
    return "Yes";
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    string result = is_wooden_matrix(n, matrix);
    cout << result << endl;

    return 0;
}