#include <bits/stdc++.h>

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native" )
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//*/

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define pb push_back

using namespace std;

using ll = int64_t;
using ld = long double;
using pll = pair <ll, ll>;

const ll MOD = 1e9 + 9;
const ll INF = 1e18 + 123;
const ld EPS = 1e-10;

/*
 * mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
 * uniform_int_distribution<int>(0, i)(rng)
 */

void cok(bool pr) {
    if (pr) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace __gnu_pbds;

typedef tree<
string,
null_type,
less<string>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
*/

map <string, ll> indtoll;
map <ll, string> inttoind;

string getind(ll n, string mask) {
    string code = inttoind[n];

    string res;
    for (ll i = 0; i < 7; i++) {
        if (mask[i] == '0') {
            res += '0';
        } else {
            res += code[i];
        }
    }

    return res;
}

string numtoind(ll n, string m1, string m2) {
    if (n < 10) {
        return getind(n, m2);
    } else if (n >= 10) {
        return getind(n / 10, m1) + getind(n % 10, m2);
    }
}

bool validnum(ll n, string m1, string m2) {
    ll pr = 1;

    if (n <= 0) {
        pr = 0;
    } else if (n < 10) {
        if (getind(n, m2) == "1110111" || indtoll[getind(n, m2)] > 0) {
            // ok
        } else {
            pr = 0;
        }
    } else if (n >= 10) {
        string code1 = getind(n / 10, m1);
        string code2 = getind(n % 10, m2);
        if ((code1 == "1110111" || indtoll[code1] > 0) && (code2 == "1110111" || indtoll[code2] > 0)) {
            // ok;
        } else {
            pr = 0;
        }
    }

    return pr;
}

ll indtonum(string n) {
    if (n.size() == 7) {
        return indtoll[n];
    } else {
        string s1, s2;
        for (ll i = 0; i < 7; i++) {
            s1 += n[i];
        }
        for (ll i = 7; i < 14; i++) {
            s2 += n[i];
        }

        return indtoll[s1] * 10 + indtoll[s2];
    }
}

void solve() {
    string rab1, rab2;
    cin >> rab1 >> rab2;

    /*cout << numtoind(39, rab1, rab2) << " " << numtoind(35, rab1, rab2) << endl;
    cout << numtoind(38, rab1, rab2) << " " << numtoind(36, rab1, rab2) << endl;
    cout << validnum(35, rab1, rab2) << ' ' << validnum(36, rab1, rab2) <<
         ' ' << validnum(38, rab1, rab2) << ' ' << validnum(39, rab1, rab2) << endl;*/

    for (ll k = 99; k >= 1; k--) {
        for (ll y = k + 1; y <= 99; y++) {
            // y = x
            // y - 1 = x + 1
            // y - 2 = x + 2
            // y - 3 = x + 3

            ll pr = 1;
            vector <string> q;
            for (ll i = y; i >= y - k; i--) {
                if (!validnum(i, rab1, rab2)) {
                    pr = 0;
                    break;
                }
                q.pb(numtoind(i, rab1, rab2));
            }

            if (pr) {
                vector <ll> nums;
                for (auto i : q) {
                    nums.pb(indtonum(i));
                }

/*
                if (k == 1) {
                    for (auto i : nums) {
                        cout << i << ' ';
                    }
                    cout << endl;
                }*/

                ll pr2 = 1;
                for (ll i = 1; i < nums.size(); i++) {
                    if (nums[i] - nums[i - 1] == 1) {
                        // ok;
                    } else {
                        pr2 = 0;
                    }
                }

                if (pr2) {
                    cout << k << endl;
                    return;
                }
            }
        }
    }

    cout << 0 << endl;
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);


// 1 - 0010010
// 2 - 1011101
// 3 - 1011011
// 4 - 0111010
// 5 - 1101011
// 6 - 1101111
// 7 - 1010010
// 8 - 1111111
// 9 - 1111011
// 0 - 1110111

    inttoind[1] = "0010010";
    inttoind[2] = "1011101";
    inttoind[3] = "1011011";
    inttoind[4] = "0111010";
    inttoind[5] = "1101011";
    inttoind[6] = "1101111";
    inttoind[7] = "1010010";
    inttoind[8] = "1111111";
    inttoind[9] = "1111011";
    inttoind[0] = "1110111";

    indtoll["0010010"] = 1;
    indtoll["1011101"] = 2;
    indtoll["1011011"] = 3;
    indtoll["0111010"] = 4;
    indtoll["1101011"] = 5;
    indtoll["1101111"] = 6;
    indtoll["1010010"] = 7;
    indtoll["1111111"] = 8;
    indtoll["1111011"] = 9;
    indtoll["1110111"] = 0;



    ll t = 1;

    // cin >> t;

    while (t--) {
        solve();

        // cout << '\n';
    }

    return 0;
}