#include <iostream>
#include <vector>

using namespace std;

bool isWoodenMatrix(const vector<vector<int> > &matrix, int n) {
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (k != i && k != j) {
                    if (matrix[i][j] > matrix[i][k] + matrix[k][j]) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int> > matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    if (isWoodenMatrix(matrix, n)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

    return 0;
}
