﻿#include <iostream>
#include <vector>
#include <string>

int main() {
    int n;
    std::cin >> n; // Чтение количества программ

    // Массив для хранения наличия каждой буквы от 'a' до 'z'
    std::vector<bool> letters(26, false);

    // Чтение названий программ и отметка используемых букв
    for (int i = 0; i < n; ++i) {
        std::string program;
        std::cin >> program; // Чтение названия программы
        char first_letter = program[0]; // Получаем первую букву
        letters[first_letter - 'a'] = true; // Отмечаем эту букву
    }

    // Создание таблицы 5 строк и 6 колонок
    char table[5][6];

    // Заполняем таблицу
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 6; ++j) {
            int index = i * 6 + j; // Индекс для буквы (0-25)
            if (index < 26) { // Проверка на буквы a-z
                table[i][j] = letters[index] ? 'a' + index : '.';
            }
            else { // Если индекс >= 26, ставим точку
                table[i][j] = '.';
            }
        }
    }

    // Вывод таблицы
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 6; ++j) {
            std::cout << table[i][j] << ' '; // Печатаем с пробелами
        }
        std::cout << std::endl; // Переходим на новую строку
    }

    return 0;
}