#include <iostream>
#include <vector>
#include <limits>

using namespace std;

string is_wooden_matrix(int n, const vector<vector<int>>& matrix) {
    
    for (int i = 0; i < n; ++i) {
        if (matrix[i][i] != 0) {
            return "No";
        }
        for (int j = 0; j < n; ++j) {
            if (matrix[i][j] != matrix[j][i]) {  
                return "No";
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) {  
                for (int k = 0; k < n; ++k) {
                    if (k != i && k != j) {  
                        if (matrix[i][j] > matrix[i][k] + matrix[k][j]) {
                            return "No";
                        }
                    }
                }
            }
        }
    }

    return "Yes";
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    string result = is_wooden_matrix(n, matrix);
    cout << result << endl;

    return 0;
}