# Ввод количества шаров каждого цвета
num_red, num_green, num_blue = map(int, input("Введите количество красных, зеленых и синих шаров (R G B) через пробел: ").split())

# Проверка условия, что нет цвета, который превышает сумму других
if (num_red > num_green + num_blue + 1) or (num_green > num_red + num_blue + 1) or (num_blue > num_red + num_green + 1):
    print(0)  # Невозможно расположить шары, выводим 0
else:
    # Список для хранения уникальных расстановок
    unique_arrangements = []

    # Рекурсивная функция для генерации расстановок
    def generate_arrangements(arrangement, r, g, b):
        if r == 0 and g == 0 and b == 0:
            unique_arrangements.append(arrangement)
            return
        
        # Добавляем красный шар, если есть
        if r > 0 and (not arrangement or arrangement[-1] != 'R'):
            generate_arrangements(arrangement + 'R', r - 1, g, b)
        
        # Добавляем зеленый шар, если есть
        if g > 0 and (not arrangement or arrangement[-1] != 'G'):
            generate_arrangements(arrangement + 'G', r, g - 1, b)
        
        # Добавляем синий шар, если есть
        if b > 0 and (not arrangement or arrangement[-1] != 'B'):
            generate_arrangements(arrangement + 'B', r, g, b - 1)

    # Запускаем генерацию расстановок
    generate_arrangements("", num_red, num_green, num_blue)

    # Выводим количество уникальных расстановок по модулю 998244353
    MOD = 998244353
    result = len(unique_arrangements) % MOD
    print(result)
