def minimize_number(s, k):
    s = list(s)
    n = len(s)

    for i in range(n):
        if k <= 0:
            break

        min_pos = i
        for j in range(i + 1, min(i + k + 1, n)):
            if s[j] < s[min_pos]:
                min_pos = j

        if min_pos == i:
            continue

        min_digit = s[min_pos]
        for j in range(min_pos, i, -1):
            s[j] = s[j - 1]
        s[i] = min_digit

        k -= (min_pos - i)

    return ''.join(s)

t = int(input().strip())
results = []
for _ in range(t):
    s, k = input().split()
    k = int(k)
    results.append(minimize_number(s, k))

for result in results:
    print(result)
