def minimizing_exchanges(s, max_swaps):
    def swap_cost(i, j):
        return abs(j - i)

    def perform_swap(i, j):
        return s[:min(i, j)] + s[max(i, j)] + s[min(i, j) + 1:max(i, j)] + s[
            min(i, j)] + s[max(i, j) + 1:]

    remaining_swaps = max_swaps

    while remaining_swaps > 0:
        min_value = int(s)
        for i in range(len(s) - 1):
            for j in range(i + 1, len(s)):
                cost = swap_cost(i, j)
                if cost <= remaining_swaps:
                    new_arr_str = perform_swap(i, j)
                    if int(new_arr_str) < min_value:
                        min_value = int(new_arr_str)
                        best_swap = (i, j)
                        best_cost = cost
        if min_value != int(s):
            s = perform_swap(best_swap[0], best_swap[1])
            remaining_swaps -= best_cost
    return s

if __name__ == "__main__":
    t = int(input())
    for _ in range(t):
        s, k = input().split()
        print(minimizing_exchanges(s, int(k)))
