def partioning(a, i, j):
    b = a[::]
    b[i], b[j] = b[j], b[i]
    return b


def permuts(word, k):
    result = []
    for i in range(len(word) - 1):
        result.append(partioning(word, i, i+1))

    if k == 1:
        return result
    else:
        k_result = []
        for r in result:
            k_result.extend(permuts(r, k - 1))
        return k_result


def simple(a: list, k) -> list:
    v = sorted(permuts(a, k))
    return v[0]


n = int(input())
a = []
for _ in range(n):
    xx = input().split()
    s = [int(x) for x in xx[0]]
    k = int(xx[1])
    print("".join(map(str, simple(s, k))))
