#define GLIBCXX_DEBUG

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

void solve() {
    string s;
    cin >> s;
    ll k; cin >> k;
    string ans;
    ll n = s.size();
    ordered_set<pair<ll,ll>> q;
    vector<vector<ll>> dg(10);
    vector<ll> uk(10,0);
    for (int i=0;i<n;++i) {
        dg[s[i]-'0'].push_back(i);
        q.insert({i, s[i]-'0'});
    }
    for (int i=0;i<n;++i) {
        for (int j=1;j<=9;++j) {
            if (dg[j].size()==0 || uk[j] >= dg[j].size())continue;
            auto nd = q.order_of_key({dg[j][uk[j]], j});
            if (nd <= k) {
                ans += ('0'+j);
                k -= nd;
                q.erase(q.find({dg[j][uk[j]], j}));
                uk[j]++;
                break;
            }
        }
    }
    cout << ans;
    for (auto e: q)cout << e.second;
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
