#include <iostream>
#include <algorithm>
#include <string>
#include <unordered_map>

using namespace std;

int mask[10];
unordered_map<int, int> frommask;
int real1[10], real2[10];

signed main() {
    string s1, s2;
    cin >> s1 >> s2;
    int a1 = 0, a2 = 0;
    for (int x = 0; x < 7; x++) {
        a1 += (1 << (7 - x - 1)) * (s1[x] - '0');
        a2 += (1 << (7 - x - 1)) * (s2[x] - '0');
    }
    mask[0] = 119;
    mask[1] = 18;
    mask[2] = 93;
    mask[3] = 91;
    mask[4] = 58;
    mask[5] = 107;
    mask[6] = 111;
    mask[7] = 82;
    mask[8] = 127;
    mask[9] = 123;
    frommask[119] = 0;
    frommask[18] = 1;
    frommask[93] = 2;
    frommask[91] = 3;
    frommask[58] = 4;
    frommask[107] = 5;
    frommask[111] = 6;
    frommask[82] = 7;
    frommask[127] = 8;
    frommask[123] = 9;
    for (int i = 0; i < 10; i++) {
        int mask1 = mask[i] & a1;
        int mask2 = mask[i] & a2;
        if (frommask.find(mask1) == frommask.end()) {
            real1[i] = -1;
        } else {
            real1[i] = frommask[mask1];
        }
        if (frommask.find(mask2) == frommask.end()) {
            real2[i] = -1;
        } else {
            real2[i] = frommask[mask2];
        }
    }
    int BEST = 0;
    for (int y = 99; y >= 1; y--) {
        int r1, r2;
        if (y / 10 == 0) {
            r1 = 0;
        } else {
            r1 = real1[y / 10];
        }
        r2 = real2[y % 10];
        // cout << y << " : " << r1 << r2 << '\n';
        if (r1 != -1 && r2 != -1) {
            int x = r1 * 10 + r2;
            for (int i = y - 1; i >= 1; i--) {
                int r3, r4;
                if (i / 10 == 0) {
                    r3 = 0;
                } else {
                    r3 = real1[i / 10];
                }
                r4 = real2[i % 10];
                if (r3 != -1 && r4 != -1) {
                    int x2 = r3 * 10 + r4;
                    if (x2 - x == y - i) {
                        BEST = max(BEST, y - i);//
                    } else {
                        break;
                    }
                } else {
                    break;
                }
            }
        }
    }
    cout << BEST;
}