#include <bits/stdc++.h>

#define fastIO cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define rep(i, a, b) for (int i = a; i < b; i++)
#define full(vec) vec.begin(), vec.end()
#define eb emplace_back
#define pb push_back
#define fr first
#define sc second

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

typedef vector <ll> vl;
typedef vector <vector <ll>> vvl;

const ld EPS = 1e-9;
const ll P = 307;
const ld PI = acos(-1);

template<class T>
istream &operator>>(istream &input, vector<T>& v) {
    for (auto &i : v) {
        input >> i;
    }
    return input;
}

template<class T>
ostream &operator<<(ostream &output, vector<T>& v) {
    for (auto &i : v) {
        output << i << ' ';
    }
    return output;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void cok(bool t) { cout << (t ? "YES" : "NO") << '\n'; }

#define bits_s(a) bitset<64>(a).to_string()
string bits(ll m) {
    string s = bits_s(m);
    //reverse(full(s));
    return s;
}

const ll N = 2e5 + 10;
const ll MAXN = 1e16;
const ll MOD = 1e9 + 7;

pair<int, int> dfs1(int v, int num, map <int, set<pair<int, int>>> &vc,
                    vector <pair<int, int>> &buffer, vector <int> &arr)
{
    if (buffer[num].second != -1)
    {
        return buffer[num];
    }
    auto& u_st = vc[arr[num]];
    auto it = u_st.lower_bound({num + 1, -1});
    int ans = arr[num];
    int cnt = 1;
    if (it != u_st.end())
    {
        auto [nm_u, u] = *it;
        auto pr = dfs1(u, nm_u, vc, buffer, arr);
        ans = pr.second;
        cnt = pr.first + 1;
    }
    buffer[num] = {cnt, ans};
    return {cnt, ans};
}

void solve() {
    string s;
    cin >> s >> s >> s >> s >> s >> s >> s;
    set <int> st;
    map <int, int> mp;
    map <int, int> mp2;
    int n;
    cin >> n >> s >> s >> s;
    map <int, set<pair<int, int>>> vc;
    vector <int> arr;
    vector <int> arr2;
    int num_if = 0;
    while (true)
    {
        cin >> s;
        if (s == "}") break;
        // cout << s << endl;
        if (s == "if")
        {
            cin >> s >> s;
            int a;
            cin >> a >> s >> s >> s;
            // cout << s << endl;
            int b;
            cin >> b >> s;
            st.insert(a);
            // cout << a << ' ' << b << endl;
            vc[a].insert({num_if++, b});
            arr.push_back(b);
            arr2.push_back(a);
        }
        else
        {
            cin >> s;
            // cout << "WORK!!" << endl;
        }
        // break;
    }
    //cout << "LOL" << endl;
    vector <pair<int, int>> buffer(num_if, {-1, -1});
    if (num_if > 0)
    {
        for (int i = 0; i < num_if; i++)
        {
            auto [cn, a] = dfs1(arr2[i], i, vc, buffer, arr);
            if (mp.find(arr2[i]) == mp.end())
            {
                mp[arr2[i]] = a;
                mp2[arr2[i]] = cn;
            }
        }
    }
    // cout << "LOL" << endl;
    /*for (auto [a, b] : mp)
    {
        cout << a << ' ' << b << endl;
    }*/
    ll ans = 2;
    int v = 0;
    set <int> used;
    while (true)
    {
        //cout << v << endl;
        if (v >= n)
        {
            break;
        }
        if (used.count(v))
        {
            cout << -1;
            return;
        }
        used.insert(v);
        auto it = st.lower_bound(v);
        int u = n;
        if (it != st.end())
        {
            u = *it;
        }
        ll ln = u - v;
        ans += num_if * ln + 3 * ln;
        //cout << u << " U " << endl;
        //cout << "ANS 1: " << ans << endl;
        if (u >= n)
        {
            break;
        }
        //cout << "LOL : " << mp2[u] << endl;
        ans += mp2[u] + num_if + 3;
        //cout << "ANS 2: " << ans << endl;
        v = mp[u] + 1;
    }
    cout << ans;
}

/*
for (int i = 0; i < 8; i++) {
    if (i == 0) i = 6;
    if (i == 7) i = 2;
    if (i == 5) i = 7;
    work (i);
}
*/


signed main() {
    fastIO
    auto start_time = chrono::high_resolution_clock::now();
    ll _ = 1;
    // cin >> _;
    while (_--) {
        solve();
    }
    auto end_time = chrono::high_resolution_clock::now();
    //cerr << "Execution time: " << chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
    return 0;
}
