#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using std::cin, std::cout;
using ll = long long;
using namespace __gnu_pbds;
using ordered_set = tree<ll, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	int T;
	cin >> T;
	while (T--) {
		std::string str;
		ll k;
		cin >> str;
		cin >> k;
		ll n = str.size();

		std::set<std::pair<ll, ll>, std::greater<std::pair<ll ,ll>>> pr;
		std::set<std::pair<ll, ll>> sf;
		std::set<std::pair<ll, ll>> mn;
		ordered_set dl;
		for (int i = 0; i < n; ++i) {
			int a = str[i] - '0';
			if (i <= k) {
				pr.insert({i, a});
				mn.insert({a, i});
			}
			else {
				sf.insert({i, a});
			}
		}
		std::vector<ll> ans;

		while (ans.size() < n) {
			auto m = *mn.begin();
			mn.erase(mn.begin());
			std::swap(m.first, m.second);
			pr.erase(m);
			dl.insert(m.first);
			ll d = dl.order_of_key(m.first);
			k -= m.first - d;
			if (pr.size() < k + 1 && !sf.empty()) {
				auto p = *sf.begin();
				sf.erase(sf.begin());
				pr.insert(p);
				std::swap(p.first, p.second);
				mn.insert(p);
			}
			else {
				while (pr.size() > k + 1) {
					auto p = *pr.begin();
					pr.erase(pr.begin());
					sf.insert(p);
					std::swap(p.first, p.second);
					mn.erase(p);
				}
			}
			ans.push_back(m.second);
		}
		for (auto i : ans) {
			cout << i;
		}
		cout << '\n';
	}

	
	return 0;
}
