
#include <iostream>
#include <string>
#include <queue>
#include <vector>

std::string minis(std::string num, long long k) {
    int n = num.size();
    for (int i = 0; i < n && k > 0; ++i) {
        std::priority_queue<std::pair<char, int>, std::vector<std::pair<char, int>>, std::greater<>> minHeap;
        for (int j = i; j < n && j <= i + k; ++j) {
            minHeap.push({num[j], j});
        }
        std::pair<char, int> prom;
        prom = minHeap.top();
        char min_val = prom.first;
        int min_index = prom.second;

        for (int j = min_index; j > i; --j) {
            std::swap(num[j], num[j - 1]);
        }
        k -= (min_index - i);
    }
    return num;
}

int main() {
    long long t, k; 
    std::string num;
    std::cin>>t;
    for(int i = 0; i < t; i++){
        std::cin >> num >> k;
        std::string min_num = minis(num, k);
        std::cout << min_num << '\n';
    }
    return 0;
}
