#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

//ll stupid_calc(int r, int g, int b) {
//    int n = r + g + b;
//    vector<vector<vector<vector<ll>>>> dp
//            (n, vector<vector<vector<ll>>>
//                    (r + 1,
//                     vector<vector<ll>>
//                             (g + 1, vector<ll>(3, 0))));
//    dp[0][1][0][0] = 1;
//    dp[0][0][1][1] = 1;
//    dp[0][0][0][2] = 1;
//    for (int i = 1; i < n; i++) {
//        for (int rr = 0; rr <= min(r, i); rr++) {
//            for (int gg = 0; gg <= min(g, i); gg++) {
//                {
//                    if (rr - 1 >= 0)
//                        dp[i][rr][gg][0] = (dp[i - 1][rr - 1][gg][1] + dp[i - 1][rr - 1][gg][2]) % MOD;
//                }
//                {
//                    if (gg - 1 >= 0)
//                        dp[i][rr][gg][1] = (dp[i - 1][rr][gg - 1][0] + dp[i - 1][rr][gg - 1][2]) % MOD;
//                }
//                {
//                    dp[i][rr][gg][2] = (dp[i - 1][rr][gg][0] + dp[i - 1][rr][gg][1]) % MOD;
//                }
//            }
//        }
//    }
//    return (dp[n - 1][r][g][0] + dp[n - 1][r][g][1] + dp[n - 1][r][g][2]) % MOD;
//}

//void stress() {
//    for (int r = 1; r <= 5; r++) {
//        for (int g = 1; g <= 5; g++) {
//            for (int b = 1; b <= 5; b++) {
//                cout << r << " " << g << " " << b << ": " << stupid_calc(r, g, b) << "\n";
//            }
//        }
//    }
//}

const ll MOD = 998244353;
const int MAXN = 1e5 + 1;

vector<ll> fact;
vector<ll> inv;

ll binpow(ll a, ll p, ll mod) {
    if (!p) return 1;
    if (p & 1) return (a * binpow(a, p - 1, mod)) % mod;
    ll temp = binpow(a, p >> 1, mod);
    return (temp * temp) % mod;
}

ll c(ll k, ll n) {
    if (k < 0) return 0;
    if (k > n) return 0;
    return (fact[n] * inv[k] % MOD) * inv[n - k] % MOD;
}

ll f(ll n, ll x) {
    return c(x - 1, n - 1);
}

ll calc(ll cnt, ll n, ll m) {
    if (cnt & 1) {
        ll ans1 = (f(n, (cnt + 1) / 2) * f(m, cnt / 2)) % MOD;
        ll ans2 = (f(n, cnt / 2) * f(m, (cnt + 1) / 2)) % MOD;
        return (ans1 + ans2) % MOD;
    } else {
        return (2 * f(n, cnt / 2) * f(m, cnt / 2)) % MOD;
    }
}

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    ll ans = 0;
    for (int cnt = 2; cnt <= n + m; cnt++) {
        ans += (calc(cnt, n, m) * c(k - (n + m - cnt), cnt + 1)) % MOD;
        ans %= MOD;
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    fact.resize(MAXN, 1);
    for (int i = 2; i < MAXN; i++) {
        fact[i] = (fact[i - 1] * 1LL * i) % MOD;
    }

    inv.resize(MAXN, 1);
    inv.back() = binpow(fact.back(), MOD - 2, MOD);
    for (int i = MAXN - 1; i >= 1; i--) {
        inv[i - 1] = (inv[i] * 1LL * i) % MOD;
    }

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
