#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();
void precalc();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    precalc();

    int t = 1;
    // cin >> t;
    while (t --> 0) {
        solve();
        cout << '\n';
    }

    return 0;
}

map<int, int> mp;

void precalc()
{
    string s = "{}";
    vector<string> v = {};

    for(int i = 0; i < 16; i++)
    {
        mp[count(s.begin(), s.end(), '{')] = i;
        v.pb(s);
        
        s = "{";
        for(auto& ss : v) s += ss + ",";
        s.pop_back();
        s += "}";
    }
}

void solve()
{
    string s;
    cin >> s;

    int cnt = count(s.begin(), s.end(), '{');
    cout << mp[cnt];
}