//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

signed main() {
    vector<int> mask(2);
    vector<int> numbers = {0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
                           0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011};
    map<int, int> back = {{0b1110111, 0}, {0b0010010, 1}, {0b1011101, 2}, {0b1011011, 3},
                          {0b0111010, 4}, {0b1101011, 5}, {0b1101111, 6}, {0b1010010, 7},
                          {0b1111111, 8}, {0b1111011, 9}};
    int x, y;
    cin >> x >> y;
    for (int i = 0; i < 7; ++i) {
        mask[0] |= ((x % 10) << (i));
        x /= 10;
    }
    for (int i = 0; i < 7; ++i) {
        mask[1] |= ((y % 10) << (i));
        y /= 10;
    }
    vector<int> a(100);
    for (int i = 0; i < 100; ++i) {
        int n1 = i / 10, n2 = i % 10;
        if (n1 == 0) {
            n1 = 0;
        } else {
            if (back.find(numbers[n1] & mask[0]) == back.end()) {
                n1 = -2;
            } else {
                n1 = back[numbers[n1] & mask[0]];
            }
        }

        if (back.find(numbers[n2] & mask[1]) == back.end()) {
            n2 = -2;
        } else {
            n2 = back[numbers[n2] & mask[1]];
        }

        if (n1 == -2 || n2 == -2) {
            a[i] = -2;
        } else {
            a[i] = n1 * 10 + n2;
        }
    }

    int counter = 0;
    int ans = 0;
    for (int i = 99; i > 1; --i) {
        // cout << a[i] << ' ';
        if (a[i] == a[i - 1] + 1) {
            counter++;
        } else {
            counter = 0;
        }
        ans = max(ans, counter);
    }
    cout << ans << '\n';
    return 0;
}
