//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <array>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    if (s <= f) {
        int curgcd = 0, start = s;
        for (int i = s; i <= f; ++i) {
            if (abs(a[i] - a[i + 1]) == 1) {
                cout << "Impossible";
                return;
            }
            if (i == f || __gcd(curgcd, abs(a[i] - a[i + 1])) == 1) {
                cout << "Kaban-" << (curgcd ? curgcd : 1488) << ' ' << start << ' ' << i << '\n';
                start = i;
                curgcd = abs(a[i] - a[i + 1]);
            } else {
                curgcd = __gcd(curgcd, abs(a[i] - a[i + 1]));
            }
        }
    } else {
        int curgcd = 0, start = s;
        for (int i = s; i >= f; --i) {
            if (abs(a[i] - a[i + 1]) == 1) {
                cout << "Impossible";
                return;
            }
            if (i == f || __gcd(curgcd, abs(a[i] - a[i - 1])) == 1) {
                cout << "Kaban-" << (curgcd ? curgcd : 1488) << ' ' << start << ' ' << i << '\n';
                start = i;
                curgcd = abs(a[i] - a[i - 1]);
            } else {
                curgcd = __gcd(curgcd, abs(a[i] - a[i - 1]));
            }
        }
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(false);
    cout.tie(0)->sync_with_stdio(false);
    int t = 1; // cin >> t;
    while (t-- > 0) {
        solve();
        cout << '\n';
    }
    return 0;
}
