#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

using namespace std;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    --s;
    --f;
    vector<pair<int, int>> ans;
    if (abs(a[min(s, f)] - a[min(s, f) + 1]) == 1) {
        cout << "Impossible";
        return 0;
    }
    int g = abs(a[min(s, f)] - a[min(s, f) + 1]);
    for (int i = min(s, f) + 1; i < max(s, f); ++i) {
        int diff = abs(a[i] - a[i + 1]);
        if (gcd(diff, g) == 1) {
            ans.emplace_back(make_pair(g, i));
            if (abs(a[i] - a[i + 1]) == 1) {
                cout << "Impossible";
                return 0;
            }
            g = abs(a[i] - a[i + 1]);
            if (g == 0) {
                g = a[i];
            }
        }
        g = gcd(diff, g);
    }
    ans.emplace_back(make_pair(g, max(s, f)));
    int pr = min(s, f);
    vector<string> res;
    for (auto &[i, j] : ans) {
        int mod = i;
        if (i == 0) {
            mod = 2;
        }
        if (s < f) {
            res.emplace_back("Kaban-" + to_string(mod) + " " + to_string(pr + 1) + " " + to_string(j + 1));
        } else {
            res.emplace_back("Kaban-" + to_string(mod) + " " + to_string(j + 1) + " " + to_string(pr + 1));
        }
        pr = j;
    }
    if (s > f) {
        reverse(res.begin(), res.end());
    }
    for (auto &str : res) {
        cout << str << '\n';
    }
    return 0;
}
