#include <iostream>
#include <string>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;

vector<string> dig1 = {
        "1110111",
        "0010010",
        "1011101",
        "1011011",
        "0111010",
        "1101011",
        "1101111",
        "1010010",
        "1111111",
        "1111011"
};

int get_dig1(string& s) {
    for (int i = 0; i < dig1.size(); ++i) {
        if (s == dig1[i]) {
            return i;
        }
    }
    return -1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string s1, s2; cin >> s1 >> s2;
    int ans = 0, cur_ans = 0;
    int prev = 100000;
    for (int i = 99; i > 0; --i) {
        int a = i / 10, b = i % 10;
        pair<string, string> cur_str;
        string a_s = dig1[a], b_s = dig1[b];
        if (a == 0) {
            a_s = "0000000";
        }
        for (int j = 0; j < 7; ++j) {
            if (a_s[j] == '1' && s1[j] == '0') {
                a_s[j] = '0';
            }
        }
        for (int j = 0; j < 7; ++j) {
            if (b_s[j] == '1' && s2[j] == '0') {
                b_s[j] = '0';
            }
        }
        a = get_dig1(a_s), b = get_dig1(b_s);
        if (i / 10 == 0) {
            a = 0;
        }
        int cur_num = a * 10 + b;
        if (cur_num == prev + 1 && b != -1 && a != -1) {
            cur_ans++;
            ans = max(ans, cur_ans);
        } else {
            cur_ans = 0;
        }
        prev = cur_num;
    }
    cout << ans << "\n";
    return 0;
}
