#include <algorithm>
#include <bits/stdc++.h>
#include <tuple>
#include <vector>

using namespace std;
using i64 = int64_t;
using ll = int64_t;

#define all(x) x.begin(), x.end()

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0 ; i < n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    --s, --f;
    bool swapped = false;
    if (s > f) {
        swap(s, f);
        swapped = true;
    }

    auto gcd = [](int a, int b) -> int {
        while (a && b) {
            if (a > b) a %= b;
            else b %= a;
        }
        return a + b;
    };

    vector<tuple<int, int, int>> kabans;
    int g = 0, l = s, r = s;
    for (int i = s; i <= f; ++i) {
        if (i == f) {
            kabans.push_back({ g ? g : a[i], l, r });
            continue;
        }
        int d = abs(a[i] - a[i + 1]);
        if (d == 1) {
            cout << "Impossible";
            return 0;
        }
        if (d == 0) {
            r = i + 1;
            continue;
        }
        int tg = gcd(g, d);
        // cout << "beg: i=" << i+1 << " g=" << g << " tg=" << tg << " d=" << d << endl;
        if (tg == 1) {
            kabans.push_back({ g ? g : a[i], l, r });
            l = i; 
            g = d;
        } else {
            g = tg;
        }
        r = i + 1;
    }
    if (swapped) reverse(all(kabans));
    for (auto [m, l, r] : kabans) {
        if (swapped) swap(l, r);
        cout << "kaban-" << (m <= 1 ? 239 : m) << ' ' << l + 1 << ' ' << r + 1 << '\n';
    }
    return 0;
}
