#include <ctime>
#include <iostream>
#include <random>
#include <vector>
#define ll long long

using namespace std;

constexpr ll MOD = 998'244'353;

std::mt19937_64 rnd(time(0));
constexpr ll N = 200005;

ll fact[N], infact[N];

ll binpow(ll h, ll r) {
  ll l = 1;
  while (r) {
    if (r & 1) {
      l = l * h % MOD;
    }
    h = h * h % MOD;
    r /= 2;
  }
  return l;
}

ll C(ll n, ll k) { return fact[n] * infact[k] % MOD * infact[n - k] % MOD; }

// ll dd[105][105][105][3];

// ll rec(ll a, ll b, ll c, int lst = -1, string s = "") {
//   if (a == 0 && b == 0 && c == 0) {
//     for (int i = 0; i < s.size(); i++) {
//       if (s[i] == 'c' && i % 2 != 1) {
//         return 1;
//       }
//     }
//     cout << s << endl;
//     return 1;
//   }
//   // if (lst != -1 && dd[a][b][c][lst] != -1) {
//   //   return dd[a][b][c][lst];
//   // }

//   ll ans = 0;
//   if (lst != 0 && a > 0) {
//     ans = (ans + rec(a - 1, b, c, 0, s + 'a')) % MOD;
//   }
//   if (lst != 1 && b > 0) {
//     ans = (ans + rec(a, b - 1, c, 1, s + 'b')) % MOD;
//   }
//   if (lst != 2 && c > 0) {
//     ans = (ans + rec(a, b, c - 1, 2, s + 'c')) % MOD;
//   }
//   if (lst != -1) {
//     dd[a][b][c][lst] = ans;
//   }
//   return ans;
// }

ll KK(ll c, ll o) {
  if (c < 1) {
    return 0;
  }
  return C(c + o - 1, c - 1);
}

void solve() {
  ll a, b, c;
  cin >> a >> b >> c;
  // for (int i = 0; i <= a; i++) {
  // for (int j = 0; j <= b; j++) {
  // for (int k = 0; k <= c; k++) {
  // for (int u = 0; u <= 2; u++) {
  //   dd[i][j][k][u] = -1;
  // }
  // }
  // }
  // }
  c++;
  if (abs(a - b) > c) {
    cout << 0 << endl;
    return;
  }
  ll ans = 0;
  ll fr1 = abs(a - b), fr2 = 0;
  ll o = min(a, b);
  for (; fr1 + fr2 <= c; fr1++, fr2++, o--) {
    ll m1 = 0, m2 = 0, m3 = 0;
    // cout << c << " " << o << " " << fr1 << " " << fr2 << " : ";
    if (c >= fr1 + fr2 && o >= (c - fr1 - fr2) && c >= 0) {
      m1 = C(c, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD *
           KK(c, o - (c - fr1 - fr2)) % MOD * binpow(2, c - fr1 - fr2) % MOD;
      ans = (ans + m1) % MOD;
    }
    if (c - 1 >= fr1 + fr2 && o >= (c - 1 - fr1 - fr2) && c >= 1) {
      m2 = C(c - 1, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD *
           KK(c - 1, o - (c - 1 - fr1 - fr2)) % MOD *
           binpow(2, c - 1 - fr1 - fr2) % MOD;
      ans = (ans + m2 * 2 % MOD) % MOD;
    }
    if (c - 2 >= fr1 + fr2 && o >= (c - 2 - fr1 - fr2) && c >= 2) {
      m3 = C(c - 2, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD *
           KK(c - 2, o - (c - 2 - fr1 - fr2)) % MOD *
           binpow(2, c - 2 - fr1 - fr2) % MOD;
      ans = (ans + m3 % MOD) % MOD;
    }
    // cout << m1 << " " << m2 * 2 << " " << m3 << endl;
  }
  cout << ans << endl;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  fact[0] = 1;
  infact[0] = 1;
  for (ll i = 1; i <= N; i++) {
    fact[i] = fact[i - 1] * i % MOD;
    infact[i] = binpow(fact[i], MOD - 2);
  }
  ll t = 1;
  while (t--) {
    solve();
  }
}

/*
 */