#include <vector>
#include <iostream>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    bool res = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    int diff;
    int currNod = -1;
    int start;
    int g;
    for (int i = min(s, f) + 1; i <= max(s, f); ++i) {
        diff = abs(a[i] - a[i - 1]);
        if (diff == 1) {
            cout << "Impossible" << endl;
            return 0;
        }
    }

    if (s < f) {
        start = s;
        for (int i = s + 1; i <= f; ++i) {
            diff = abs(a[i] - a[i - 1]);
            if (currNod == -1) {
                currNod = diff;
            } else {
                g = gcd(currNod, diff);
                if (g == 1) {
                    cout << "Kaban-" << currNod << " " << start + 1 << " " << i << '\n';
                    start = i - 1;
                    currNod = diff;
                } else {
                    currNod = g;
                }
            }
        }
        if (currNod == 0) {
            currNod = 2;
        }
        cout << "Kaban-" << currNod << " " << start + 1 << " " << f + 1 << '\n';
    } else {
        start = s;
        for (int i = s - 1; i >= f; --i) {
            diff = abs(a[i] - a[i + 1]);
            if (currNod == -1) {
                currNod = diff;
            } else {
                g = gcd(currNod, diff);
                if (g == 1) {
                    cout << "Kaban-" << currNod << " " << start + 1 << " " << i + 2 << '\n';
                    start = i + 1;
                    currNod = diff;
                } else {
                    currNod = g;
                }
            }
        }
        if (currNod == 0) {
            currNod = 2;
        }
        cout << "Kaban-" << currNod << " " << start + 1 << " " << f + 1 << '\n';
    }
    cout << endl;
}

