#include <bits/stdc++.h>
using namespace std;

template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
       os << vec[i] << ((i != vec.size() -1) ? " " : "" );
   return os;
}

template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}

typedef long long ll;
typedef long double ld;
#define endl "\n"
#define f first
#define s second
const int inf = 1e9 + 1000;
const ll mod = 4398046511104; // 2^42
const ld eps = 1e-9;
const int w = 2147483647;

void solve(){
    int n;
    cin >> n;
    ll chet = 0;
    ll flag = 0;
    vector<int> ans(32, 0);
    for(int i = 0; i < n; i++){
        ll cur; cin >> cur;
        int l = 0;
        while(cur > 0){
            ans[l] += cur % 2;
            cur /= 2;
            l++;
        }
    }
    int summ = 0;
    for(auto a : ans){
        summ += a%n;
    }
    cout << (summ == 0 ? "Dmitry" : "Alice") << endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifndef LOCAL
    // freopen("INPUT.TXT", "r", stdin);
    // freopen("OUTPUT.TXT", "w", stdout);
    // #else
    // freopen("mincut.in", "r", stdin);
    // freopen("mincut.out", "w", stdout);
    #endif

    int t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}