// clang-format off
#include <bits/stdc++.h>
using namespace std; using ll = long long; using ull = unsigned long long; using ld = long double;
#pragma GCC optimize("O3,Ofast")
#define forn(i, n) for (ll i = 0; i < ll(n); ++i)
#define all(v) v.begin(), v.end()
constexpr ll MOD = 1e9 + 7;
// clang-format on
vector<ll> num_to_look = {
    0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
    0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011,
};
map<ll, ll> look_to_num;
ll maskl = 0;
ll maskr = 0;

ll get_real_num(ll num) {
    ll l = num / 10;
    ll r = num % 10;
    ll lnew = num_to_look[l] & maskl;
    ll rnew = num_to_look[r] & maskr;
    if (l == 0) {
        if (look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        }
        return 100;
    } else {
        if (lnew == 0 && look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        } else if (look_to_num.count(lnew) == 1 &&
                   look_to_num.count(rnew) == 1) {
            if (look_to_num[lnew] == 0) {
                return 100;
            }
            return 10 * look_to_num[lnew] + look_to_num[rnew];
        }
        return 100;
    }
    assert(false);
}

void solve() {
    forn(i, 10) {
        look_to_num[num_to_look[i]] = i;
    }
    assert(num_to_look[8] == 127);
    assert(num_to_look[0 == 119]);
    forn(i, 7) {
        char ok1;
        cin >> ok1;
        maskl |= (ok1 == '1') << (6 - i);
    }
    forn(i, 7) {
        char ok2;
        cin >> ok2;
        maskr |= (ok2 == '1') << (6 - i);
    }

    ll k = 0;
    ll cur = 0;
    ll last = get_real_num(99);
    for (ll i = 98; i > 0; --i) {
        ll next = get_real_num(i);
        if (next == last + 1) {
            ++cur;
            if (k < cur) {
                k = cur;
            }
        } else {
            cur = 0;
        }
        last = next;
    }

    cout << k << '\n';
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll all_tests = 1;
    // cin >> all_tests;
    forn(test_case, all_tests) {
        solve();
    }
}
