#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const ll INF = 1e9;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var
//

struct segtree{
    vll DO;
    void init(int n){DO.resize(4 * n,0);}
    void add(int v, int DOl, int DOr, int l, int r, ll val){
        if (l > r) re;
        if (l == DOl && r == DOr) DO[v] += val;
        else {
            int DOm = (DOl + DOr) / 2;
            add(2 * v, DOl, DOm, l, min(DOm, r), val);
            add(2 * v + 1, DOm + 1, DOr, max(DOm + 1, l), r, val);
        }
    }
    ll what_val(int v, int DOl, int DOr, int ind){
        if (DOl == DOr) re DO[v];
        int DOm = (DOl + DOr) / 2;
        if (ind <= DOm) re DO[v] + what_val(2 * v, DOl, DOm, ind);
        else re DO[v] + what_val(2 * v + 1, DOm + 1, DOr, ind);
    }
};


void solve(){
    string s, ans = ""; cin >> s;
    ll k, n = sz(s); cin >> k;
    segtree segt; segt.init(n);
    // st.add(1, 0, n - 1, l, r - 1, val); from l to r - 1
    // st.what_val(1, 0, n - 1, ind)
    vector<set<int>> mp(10);
    set<int> st; rep(i, n) st.insert(i);
    rep(i, n) mp[s[i] - '0'].insert(i);
    while(!st.empty()) {
        int ind = *st.begin();
        bool ok = false;
        for (int num = 1; num <= 9; ++num) {
            if (mp[num].empty()) continue;
            int j = *mp[num].begin();

            int new_ind = ind + segt.what_val(1, 0, n - 1, ind);
            int new_j = j + segt.what_val(1, 0, n - 1, j);
            if (new_j - new_ind > k) continue;
            k -= new_j - new_ind;
            ans += char('0' + num);
            mp[num].erase(j); st.erase(j);
            segt.add(1, 0, n - 1, ind, j, 1);
            ok = 1;
            break;
        }
        if (ok) continue;
        ans += char('0' + s[ind]);
        st.erase(ind);
    }

    cout << ans << '\n';
}

signed main() {
    GO();
    int Q = 1; cin >> Q;
    while (Q--) solve();
}
