#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const ll INF = 1e9;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var
vvi g;
vvi b;
///


void solve(){
    int n; cin >> n;
    vll a(n); for (auto &i: a) cin >> i;
    int s, f; cin >> s >> f;
    bool ok = false;
    if (s > f) swap(s, f), ok = true;
    vector<pair<int, pii>> ans;
    ll g = 0, ind = s - 1;
    for (int i = s - 1; i < f; ++i) {
        if (i == f - 1) {
            if (g == 0) g = 2;
            ans.push_back({g, {ind, f - 1}});
            break;
        }
        ll d = a[i + 1] - a[i];
        if (d == 1) {
            cout << "Impossible";
            re;
        }
        ll g2 = gcd(g, d);
        if (g2 == 1) {
            if (g == 0) g = 2;
            ans.push_back({g, {ind, i}});
            ind = i, g = d;
            continue;
        }
        g = g2;
    }

    if (ok) reverse(all(ans));
    for (auto &p: ans) {
        cout << "Kaban-" << p.fi << ' ';
        if (ok) cout << p.se.se + 1 << ' ' << p.se.fi + 1 << '\n';
        else cout << p.se.fi + 1 << ' ' << p.se.se + 1 << '\n';
    }
}

signed main() {
    GO();
    int Q = 1;
    while (Q--) solve();
}