#include <bits/stdc++.h>
#define int long long

using namespace std;

struct stree {
    vector<int> v;
    int n;

    stree (int n0) {
        n = n0;
        v.resize(n * 4, 0);
    }

    void set(int id, int l, int r, int i, int d) {
        if (r - l == 1) {
            v[id] = d;
            return;
        }
        int m = (l + r) / 2;
        if (i < m) set(id * 2 + 1, l, m, i, d);
        else set(id * 2 + 2, m, r, i, d);
        v[id] = v[id * 2 + 1] + v[id * 2 + 2];
    }

    void set(int i, int d) {
        set(0, 0, n, i, d);
    }

    int get(int id, int l, int r, int lq, int rq) {
        if (lq >= r || rq <= l) return 0;
        if (lq <= l && r <= rq) return v[id];
        int m = (l + r) / 2;
        return get(id * 2 + 1, l, m, lq, rq) + get(id * 2 + 2, m, r, lq, rq);
    }

    int get(int lq) {
        return get(0, 0, n, lq, n);
    }
};

void solve() {
  string s;
  int k;
  cin >> s >> k;
  vector<deque<int>> a(9);
  for (int i = 0; i < s.size(); ++i) {
    a[s[i] - '1'].push_back(i);
  }
  stree segt(s.size() + 1);
  for (int i = 0; i < s.size(); ++i) {
    bool p = 0;
    int cur = -1;
    for (int j = 0; j < 9; ++j) {
      if (a[j].size() > 0 && (cur == -1 || a[j].front() < a[cur].front())) {
        cur = j;
      }
    }
    //cout << i << " " << cur + 1 << " " << k << " " << sdv << "\n";
    a[cur].pop_front();
    for (int j = 0; j < cur; ++j) {
      if (0 < a[j].size() && a[j].front() + segt.get(a[j].front() + 1) - i <= k) {
        cout << (char) (j + '1');
        k -= a[j].front() + segt.get(a[j].front() + 1) - i;
        segt.set(a[j].front(), 1);
        a[j].pop_front();
        a[cur].push_front(i);
        p = 1;
        break;
      }
    }
    if (p == 0) {
      cout << (char) (cur + '1');
    }
  }
  cout << "\n";
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  int t;
  cin >> t;
  while (t--) solve();

  return 0;
}