#include <bits/stdc++.h>

#define endl "\n"
#define all(a) a.begin(), a.end()

using namespace std;
using ll = int64_t;

const int INF = 1e18;

mt19937 rnd(1000 - 7);

void print(auto &v) {
    for (auto &x : v) {
        cout << x << " ";
    }
    cout << endl;
}
struct elem {
    int m, s, f;
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& el : a)
        cin >> el;

    int s, f;
    cin >> s >> f;
    --s, --f;

    bool is_reversed = false;
    if (s > f) {
        swap(s, f);
        is_reversed = true;
    }

    vector<elem> ans;
    for (int i = s + 1; i <= f; ++i) {
        if (abs(a[i - 1] - a[i]) == 1) {
            cout << "Impossible\n";
            return;
        }

        if ((int)ans.size() == 0) {
            ans.push_back({ abs(a[i] - a[i - 1]), i - 1, -1 });
        } else {
            int cur_m = abs(a[i] - a[i - 1]);
            if (cur_m == 0) {
                continue;
            } else if (ans.back().m == 0) {
                ans.back().m = cur_m;
                continue;
            }

            if (gcd(ans.back().m, abs(a[i] - a[i - 1])) == 1) {
                ans.back().f = i - 1;
                ans.push_back({ abs(a[i] - a[i - 1]), i - 1, -1 });
            } else {
                ans.back().m = gcd(ans.back().m, abs(a[i] - a[i - 1]));
            }
        }
    }

    if (ans.back().f == -1) {
        ans.back().f = f;
    }
    if (ans.back().m == 0) {
        ans.back().m = 2;
    }

    if (is_reversed)
        reverse(all(ans));

    for (auto& el : ans) {
        if (is_reversed)
            swap(el.s, el.f);
        cout << "Kaban-" << el.m << " " << el.s + 1 << " " << el.f + 1 << "\n";
    }
}




main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    while (t--)
        solve();
}
