#include <iostream>
#include <vector>
#include <cstdint>

using namespace std;

constexpr int INF = INT_MAX;


void solve() {
    int n;
    cin >> n;
    int min_x = INF, max_x = -INF, max_mod_y = 0;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (y == 0) {
            min_x = min(min_x, x);
            max_x = max(max_x, x);
        }
        max_mod_y = max(max_mod_y, abs(y));
    }
    if (max_x == -INF || min_x == INF || max_mod_y == 0 || max_x == min_x) {
        cout << 0 << "\n";
    } else {
        // cout << max_x << ' ' << min_x << ' ' << max_mod_y << '\n';
        const double res = static_cast<double>((max_x - min_x) * max_mod_y) / 2.0;
        cout << res << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
