#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <queue>
#include <tuple>
#include <set>

using namespace std;

constexpr int INF = INT_MAX;
unsigned d[1000][1000];

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto &el: a) {
        cin >> el;
    }
    int s, f;
    cin >> s >> f;

    bool to_swap = false;
    if (s >= f) {
        swap(s, f);
        to_swap = true;
    }
    s--;
    f--;
    int temp_gcd = -1;
    int last_gcd = -1;
    int last_start = s;

    vector <tuple <string, int, int>> temp;
    for (int i = s; i < f; i++) {
        if (a[i + 1] - a[i] == 0) {
            if (temp_gcd == -1) temp_gcd = a[i];
            continue;
        }

        if (temp_gcd == -1) {
            temp_gcd = abs(a[i + 1] - a[i]);
            if (temp_gcd == 1) {
                cout << "Impossible";
                return;
            }
        } else {
            last_gcd = temp_gcd;
            temp_gcd = gcd(temp_gcd, abs(a[i + 1] - a[i]));
        }
        if (temp_gcd == 1) {
            temp.emplace_back("kaban-" + to_string(last_gcd), last_start + 1, i + 1);
            last_start = i;
            last_gcd = -1;
            temp_gcd = abs(a[i + 1] - a[i]);
        }
    }
    temp.emplace_back("kaban-" + to_string(temp_gcd), last_start + 1, f + 1);

    if (to_swap) {
        reverse(temp.begin(), temp.end());
    }
    for (auto [str, a, b]: temp) {
        if (to_swap) {
            swap(a, b);
        }
        cout << str << ' ' << a << ' ' << b << '\n';
    }
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
