#include <iostream>
#include <string>
#include <vector>
#include <bitset>

using namespace std;

struct kaban {
    int n, l, r;
};

int gcd(int a, int b) {
    if (a < b) return gcd(b, a);

    if (b == 0) return a;

    return gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& c : a) cin >> c;
    int s, f;
    cin >> s;
    cin >> f;
    bool swapped = false;

    if (s > f) {
        for (int i = 0; i < n / 2; ++i) {
            swap(a[i], a[n - 1 - i]);
        }
        swapped = true;
        swap(s, f);
    }

    vector<kaban> kabans;
    int l = 0, r = 0;
    int taxi_number = -1;
    s--;
    f--;
    for (int i = s; i < f; ++i) {
        if (abs(a[i] - a[i + 1]) == 1) {
            cout << "Impossible\n";
            return;
        }
    }

    bool flag = false;
    for (int i = s; i <= f; ++i) {
        if (i == f) {
            r = i;
            kabans.push_back({ taxi_number, l, r });
            break;
        }
        int diff = abs(a[i] - a[i + 1]);

        if (taxi_number == -1) {
            l = i;
            r = i;
            taxi_number = diff;
            if (diff == 0) {
                flag = true;
            }
        }

        if (diff != 0) {
            flag = false;
        }

        if (flag && diff != 0) {
            taxi_number = diff;
            continue;
        }

        if (gcd(taxi_number, diff) == 1) {
            r = i;
            kabans.push_back({ taxi_number, l, r });
            taxi_number = -1; i--;
        }
        else {
            taxi_number = gcd(taxi_number, diff);
        }
    }


    for (int i = 0; i < kabans.size(); ++i) {
        int j = kabans.size() - 1 - i;

        if (!swapped) {
            j = i;
        }
        else {
            swap(kabans[j].r, kabans[j].l);

        }
        if (kabans[j].n == 0) {
            kabans[j].n = 228;
        }
        std::cout << "Kaban-" << kabans[j].n << ' ' << kabans[j].l + 1 << ' ' << kabans[j].r + 1<< '\n';



    }
}

signed main() {
    solve();
}
