import sys

input = lambda: sys.stdin.readline().rstrip()

s1 = int(input(), 2)
s2 = int(input(), 2)
#   --1
# |2   |3
#   --4
# |5   |6
#   --7
# m = {
#     '1110111': 0, '0010010': 1, '1011101': 2, '1011011': 3,
#     '0111010': 4, '1101011': 5, '1101111': 6, '1010010': 7,
#     '1111111': 8, '1111011': 9
# }

rev = list(map(lambda x: int(x, 2),
               ['1110111', '0010010', '1011101', '1011011',
                '0111010', '1101011', '1101111', '1010010',
                '1111111', '1111011']))

m = {rev[i] : i for i in range(10)}


def get(s: int):
    p1 = s // 10
    p2 = s % 10
    t1 = rev[p1]
    t2 = rev[p2]
    k1 = t1 & s1
    k2 = t2 & s2
    if p1 == 0:
        if k2 in m:
            return m[k2]
        else:
            return -1
    if k1 not in m or k2 not in m:
        return -1
    else:
        return m[k1] * 10 + m[k2]


cur = 0
pred = 100
mx = 0
for i in range(99, 0, -1):
    tmp = get(i)
    if tmp == -1:
        mx = max(cur, mx)
        cur = 0
        pred = 10000
    else:
        if tmp - 1 == pred:
            cur += 1
        else:
            mx = max(cur, mx)
            cur = 0
        pred = tmp

print(max(cur, mx))
