#include <iostream>
#include <bits/stdc++.h>

#define N 1010
#define ll long long
//#define int ll

using namespace std;
vector<vector<int>> ls(N, vector<int>(N, 0));
vector<vector<pair<int, int>>> mst(N);
int n;

void primAlgorithm() {
    vector<bool> used(n, false);
    priority_queue<tuple<int, int, int>, vector<tuple<int, int, int>>, greater<>> q;
    vector<tuple<int, int, int>> res;
    q.push({0, 0, 0});
    while (!q.empty()) {
        auto [w, u, v] = q.top();
        q.pop();
        if (used[u]) continue;
        used[u] = true;
        if (u != v) {
            mst[u].emplace_back(v, w);
            mst[v].emplace_back(u, w);
        }

        for (int i = 0; i < n; i++) {
            if (i == u) continue;
            q.push({ls[i][u], i, u});
        }
    }
}

vector<bool> used;
vector<vector<int>> res(N, vector<int>(N, 0));

void dfs(int u, int dep, int st) {
    if (used[u]) return;
    res[st][u] = dep;
    res[u][st] = dep;
    used[u] = true;
    for (auto [w, v] : mst[u]) {
        dfs(v, dep + w, st);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> ls[i][j];
        }
    }

    primAlgorithm();
    for (int i = 0; i < n; i++) {
        used.clear();
        used.resize(n);
        dfs(i, 0, i);
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            cout << res[i][j] << ' ';
//        }
//        cout << '\n';
//    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (res[i][j] != ls[i][j]) {
                cout << "NO";
                return 0;
            }
        }
    }

    cout << "YES";

    return 0;
}