#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define ull unsigned ll
#define int ll
#define ld long double
#define F first
#define S second
#ifndef OlegSanders
#define cerr if (false) cerr
#endif

using namespace std;

int INF = 1e9+7;

struct Digit {
    vector<int> data;

    Digit() {
        data.resize(7);
    }

    Digit(string s) {
        for (auto to:s) {
            data.pb(to - '0');
        }
    }

    Digit(int a) {
        data = {1, 1, 1, 1, 1, 1, 1};
        switch (a) {
            case 0:
                data[3] = 0;
                break;
            case 1:
                data[0] = 0;
                data[1] = 0;
                data[3] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 2:
                data[1] = 0;
                data[5] = 0;
                break;
            case 3:
                data[1] = 0;
                data[4] = 0;
                break;
            case 4:
                data[0] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 5:
                data[2] = 0;
                data[4] = 0;
                break;
            case 6:
                data[2] = 0;
                break;
            case 7:
                data[1] = 0;
                data[3] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 8:
                break;
            case 9:
                data[4] = 0;
                break;
        }
    }

    bool operator==(Digit a){
        return this->data == a.data;
    }


    static int to_int(Digit a) {
        for (int i = 0; i < 10; i++) {
            Digit t{i};
            if (a == t) {
                return i;
            }
        }
    }
};

Digit operator&(Digit a, Digit b) {
    Digit c;
    for (int i = 0; i < 7; i++) {
        c.data[i] = a.data[i] & b.data[i];
    }
    return c;
}

pair<Digit, Digit> get_pair(int k) {
    if (k < 10) {
        return {Digit(), Digit(k)};
    }
    return {Digit(k / 10), Digit(k % 10)};
}

int gen_int_from_pair(pair<Digit, Digit> a) {
    int ans = 0;
    for (int i = 0; i < 7; i++) {
        ans *= 2;
        ans += a.first.data[i];
        ans *= 2;
        ans += a.second.data[i];
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
//    for (int i = 0; i < 10; i++) {
//        cout << i << ' ' << Digit::to_int(Digit(i)) << endl;
//    }

    string s;
    cin >> s;

    Digit first{s};

    cin >> s;
    Digit second{s};

    map<int, int> pair_to_int;

    for (int i = 0; i <= 99; i++) {
        pair_to_int[gen_int_from_pair(get_pair(i))] = i;
    }

    int ans = 0;

    for (int st = 39; st <= 39; st++) {
        int k = 0;

        pair<Digit, Digit> x = get_pair(st);

//        for (auto to:x.second.data) {
//            cout << to;
//        }cout << endl;

        x = {x.first & first, x.second & second};

//        for (auto to:x.second.data) {
//            cout << to;
//        }cout << endl;

        if (pair_to_int.count(gen_int_from_pair(x)) == 0) {
            continue;
        }

        int y = pair_to_int[gen_int_from_pair(x)];

        k++;

        while (st - k >= 0) {
            x = get_pair(st - k);
            x = {x.first & first, x.second & second};

            if (pair_to_int.count(gen_int_from_pair(x)) == 0) {
                break;
            }

            int y1 = pair_to_int[gen_int_from_pair(x)];
            if (y1 == y + 1) {
                y = y1;
                k++;
            } else {
                break;
            }
        }

        ans = max(ans, k - 1);
    }
    cout << ans;
}
