#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<string> programs(n);
    for (int i = 0; i < n; ++i) {
        cin >> programs[i];
    }

    vector<bool> has_program(26, false);

    for (const string& program : programs) {
        char first_letter = program[0];
        int index = first_letter - 'a';
        has_program[index] = true;
    }

    vector<char> result;
    for (int i = 0; i < 26; ++i) {
        if (has_program[i]) {
            result.push_back('a' + i);
        } else {
            result.push_back('.');
        }
    }

    for (int i = 0; i < 30; i += 6) {
        for (int j = 0; j < 6; ++j) {
            if (i + j < 26)
                cout << result[i + j];
        }
        cout << "\n";
    }

    return 0;
}
