#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <queue>
#include <random>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <deque>

using namespace std;

long long mod = 1e9 + 7;

// random_device rd;
// mt19937 gen(rd());

// long long binPow(long long a, long long p)
// {
//     if (p == 0 || a == 1) {return 1;}
//     a %= mod;
//     if (p % 2 == 0) {return binPow(a * a % mod, p / 2) % mod;}
//     return (a * binPow(a, p - 1)) % mod;
// }

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p);

template<class T>
istream& operator>> (istream& in, vector<T>& vec)
{
    for (T& i: vec) {in >> i;}
    return in;
}

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

void solve()
{
    int n;
    cin >> n;
    vector<vector<long long>> s(n, vector<long long>(n));
    cin >> s;
    vector<long long> d(n, LLONG_MAX);
    vector<bool> a(n, false);
    vector<int> p(n, -1);
    vector<vector<int>> g(n);
    p[0] = 0;
    d[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        int cur = -1;
        for (int j = 0; j < n; ++j)
        {
            if (!a[j])
            {
                if (cur == -1 || d[cur] > d[j]) {cur = j;}
            }
        }
        if (d[cur] != 0)
        {
            g[cur].push_back(p[cur]);
            g[p[cur]].push_back(cur);
        }
        for (int j = 0; j < n; ++j)
        {
            if (j == cur) {continue;}
            if (!a[j])
            {
                if (d[j] > s[cur][j])
                {
                    p[j] = cur;
                    d[j] = s[cur][j];
                }
            }
        }
        a[cur] = true;
        stack<pair<int, long long>> st;
        vector<bool> q(n);
        st.push({cur, 0});
        long long sum = 0;
        q[cur] = true;
        while(!st.empty())
        {
            auto[cur1, curd] = st.top(); st.pop();
            for (auto &el : g[cur1])
            {
                if (!q[el])
                {
                    if (s[cur][el] != curd + s[cur1][el])
                    {
                        cout << "NO";
                        return;
                    }
                    q[el] = true;
                    st.push({el, s[cur][el]});
                }
            }
        }
    }
    cout << "YES";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;

    for (;t > 0; --t)
    {
        solve();
    }
}