﻿#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

int n;
vector<int> score;
vector<bool> been;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    else {
        return gcd(b, a % b);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    score.resize(n);
    been.resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> score[i];
    }
    int s, f;
    cin >> s >> f;
    s--; f--;
    vector<pair<int, int>> next(n, { -1, -1 });
    if (s < f) {
        int last = s;
        for (int i = s + 1; i <= f; i++) {
            int ab = abs(score[i] - score[i - 1]);
            if (ab == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            if (ab != 0) {
                next[last] = { i, ab };
                last = i;
            }
        }
    }
    else {
        int last = s;
        for (int i = s - 1; i >= f; i--) {
            int ab = abs(score[i] - score[i - 1]);
            if (ab == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            if (ab != 0) {
                next[last] = { i, ab };
                last = i;
            }
        }
    }
    if (next[s].first == -1) {
        cout << "Kaban-2 " << s + 1<< ' ' << f + 1 << endl;
        return 0;
    }
    int v = next[s].first;
    int sum = next[s].second;
    int last_last_v = s;
    while (v != f) {
        int last_v = v;
        int last_sum = sum;
        while (sum != 1 && v !=f) {
            last_v = v;
            int v2 = next[v].first;
            last_sum = sum;
            sum = gcd(sum, next[v].second);
            v = v2;
        }
        if (sum != 1) {
            last_sum = sum;
        }
        
        cout << "Kaban-" << last_sum << ' ' << last_last_v + 1<< ' '<<last_v + 1<< endl;
        if (v == f && sum == 1) {
            sum = abs(score[last_v] - score[v]);
            cout << "Kaban-" << sum << ' ' << last_v  + 1<< ' ' << f + 1<< endl;
        }
        last_last_v = last_v;
        sum = abs(score[last_v] - score[v]);
    }
    return 0;
}