import java.util.*;

public class MinNumber {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        scanner.nextLine();

        for (int i = 0; i < t; i++) {
            String input = scanner.nextLine();
            String[] parts = input.split(" ");
            String s = parts[0];
            long k = Long.parseLong(parts[1]);

            System.out.println(minimumNumber(s, k));
        }
    }

    private static String minimumNumber(String s, long k) {
        char[] digits = s.toCharArray();
        int n = digits.length;

        for (int i = 0; i < n && k > 0; i++) {
            char minChar = digits[i];
            int minIndex = i;

            for (int j = i + 1; j < n && j <= i + k; j++) {
                if (digits[j] < minChar) {
                    minChar = digits[j];
                    minIndex = j;
                }
            }

            if (minIndex != i) {
                for (int j = minIndex; j > i; j--) {
                    char temp = digits[j];
                    digits[j] = digits[j - 1];
                    digits[j - 1] = temp;
                    k--;
                    if (k == 0) break;
                }
            }
        }

        return new String(digits);
    }
}
