def is_wooden_matrix(n, matrix):
    for i in range(n):
        if matrix[i][i] != 0:
            return "No"
        for j in range(n):
            if i != j and matrix[i][j] <= 0:
                return "No"

    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return "No"

    visited = [False] * n

    def dfs(v):
        visited[v] = True
        for u in range(n):
            if matrix[v][u] > 0 and not visited[u]:
                dfs(u)

    dfs(0)

    return "Yes" if all(visited) else "No"

n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]

print(is_wooden_matrix(n, matrix))
