def max_triangle_area(points):
    base_points = [(x, y) for x, y in points if y == 0]
    if len(base_points) < 2:
        return 0

    max_height = max(y for x, y in points if y > 0)
    max_area = 0

    for i in range(len(base_points)):
        for j in range(i + 1, len(base_points)):
            x1, y1 = base_points[i]
            x2, y2 = base_points[j]
            base_length = abs(x2 - x1)
            area = 0.5 * base_length * max_height
            max_area = max(max_area, area)

    return max_area

N = int(input())
points = [tuple(map(int, input().split())) for _ in range(N)]
result = max_triangle_area(points)
print(result)