from math import factorial
def count_non_adjacent_arrangements(r, g, b):

    colors = sorted([r, g, b])
    x, y, z = colors[2], colors[1], colors[0]

    if x > y + z + 1:
        return 0

    def combination(n, k):
        return factorial(n) // (factorial(k) * factorial(n - k))

    total_positions = y + z + 1
    ways = combination(total_positions, y) * combination(total_positions - y, z)

    return ways%998244353

r, g, b = map(int, input().split())
result = count_non_adjacent_arrangements(r, g, b)
print(f"{result}")