#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
std::string f_min(std::string s, long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        int min_pos = i;
        for (int j = i + 1; j < std::min(n, i + k + 1); ++j) {
            if (s[j] < s[min_pos]) {
                min_pos = j;
            }
        }
        if (min_pos != i) {
            k -= (min_pos - i);
            char min_value = s[min_pos];
            s.erase(s.begin() + min_pos);
            s.insert(s.begin() + i, min_value);
        }
    }
    return s;
}
int main() {
    int t;
    std::cin >> t;
    std::vector<std::pair<std::string, long long>> inputs(t);
    for (int i = 0; i < t; ++i) {
        std::cin >> inputs[i].first >> inputs[i].second;
    }
    for (int i = 0; i < t; ++i) {
        std::cout << f_min(inputs[i].first, inputs[i].second) << std::endl;
    }
    return 0;
}