#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

const int MOD = 998244353;

long long f(long long r, long long b, long long g, char next) {
    if (r < 0 || b < 0 || g < 0) {
        return 0;
    }

    // Базовый случай для каждого цвета
    if (next == 'r') {
        if (r == 1 && b == 0 && g == 0) {
            return 1;
        }
        return (f(r - 1, b, g, 'b') + f(r - 1, b, g, 'g')) % MOD;
    }

    if (next == 'b') {
        if (r == 0 && b == 1 && g == 0) {
            return 1;
        }
        return (f(r, b - 1, g, 'r') + f(r, b - 1, g, 'g')) % MOD;
    }

    if (next == 'g') {
        if (r == 0 && b == 0 && g == 1) {
            return 1;
        }
        return (f(r, b, g - 1, 'r') + f(r, b, g - 1, 'b')) % MOD;
    }
}

long long totalWays(long long r, long long b, long long g) {
    return (f(r, b, g, 'r') + f(r, b, g, 'b') + f(r, b, g, 'g')) % MOD;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long r, b, g;
    cin >> r >> b >> g;

    cout << totalWays(r, b, g) << '\n';

    return 0;
}
