MOD = 998244353

def f(r, b, g, next_color):
    if r < 0 or b < 0 or g < 0:
        return 0
    
    if next_color == 'r':
        if r == 1 and b == 0 and g == 0:
            return 1
        return (f(r - 1, b, g, 'b') + f(r - 1, b, g, 'g')) % MOD
    
    if next_color == 'b':
        if r == 0 and b == 1 and g == 0:
            return 1
        return (f(r, b - 1, g, 'r') + f(r, b - 1, g, 'g')) % MOD
    
    if next_color == 'g':
        if r == 0 and b == 0 and g == 1:
            return 1
        return (f(r, b, g - 1, 'r') + f(r, b, g - 1, 'b')) % MOD

def totalWays(r, b, g):
    return (f(r, b, g, 'r') + f(r, b, g, 'b') + f(r, b, g, 'g')) % MOD

if __name__ == '__main__':
    r, b, g = map(int, input().split())
    print(totalWays(r, b, g))
