from functools import reduce
def winner(num, heaps):
    if num == 1:
        return "Alice" if heaps[0] % 2 != 0 else "Dmitry"
    xor_sum = reduce(lambda x, y: x ^ y, heaps)
    if xor_sum != 0:
        return "Alice"
    odd_count = sum(1 for h in heaps if h % 2 != 0)
    return "Dmitry" if odd_count == 0 else "Alice"

num = int(input().strip())
heaps = list(map(int, input().strip().split()))

print(winner(num, heaps))