def max_triangle_area(points):

    points_on_x = [p for p in points if p[1] == 0]
    points_above_x = [p for p in points if p[1] != 0]


    if len(points_on_x) < 2:
        return 0.0


    max_height = max(abs(p[1]) for p in points_above_x) if points_above_x else 0

    if max_height == 0:
        return 0.0

    max_area = 0.0
    for i in range(len(points_on_x)):
        for j in range(i + 1, len(points_on_x)):

            base = abs(points_on_x[i][0] - points_on_x[j][0])
            area = 0.5 * base * max_height
            max_area = max(max_area, area)

    return max_area


n = int(input().strip())
points = [tuple(map(int, input().split())) for _ in range(n)]


print(f"{max_triangle_area(points):.9f}")
