﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<pair<int, int>> points(n);
    vector<pair<int, int>> pointsOnOx;

    for (int i = 0; i < n; ++i) {
        cin >> points[i].first >> points[i].second;
        if (points[i].second == 0) {
            pointsOnOx.push_back(points[i]);
        }
    }

    double maxArea = 0.0;

    for (size_t i = 0; i < pointsOnOx.size(); ++i) {
        for (size_t j = i + 1; j < pointsOnOx.size(); ++j) {
            int xA = pointsOnOx[i].first;
            int xB = pointsOnOx[j].first;

            for (const auto& point : points) {
                if (point.second != 0) {
                    double area = 0.5 * abs((xA - xB) * point.second);
                    maxArea = max(maxArea, area);
                }
            }
        }
    }

    cout << maxArea << endl;

    return 0;
}
