﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

string find_minimum_number(string s, long long k) {
    long long n = s.length();
    for (long long i = 0; i < n && k > 0; i++) {
        auto min_iter = min_element(s.begin() + i, s.begin() + min(i + k, n));
        if (min_iter != s.begin() + i) {
            rotate(s.begin() + i, min_iter, min_iter + 1);
            k -= distance(s.begin() + i, min_iter);
        }
    }
    return s;
}

int main() {
    long long t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        cout << find_minimum_number(s, k) << endl;
    }

    return 0;
}