import heapq

def minimize_number_with_swaps(s, k):
    digits = list(s)
    n = len(digits)
    
    for i in range(n):
        if k <= 0:
            break
        

        min_heap = []
        for j in range(i, min(i + k + 1, n)):
            heapq.heappush(min_heap, (digits[j], j))
        

        min_digit, min_idx = heapq.heappop(min_heap)
        

        if min_idx == i:
            continue
        

        k -= (min_idx - i)

        for j in range(min_idx, i, -1):
            digits[j] = digits[j - 1]
        digits[i] = min_digit

    return ''.join(digits)

t = int(input().strip())
results = []
for _ in range(t):
    s, k = input().strip().split()
    k = int(k)
    result = minimize_number_with_swaps(s, k)
    results.append(result)

print('\n'.join(results))

