#include <iostream>
#include <algorithm>

long long factorial(int number) {
    long long result = 1;
    for (int i = 2; i <= number; ++i) {
        result *= i;
    }
    return result;
}

int main() {
    int redValue;
    int greenValue;
    int blueValue;
    std::cin >> redValue;
    std::cin >> greenValue;
    std::cin >> blueValue;
    
    int totalValue = redValue + greenValue + blueValue;
    const int modulusValue = 998244353;

    if (std::max({redValue, greenValue, blueValue}) <= (totalValue + 1) / 2) {
        long long numerator = factorial(totalValue);
        long long denominator = factorial(redValue) * factorial(greenValue) * factorial(blueValue);
        std::cout << (numerator / denominator) % modulusValue << std::endl;
    } else {
        std::cout << 0 << std::endl;
    }
    
    return 0;
}