#include <bits/stdc++.h>

const long long INF = 1e9;

void solve() {
    int n;
    std::cin >> n;
    long long left_x = INF;
    long long right_x = -INF;
    long long max_y = -1;
    for(int i = 0; i < n; ++i) {
        long long x, y;
        std::cin >> x >> y;
        if(y == 0) {
            left_x = std::min(left_x, x);
            right_x = std::max(right_x, x);
        }
        max_y = std::max(max_y, std::abs(y));
    }
    if (left_x == INF || n < 3) {
        std::cout << 0 << '\n';
        return;
    }
    std::cout << (right_x - left_x) * max_y / 2.0;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::cout.setf(std::ios::fixed);
    std::setprecision(20);
    unsigned long long t = 1;
    // std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
