#include "iostream"
#include "vector"
#include "cmath"
#include "numeric"
#include "utility"
#include "algorithm"
#include "map"
#include "string"

void solve() {
    long long n, k;
    std::cin >> n >> k;
    double tmp = 1.0/(2 * static_cast<double>(k));
    long long p = std::ceil(std::pow(n, tmp));

    long long b = 1;
    long long e = 2 * k;

    while (e - b > 4) {
        long long h = (b + e)/2;
        if (static_cast<long long>(std::pow(p, h)) < n) {
            b = h;
        }
        else {
            e = h;
        }
    }
    long long r = b - 1;
    for (; r <= e + 1; ++r) {
        if (static_cast<long long>(std::pow(p, r)) >= n && static_cast<long long>(std::pow(p, r-1)) < n) {
            break;
        }
    }
    std::cout << (p - 1) * r << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    unsigned long long t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
