#include "iostream"
#include "vector"
#include "cmath"
#include "numeric"
#include "utility"
#include "algorithm"
#include "map"
#include "string"

void solve() {
    long long n, k;
    std::cin >> n >> k;
    double tmp = 1.0/(2 * static_cast<double>(k));
    long long p;
    if (k < 70) {
        p = std::ceil(std::pow(n, tmp));
    }
    else {
        p = 2;
    }
    long long current_p = 1;
    long long r = 0;
    for (; r <= 2 * k; ++r) {
        if (((n % p == 0) && (current_p >= (n/p))) || (current_p > n/p))
            break;
        current_p *= p;
    }
    ++r;
    std::cout << (p - 1) * r << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    unsigned long long t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}


// 1000000000000000000
