def max_triangle_area(points):
    points_on_ox = [p for p in points if p[1] == 0]
    points_not_on_ox = [p for p in points if p[1] != 0]

    if len(points_on_ox) < 2 or not points_not_on_ox:
        return 0.0
    max_area = 0.0

    for i in range(len(points_on_ox)):
        for j in range(i + 1, len(points_on_ox)):
            x1, _ = points_on_ox[i]
            x2, _ = points_on_ox[j]
            for x3, y3 in points_not_on_ox:
                area = 0.5 * abs(x2 - x1) * abs(y3)
                max_area = max(max_area, area)

    return max_area

n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]
result = max_triangle_area(points)
print(result)