def factorial_mod(n, mod):
    if n < 0:
        return 0
    res = 1
    for i in range(2, n + 1):
        res = res * i % mod
    return res
def power_mod(a, b, mod):
    res = 1
    while b > 0:
        if b % 2 == 1:
            res = res * a % mod
        a = a * a % mod
        b //= 2
    return res
def arrangements(r, g, b):
    MOD = 998244353
    counts = sorted([r, g, b])
    r, g, b = counts[2], counts[1], counts[0]
    if r > g + b + 1:
        return 0
    total_places = g + b + 1
    result = factorial_mod(total_places, MOD)
    result = result * power_mod(factorial_mod(g, MOD), MOD - 2, MOD) % MOD
    result = result * power_mod(factorial_mod(b, MOD), MOD - 2, MOD) % MOD

    return result

r, g, b = map(int, input().split())
print(arrangements(r, g, b))