def real_cifir(cifir, mask):
    fig = {0: "1110111", 1: "0010010", 2: "1011101", 3: "1011011", 4: "0111010", 5: "1101011", 6: "1101111",
           7: "1010010", 8: "1111111", 9: "1111011"}
    anti_fig = {value: key for key, value in fig.items()}
    new_key = fig[cifir]
    res = ""
    for i in range(7):
        if new_key[i] == "1" and mask[i] == "1":
            res += "1"
        else:
            res += "0"

    try:
        return anti_fig[res]
    except:
        return -1


def all_var(mask1, mask2):
    res = []
    r = 0
    for st in range(9, 0, -1):
        stmask = real_cifir(st, mask1)
        for ml in range(9, -1, -1):
            mlmask = real_cifir(ml, mask2)
            if (stmask == -1) or (mlmask == -1):
                res.append(-2)
            else:
                res.append(10 * stmask + mlmask)
    for ml in range(9, -1, -1):
        mlmask = real_cifir(ml, mask2)
        if (mlmask == -1):
            res.append(-2)
        else:
            res.append(mlmask)

    longest_length = 1
    current_length = 1

    for i in range(1, len(res)):
        if res[i] == res[i - 1] + 1:
            current_length += 1
        else:
            if current_length > longest_length:
                longest_length = current_length
            current_length = 1

    if current_length > longest_length:
        longest_length = current_length

    return longest_length - 1


mask1 = input()
mask2 = input()
print(all_var(mask1, mask2))