#include <iostream>
#include <string>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    vector<string> results;

    while (t--) {
        string s_sam_takoi;
        long long k;
        cin >> s_sam_takoi >> k;

        int n = s_sam_takoi.size();

        for (int i = 0; i < n; ++i) {
            if (k <= 0) break; 
            int min_pos = i;
            for (int j = i + 1; j < n && j <= i + k; ++j) {
                if (s_sam_takoi[j] < s_sam_takoi[min_pos]) {
                    min_pos = j;
                }
            }

         
            if (min_pos != i) {
                int swaps_needed = min_pos - i;

                if (swaps_needed <= k) {
                    
                    char min_char = s_sam_takoi[min_pos];
                    for (int j = min_pos; j > i; --j) {
                        s_sam_takoi[j] = s_sam_takoi[j - 1];
                    }
                    s_sam_takoi[i] = min_char;
                    k -= swaps_needed;
                }
            }
        }

        results.push_back(s_sam_takoi);
    }

    
    for (const string& result : results) {
        cout << result << '\n';
    }

    return 0;
}
