﻿#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

string getMin(string s, int k) {
    int n = s.length();
    if (k >= n) {
        sort(s.begin(), s.end());
        return s;
    }
    for (int i = 0; i < n && k > 0; i++) {
        char minChar = s[i];
        int minIndex = i;
        for (int j = i + 1; j < n && j - i <= k; j++) {
            if (s[j] < minChar) {
                minChar = s[j];
                minIndex = j;
            }
        }
        if (minIndex != i) {
            swap(s[i], s[minIndex]);
            k -= (minIndex - i);
        }
    }
    return s;
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, int>> pairs(t);
    for (int i = 0; i < t; i++) {
        string s;
        int k;
        cin >> s >> k;
        pairs[i] = make_pair(s, k);
    }
    for (int i = 0; i < t; i++) {
        string result = getMin(pairs[i].first, pairs[i].second);
        cout << result << endl;
    }
    return 0;
}