﻿#include <iostream>
#include <string>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    vector<string> results;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            int min_pos = i;
            for (int j = i + 1; j < min(n, i + k + 1); ++j) {
                if (s[j] < s[min_pos]) {
                    min_pos = j;
                }
            }
            if (min_pos != i) {
                int swaps_needed = min_pos - i;
                if (swaps_needed <= k) {
                    char min_char = s[min_pos];
                    for (int j = min_pos; j > i; --j) {
                        s[j] = s[j - 1];
                    }
                    s[i] = min_char;
                    k -= swaps_needed;
                }
            }
        }

        results.push_back(s); 
    }
    for (const string& result : results) {
        cout << result << endl;
    }

    return 0;
}