#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = 2e5 + 7;

int n;
int a[N];
int s, f;

void scan() {
  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  cin >> s >> f;
  --s, --f;
}

bool order_flag = false;

int gcd(int a, int b) {
  return b ? gcd(b, a % b) : a;
}

struct Item {
  int i, j, m;
};

vector<Item> ans;

void solve() {
  if (s > f) {
    swap(s, f);
    order_flag = true;
  }
  while (s < f) {
    int nxt = s, d = abs(a[s + 1] - a[s]), last_d = d;
    while (nxt <= f && d != 1) {
      ++nxt;
      last_d = d;
      d = gcd(d, abs(a[nxt] - a[nxt - 1]));
    }
    --nxt;
    ans.push_back({s, nxt, last_d ? last_d : 2});
    if (s >= nxt) {
      cout << "Impossible\n";
      exit(0);
    }
    s = nxt;
  }
}

void print_ans() {
  if (order_flag) {
    reverse(ALL(ans));
    for (auto& elem : ans) {
      swap(elem.i, elem.j);
    }
  }
  for (auto elem : ans) {
    cout << "Kaban-" << elem.m << ' ' << elem.i + 1 << ' ' << elem.j + 1
         << '\n';
  }
}

void run_solve() {
  scan();
  solve();
  print_ans();
}