#include <bits/stdc++.h>
using namespace std;

bool valid(const int & a,const int & b,const int & c){
  if(a>b+c || b>a+c || c>a+b) return false;
  return true;
}

double MOD(double a){
  if(a<0){
    return -a;
  }
  return a;
}

struct Point {
  double x;
  double y;
};

Point findThirdPoint(Point A, Point B, double a, double b) {
  Point C{};
  double angle = atan2(B.y - A.y, B.x - A.x);
  C.x = A.x + b * cos(angle + M_PI_2);
  C.y = A.y + b * sin(angle + M_PI_2);
  return C;
}

Point findThirdPoint2(Point A, Point B, double a, double b) {
  Point C{};
  double angle = atan2(B.y - A.y, B.x - A.x);
  C.x = A.x + b * cos(angle - M_PI_2);
  C.y = A.y + b * sin(angle - M_PI_2);
  return C;
}

int main() {
  int n;
  cin>>n;
  if(n==1){
    cout<<"No";
    return 0;
  }
  vector<vector<int>> a(n, vector<int>(n));
  for(auto &i : a) {
    for(auto &j : i) {
      cin>>j;
    }
  }
  map<int, Point> m;
  m[0] = {0,0};
  m[1] = {static_cast<double>(a[0][1]), 0};
  for(int i=0;i<n;i++) {
    for(int j=i+1;j<n;j++) {
      for(int k=j+1;k<n;k++) {
        if(i==j || i==k || j==k) continue;
        if(!valid(a[i][j],a[i][k],a[j][k])) {
          cout<<"No";
          return 0;
        }else{
          if(m.find(k)==m.end()){
            m[k] = findThirdPoint(m[i],m[j],a[i][j],a[i][k]);
          }
          else if(MOD(m[k].x-findThirdPoint(m[i],m[j],a[i][j],a[i][k]).x) > 0.0001 || MOD(m[k].y-findThirdPoint(m[i],m[j],a[i][j],a[i][k]).y) > 0.0001
                   && (MOD(m[k].x-findThirdPoint2(m[i],m[j],a[i][j],a[i][k]).x) > 0.0001 || MOD(m[k].y-findThirdPoint2(m[i],m[j],a[i][j],a[i][k]).y) > 0.0001)){
            cout<<"No";
            return 0;
          }
        }
      }
    }
  }
  cout<<"Yes";
  return 0;
}
