n = int(input())

points = [tuple(map(int, input().split())) for _ in range(n)]

pointsOX = sorted([p for p in points if p[1] == 0])

max_height = [0] * n

for k in range(n):
    if points[k][1] == 0:
        continue  
    C = points[k]
    for i in range(len(pointsOX)):
        A = pointsOX[i]
        for j in range(i + 1, len(pointsOX)):
            B = pointsOX[j]
            A_coef = B[1] - A[1]  
            B_coef = A[0] - B[0]  
            C_coef = A[0] * B[1] - B[0] * A[1]  
            height = abs(A_coef * C[0] + B_coef * C[1] + C_coef) / ((A_coef**2 + B_coef**2)**0.5)
            max_height[k] = max(max_height[k], height)

max_area = 0.0

for i in range(len(pointsOX)):
    for j in range(i + 1, len(pointsOX)):
        base_length = abs(pointsOX[j][0] - pointsOX[i][0])
        max_area = max(max_area, 0.5 * base_length * max(max_height))

print(max_area)
