MOD = 998244353

def res(r, g, b):
    if abs(r - g) > 1 or abs(g - b) > 1 or abs(r - b) > 1:
        return 0

    def factorial(n):
        result = 1
        for i in range(2, n + 1):
            result = (result * i) % MOD
        return result

    def comb(n, k):
        if k > n:
            return 0
        return (factorial(n) * pow(factorial(k), MOD - 2, MOD) * pow(factorial(n - k), MOD - 2, MOD)) % MOD

    def count(r, g, b):
        if r > g:
            r, g = g, r
        if g > b:
            g, b = b, g
        if r > g:
            r, g = g, r

        if b > r + g + 1:
            return 0

        if r == g == b:
            return 6
        elif r == g and g == b - 1:
            return 6
        elif r == g or g == b:
            return 2
        else:
            return 6

    return count(r, g, b)

if __name__ == "__main__":
        r, g, b = map(int, input().strip().split())
        result = res(r, g, b)
        print(result)
