#include "bits/stdc++.h"

using namespace std;

using ll = long long;

vector<vector<int>> e;
vector<bool> v;

int dfs(int i){
    v[i] = true;
    int res = 1;
    for(int j : e[i]){
        if(!v[j])
            res += dfs(j);
    }
    return res;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m = 0;
    cin>>n;
    e.resize(n);
    v.resize(n);
    vector<vector<int>> d(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin>>d[i][j];
        }
    }
    bool ok = true;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            bool edge = true;
            for (int k = 0; k < n; ++k) {
                if(k == i || k == j)
                    continue;
                ok &= d[i][j] <= d[i][k] + d[k][j];
                edge &= d[i][j] < d[i][k] + d[k][j];
            }
            if(edge){
                e[i].push_back(j);
                e[j].push_back(i);
                ++m;
            }
        }
    }
    if(m != (n-1) || dfs(0) != n){
        cout<<"No";
        return 0;
    }
    if(ok){
        cout<<"Yes";
    }
    else{
        cout<<"No";
    }
}