import sys
# sys.stdin = open("kolya.in")


digits = [
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011",
]

inv_digits = {s: i for i, s in enumerate(digits)}

def draw(s):
    res = [[' ' for j in range(5)] for i in range(9)]
    if s[0] == '1': res[0][1] = res[0][2] = res[0][3] = 'o'
    if s[1] == '1': res[1][0] = res[2][0] = res[3][0] = 'o'
    if s[2] == '1': res[1][4] = res[2][4] = res[3][4] = 'o'
    if s[3] == '1': res[4][1] = res[4][2] = res[4][3] = 'o'
    if s[4] == '1': res[5][0] = res[6][0] = res[7][0] = 'o'
    if s[5] == '1': res[5][4] = res[6][4] = res[7][4] = 'o'
    if s[6] == '1': res[8][1] = res[8][2] = res[8][3] = 'o'
    print("\n".join(["".join(line) for line in res]))


def num2s(d):
    if d > 99:
        return None
    if d <= 0:
        return None
    digit1 = d // 10
    digit2 = d % 10
    if digit1 == 0:
        if digit2 == 0:
            return None
        return "0000000", digits[digit2]
    else:
        return digits[digit1], digits[digit2]


def s2num(s1, s2):
    if s1 == "0000000":
        d2 = inv_digits.get(s2)
        if d2 is None:
            return None
        return d2
    d1 = inv_digits.get(s1)
    if d1 is None:
        return None
    d2 = inv_digits.get(s2)
    if d2 is None:
        return None
    return d1 * 10 + d2



masks = [f"{i:07b}" for i in range(2 ** 7)]

def mask(s, m):
    return f"{int(s, 2) & int(m, 2):07b}"


mask1, mask2 = input().strip(), input().strip()

def solve(mask1, mask2):
    answer = 0

    for start in range(1, 100):
        for base_goal in range(1, 100):
            for i in range(start + 1):
                real = start - i
                goal = base_goal + i
                real_s = num2s(real)
                goal_s = num2s(goal)
                if real_s is None or goal_s is None:
                    #  if i - 1 > answer:
                    #      print(start, base_goal)
                    answer = max(i - 1, answer)
                    break
                printed_s = mask(real_s[0], mask1), mask(real_s[1], mask2)
                if printed_s != goal_s:
                    # if i - 1 > answer:
                        # print(start, base_goal)
                    answer = max(i - 1, answer)
                    break
    return answer


# for mask1 in masks:
    # for mask2 in masks:
        # print(solve(mask1, mask2))
print(solve(mask1, mask2))
