#include <bits/stdc++.h>
#include <cstdio>

#define print_lst_1x(lst) for (auto el: lst){cout << el << ' ';} cout << endl;
#define print_lst_2x(lst) for (auto el: lst){for (auto zn: el) {cout << zn << ' ';} cout << '\n';} cout << endl;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef std::vector<int> vi;
typedef std::vector<ll> vll;
typedef std::vector<std::vector<int>> vvi;
typedef std::pair<int, int> pii;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
#define ordered_set tree<int, null_type,less_equal<int>, rb_tree_tag,tree_order_statistics_node_update>

using namespace std;

template <typename Ty>
istream& operator>>(istream& is, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        is >> arr[i];
    }
    return is;
}

template <typename Ty>
istream& operator>>(istream& is, std::pair<Ty, Ty>& arr){
    is >> arr.first>>arr.second;
    return is;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i] << " ";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<std::vector<Ty>>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i]<< "\n";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os,std::pair<Ty,Ty>& arr){
        os << arr.first<<" "<<arr.second;
    return os;
}

//   
/*
int solve_q(){
    int n;
    scanf("%d", &n);
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        printf("%d\n", m);
        fflush(stdout);
        int ans;
        scanf("%d", &ans);
        if (ans == 0) {
            return 0;
        }
        if (ans == 1)
            l = m;
        else r = m;
    }
    return 0;
}
 */

//#include "solve_func.hpp"




void solve_gg() {
    int n; cin >> n;
    vi a(n); cin >> a;
    for (int i = 0; i < n; ++i) {
        if (a[i] % 2) {
            cout << "Alice";
            return;
        }
    }
    cout << "Dmitry";
}

vector<vector<int>> points;
vector<vector<int>> temp;
vector<vector<int>> nodes;
vi vis;
bool yes = true;
void dfs(int main, int u,int dist){
    vis[u] = 1;
    temp[main][u] = dist;
    for(auto v : nodes[u]){
        if(vis[v] == 0){
            dfs(main, v, dist + points[u][v]);
        }
    }
}

class DSU
{
private:
    int cnt;
    vector<int> path, rank;
public:
    DSU(int n)
    {
        cnt = n;
        for (int i = 0; i < n; i++) path.push_back(i);
        rank.resize(n);
    }
    int finde(int u)
    {
        if (path[u] == u) return u;
        else return path[u] = finde(path[u]);
    }
    bool all(int a, int b)
    {
        return finde(a) == finde(b);
    }
    void union_set(int a, int b)
    {
        int p1 = finde(a), p2 = finde(b); if (rank[p1] < rank[p2]) std::swap(p1, p2);
        if (p1 == p2) return;
        path[p2] = p1;
        if (rank[p2] == rank[p1]) rank[p1]++;
        cnt--;
    }
    bool full()
    {
        return cnt == 1;
    }

};

class Solution {
public:
    int minCostConnectPoints() {
        int n = points.size();
        priority_queue<vector<int>> deq;
        for (int i = 0; i < points.size(); i++)
            for (int j = i + 1; j < points.size(); j++)
            {
                deq.push({ -(points[i][j]),i,j });
            }
        DSU set(points.size());
        while (!deq.empty())
        {
            auto edge = deq.top(); deq.pop();
            if (!set.all(edge[1], edge[2]))
            {
                int x = edge[1], y = edge[2], ww= edge[0];
                set.union_set(edge[1], edge[2]);
                nodes[edge[1]].push_back(edge[2]);
                nodes[edge[2]].push_back(edge[1]);
            }
        }
        vis.resize(n);
        for(int i  =0; i < n; i ++) {
            vis.assign(vis.size(),0);
            dfs(i, i, 0);
        }
        if(points != temp) yes = false;

    }
};


void solve_k() {
    ll n;
    cin >> n;
    points.resize(n, vi(n));
    nodes.resize(n);
    temp.resize(n, vi(n));
    cin>>points;
    Solution solve;
    solve.minCostConnectPoints();
    cout<<(yes ? "Yes": "No");

}

void solve_hh() {
    string num; cin >> num;
    vector<int> a;
    for (auto c : num) {
        a.push_back(c - '0');
    }
    ll k; cin >> k;

    if (k == 0) {
        cout << num << '\n';
        return;
    }

    ordered_set st;
    int n = (int)a.size();
    st.insert(a[0]);
    int indexlast = n;
    int last = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= *st.find_by_order((int)st.size() - 1))
            st.insert(a[i]);
        else {
            int cnthod = st.size() - st.order_of_key(a[i] + 1);
            if (k >= cnthod) {
                k -= cnthod;
                st.insert(a[i]);
            } else {
                indexlast = i - k;
                last = a[i];
                break;
            }
        }
    }
    string ans;
    for (int i = 0; i < indexlast; ++i)
        ans += to_string(*st.find_by_order(i));
    if (indexlast < n) {
        ans += to_string(last);
        for (int i = indexlast; i < (int)st.size(); ++i)
            ans += to_string(*st.find_by_order(i));
        for (int i = (int)st.size() + 1; i < n; ++i)
            ans += to_string(a[i]);
    }
    cout << ans << '\n';
}


int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve_k();
    }
    return 0;
}