#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
#include <cstdint>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#include <queue>
#include <fstream>
#include <random>
//#include <numbers>
#include <optional>
#include <deque>
#include <sstream>
#include <list>
#include <chrono>
#include <thread>

using namespace std;
using i64 = int64_t;
using ui64 = uint64_t;

#define YN(b) if (b) cout << "Yes\n"; else cout << "No\n";

template<typename T>
istream& operator>>(istream& is, vector<T>& v) { for (auto &e: v) { is >> e; } return is; }

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) { for (auto &e: v) { os << e << " "; } return os; }

template<typename T, typename V>
istream& operator>>(istream& is, pair<T, V>& v) { return is >> v.first >> v.second; }

template<typename T, typename V>
ostream& operator<<(ostream& os, pair<T, V>& v) { return os << v.first << " " << v.second; }

const int64_t md = 1e9+7;

int64_t binpow(int64_t a, int64_t b, int64_t mod = md) {
    int64_t r = 1;
    while (b) {
        if (b & 1) r = ((__int128_t)r * a) % mod;
        a = ((__int128_t)a * a) % mod;
        b >>= 1;
    }
    return r;
}

int dx[4] = {-1, 0, 1, 0};

inline int64_t sqr(int64_t x) {
    return x * x;
}

inline int popcount(int64_t x) {
    int c = 0;
    while (x) c += x & 1, x >>= 1;
    return c;
}

optional<int> dp[65][65][65][65][2];
char was[65][65][65][65][2];

vector<pair<char, char>> kor = {{-1, -1}, {-1, 0}, {-1, 1}, {0, 1}, {0, -1}, {1, 1}, {1, 0}, {1, -1}};
vector<pair<char, char>> wiz = {{0, -1}, {-1, 0}, {1, 0}, {0, 1}};
vector<pair<char, char>> cam = {{-1, -3}, {1, -3}, {-3, -1}, {3, -1}, {-3, 1}, {3, 1}, {-1, 3}, {1, 3}};
pair<char, char> get(char x) {
    return {x >> 3, x & 7};
}

int to(char x, char y) {
    return (x << 3) + y;
}

vector<vector<pair<char, char>>> hod = {kor, wiz, cam};
char avail[8][8];

void fill(char pos, int type) {
    if (pos == 64) return;
    auto p = get(pos);
    //avail[p.first][p.second] = 1;
    for (auto &e: hod[type]) {
        int ni = p.first + e.first;
        int nj = p.second + e.second;
        if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
        avail[ni][nj] = 1;
    }
}

string pr(int x) {
    if (x == 64) {
        return "#";
    }
    stringstream ss;
    ss << (char)('a' + x / 8);
    ss << 1 + (x % 8);
    return ss.str();
}

optional<int> rec(char b_kor, char w_kor, char w_cam, char w_wiz, char turn, int foo) {
    cout << pr(b_kor) << " " << pr(w_kor) << " " << pr(w_cam) << " " << pr(w_wiz) << " " << turn << "\n";

    if (foo > 1000) {
        return {};
    }
    if (was[b_kor][w_kor][w_cam][w_wiz][turn]) {
        return std::nullopt;
    }
    if (dp[b_kor][w_kor][w_cam][w_wiz][turn]) {
        return *dp[b_kor][w_kor][w_cam][w_wiz][turn];
    }
    was[b_kor][w_kor][w_cam][w_wiz][turn] = 1;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            avail[i][j] = 0;
        }
    }
    if (turn == 0) {
        fill(w_kor, 0);
        fill(w_wiz, 1);
        fill(w_cam, 2);
        vector<char> available;
        {
            auto kor_p = get(b_kor);
            bool shah = avail[kor_p.first][kor_p.second];
            for (auto &e: hod[0]) {
                char ni = kor_p.first + e.first;
                char nj = kor_p.second + e.second;
                if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
                if (avail[ni][nj]) {
                    continue;
                }
                auto v = to(ni, nj);
                if (v == w_kor) {
                    continue;
                }
                available.emplace_back(v);
            }
            if (shah && available.empty()) {
                was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
                return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = 0);
            }
            if (available.empty()) {
                was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
                return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = 1e9);
            }
        }
        optional<int> ans;
        for (auto &e: available) {
            auto r = rec(e, w_kor, e == w_cam ? 64 : w_cam, e == w_wiz ? 64 : w_wiz, 1, foo + 1);
            if (r && (!ans || 1 + *r < *ans)) {
                ans = 1 + *r;
            }
        }
        was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
        return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = ans);
    }
    optional<int> ans;
    fill(b_kor, 0);fasfas
    for (auto [pos, t]: vector<pair<char, char>>{{w_kor, 0}, {w_wiz, 1}, {w_cam, 2}}) {
        if (pos == 64) continue;
        auto p = get(pos);
        for (auto &e: hod[t]) {
            char ni = p.first + e.first;
            char nj = p.second + e.second;
            if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
            auto ps = to(ni, nj);
            if (ps == b_kor) {
                continue;
            }
            if (t == 0 && avail[ni][nj]) { // beaten by enemy king
                continue;
            }
            optional<int> curr_ans;
            if (t == 0) {
                curr_ans = rec(b_kor, ps, w_cam, w_wiz, 0, foo + 1);
            } else if (t == 1) {
                curr_ans = rec(b_kor, w_kor, w_cam, ps, 0, foo + 1);
            } else {
                curr_ans = rec(b_kor, w_kor, ps, w_wiz, 0, foo + 1);
            }
            if (curr_ans && (!ans || *ans > 1 + *curr_ans)) {
                ans = 1 + *curr_ans;
            }
        }
    }

    was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
    return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = ans);
}

int pos(const string& s) {
    return (s[0] - 'a') * 8 + (s[1] - '1');
}

signed main() {
    /*ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/
    int t;
    cin >> t;
    while (t--) {
        string w_kor, b_kor, w_cam, w_wiz, turn;
        cin >> w_kor >> b_kor >> w_cam >> w_wiz >> turn;;
        auto res = rec(pos(b_kor), pos(w_kor), pos(w_cam), pos(w_wiz), turn == "w", 0);
        if (!res) {
            cout << "0\n";
        } else {
            cout << *res << "\n";
        }
    }
}
