#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
#include <cstdint>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#include <queue>
#include <fstream>
#include <random>
//#include <numbers>
#include <optional>
#include <deque>
#include <sstream>
#include <list>
#include <chrono>
#include <thread>

using namespace std;
using i64 = int64_t;
using ui64 = uint64_t;

#define YN(b) if (b) cout << "Yes\n"; else cout << "No\n";

template<typename T>
istream& operator>>(istream& is, vector<T>& v) { for (auto &e: v) { is >> e; } return is; }

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) { for (auto &e: v) { os << e << " "; } return os; }

template<typename T, typename V>
istream& operator>>(istream& is, pair<T, V>& v) { return is >> v.first >> v.second; }

template<typename T, typename V>
ostream& operator<<(ostream& os, pair<T, V>& v) { return os << v.first << " " << v.second; }

const int64_t md = 1e9+7;

int64_t binpow(int64_t a, int64_t b, int64_t mod = md) {
    int64_t r = 1;
    while (b) {
        if (b & 1) r = ((__int128_t)r * a) % mod;
        a = ((__int128_t)a * a) % mod;
        b >>= 1;
    }
    return r;
}

int dx[4] = {-1, 0, 1, 0};

inline int64_t sqr(int64_t x) {
    return x * x;
}

inline int popcount(int64_t x) {
    int c = 0;
    while (x) c += x & 1, x >>= 1;
    return c;
}

vector<vector<char>> wu = {
    {1, 1, 1, 0, 1, 1, 1},
    {0, 0, 1, 0, 0, 1, 0},
    {1, 0, 1, 1, 1, 0, 1},
    {1, 0, 1, 1, 0, 1, 1},
    {0, 1, 1, 1, 0, 1, 0},
    {1, 1, 0, 1, 0, 1, 1},
    {1, 1, 0, 1, 1, 1, 1},
    {1, 0, 1, 0, 0, 1, 0},
    {1, 1, 1, 1, 1, 1, 1},
    {1, 1, 1, 1, 0, 1, 1}
};

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string S, T;
    cin >> S >> T;
    vector<int> nm;
    for (int i = 99; i > 0; --i) {
        int f = i / 10;
        int s = i % 10;
        auto ff = f ? wu[f] : vector<char>(7);
        auto ss = wu[s];
        for (int j = 0; j < 7; ++j) {
            if (S[j] == '0') ff[j] = 0;
            if (T[j] == '0') ss[j] = 0;
        }
        int g1 = f ? -1 : 0, g2 = -1;
        for (int k = 0; k < wu.size(); ++k) {
            if (wu[k] == ff) g1 = k;
            if (wu[k] == ss) g2 = k;
        }
        if (g1 == -1 || g2 == -1) {
            nm.emplace_back(-1);
            continue;
        }
        int num = g1 * 10 + g2;
        nm.emplace_back(num);
    }
    int prev = -1;
    int len = 0, max_len = 0;
    for (auto &e: nm) {
        if (e == prev + 1) {
            ++len;
        } else {
            len = 0;
        }
        prev = e;
        max_len = max(max_len, len);
    }
    cout << max_len << "\n";
}
