#include <bits/stdc++.h>

// #define FSTREAM
// #define MULTITEST

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    size_t n;
    cin >> n;
    bool used[26];
    for (char ch = 'a'; ch <= 'z'; ++ch) {
        used[ch - 'a'] = false;
    }
    for (size_t i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if ('a' <= s[0] && s[0] <= 'z') {
            used[s[0] - 'a'] = true;
        }
    }
    int cnt = 0;
    for (char ch = 'a'; ch <= 'z'; ++ch) {
        if (used[ch - 'a']) {
            cout << ch;
        } else {
            cout << '.';
        }
        cnt++;
        if (cnt % 6 == 0) {
            cout << '\n';
        }
    }
}

signed main() {
#ifdef FSTREAM
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
#ifdef MULTITEST
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}