m1 = input()
m2 = input()

pic_to_num = {
    '1110111': 0,
    '0010010': 1,
    '1011101': 2,
    '1011011': 3,
    '0111010': 4,
    '1101011': 5,
    '1101111': 6,
    '1010010': 7,
    '1111111': 8,
    '1111011': 9
}

num_to_pic = list(pic_to_num.keys())

def apply_mask(m, s):
    ans = ''
    for c1, c2 in zip(s, m):
        if c1 == '1' and c2 == '1':
            ans += '1'
        else:
            ans += '0'
    return ans

cnt = -1
best_cnt = 0
last_num = -2
for i in range(99, 0, -1):
    x1 = i // 10
    x2 = i % 10
    s1 = '0000000' if x1 == 0 else apply_mask(m1, num_to_pic[x1])
    s2 = apply_mask(m2, num_to_pic[x2])
    if (s1 not in pic_to_num and s1 != '0000000') or s2 not in pic_to_num or (s1 in pic_to_num and pic_to_num[s1] == 0):
        best_cnt = max(best_cnt, cnt)
        cnt = -1
        last_num = -2
        continue
    y1 = 0 if s1 == '0000000' else pic_to_num[s1]
    next_num = y1 * 10 + pic_to_num[s2]
    if next_num == last_num + 1:
        cnt += 1
        last_num = next_num
    else:
        best_cnt = max(best_cnt, cnt)
        cnt = 0
        last_num = next_num
print(max(cnt, best_cnt))
