def calculate_ways(r, b, g, last_color):
    if min(r, b, g) < 0:
        return 0
    if r == b == g == 0:
        return 1

    ways = 0
    if last_color == 'r':
        ways += calculate_ways(r, b - 1, g, 'b') + calculate_ways(r, b, g - 1, 'g')
    elif last_color == 'b':
        ways += calculate_ways(r - 1, b, g, 'r') + calculate_ways(r, b, g - 1, 'g')
    elif last_color == 'g':
        ways += calculate_ways(r - 1, b, g, 'r') + calculate_ways(r, b - 1, g, 'b')

    return ways

def total_ways(r, b, g):
    return (
        calculate_ways(r - 1, b, g, 'r') +
        calculate_ways(r, b - 1, g, 'b') +
        calculate_ways(r, b, g - 1, 'g')
    )

if __name__ == '__main__':
    r, b, g = map(int, input().split())
    print(total_ways(r, b, g))
