#include <bits/stdc++.h>

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
  in >> v.first >> v.second;
  return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
  out << v.first << ' ' << v.second;
  return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { in >> v[i]; }
  return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { out << v[i] << ' '; }
  return out;
}

void solve() {
  int n; cin >> n;
  int min_x = INT_MAX;
  int max_x = INT_MIN;
  vector<int> ys;
  ys.reserve(n);
  for (int i = 0; i < n; ++i) {
    int x, y; cin >> x >> y;
    if (y == 0) {
      min_x = min(x, min_x);
      max_x = max(x, max_x);
    } else {
      ys.push_back(abs(y));
    }
  }
  if (min_x == max_x || min_x == INT_MAX || max_x == INT_MIN) {
    cout << 0;
    return;
  }
  int max_s = 0;
  int a = max_x - min_x;
  for (auto y : ys) {
    max_s = max(a * y, max_s);
  }
  ld res = static_cast<ld>(max_s) / 2.0;
  cout << res;
}

int main() {
  ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);
  std::cout.precision(10);
  std::cout.setf(std::ios::fixed);
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  int t = 1;
  //cin >> t;
  while (t-- > 0) {
    solve();
  }
  return 0;
}
