#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2")

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    string s;
    int k;
    queue<int> q;

    cin >> s >> k;
    if (k == 0) {
        cout << s;
        return;
    }
    for (int x = '9'; x >= '1'; --x) {
        for (int i = 0; i < s.length(); ++i) {
            if (s[i] == x) q.push(i);
        }
        while (!q.empty()) {
            for (int i = 0; i < s.length() - 1; ++i) {
                if (s[i + 1] < s[i]) {
                    --k;
                    swap(s[i], s[i + 1]);
                }
                if (k == 0) {
                    cout << s;
                    return;
                }
            }
            q.pop();
            if (x == '1' && q.size() == 1) {
                cout << s;
                return;
            }
        }
    }
    cout << s;
    return;
}

int main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << endl;
    }

    return 0;
}
