import java.util.ArrayList;
import java.util.Scanner;

public class Main{
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        scanner.nextLine();

        ArrayList<int[]> onx = new ArrayList<>();
        ArrayList<int[]> ony = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            String str = scanner.nextLine();
            String[] parts = str.split(" ");
            int x = Integer.parseInt(parts[0]);
            int y = Integer.parseInt(parts[1]);

            if (y == 0){
                onx.add(new int[]{x,y});
            }
            else {
                ony.add(new int[]{x,y});
            }
        }

        double maxArea = 0;
        int countX = onx.size();
        int countY = ony.size();

        if (countX >= 2 && countY >= 1){
            for (int i = 0; i < countX; i++) {
                for (int j = i + 1; j < countX; j++) {
                    int[] p1 = onx.get(i);
                    int[] p2 = onx.get(j);

                    for (int[] k : ony) {
                        int x1 = p1[0], y1 = p1[1];
                        int x2 = p2[0], y2 = p2[1];
                        int x3 = k[0], y3 = k[1];

                        double area = 0.5 * Math.abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2));
                        maxArea = Math.max(maxArea, area);
                    }
                }
            }
        }
        System.out.println(maxArea);
    }
}