#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <time.h>
#include <map>
#include <set>
#include <cstring>
#include <conio.h>

using namespace std;

int main(){

    int n;
    cin >> n;
    vector <vector<int>> mt(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> mt[i][j];
        }
    }

    bool mtDer = true;

    for (int i = 0; i < n; ++i) {
        if (mt[i][i] != 0) {
            mtDer = false;
            break;
        }
        for (int j = 0; j < n; ++j) {
            if (mt[i][j] != mt[j][i]) {
                mtDer = false;
                break;
            }
            if (i != j && mt[i][j] <= 0) {
                mtDer = false;
                break;
            }
        }
        if (!mtDer) break;
    }

    if (mtDer) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    if (i != j && j != k && i != k) {
                        if (mt[i][j] + mt[j][k] < mt[i][k]) {
                            mtDer = false;
                            break;
                        }
                    }
                }
                if (!mtDer) break;
            }
            if (!mtDer) break;
        }
    }

    if (mtDer) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }


    return 0;
}
