

// &#127850;&#127850;&#127850;

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = 2e5 + 23;
const int INF = 1e9 + 23;
const ll BIGINF = 1e17 + 23;
const int MOD = 1e9 + 7;
const int MAX_LOG = 26;

// #define SINGLE_TEST
// #define ULTRA_MEGA_COOL_RAND
#define int long long
// #define PRAGM
#define all(x) x.begin(), x.end()
#define pb push_back
#define help                          \
    ios_base::sync_with_stdio(false); \
    cin.tie(nullptr);
#define me cout.tie(nullptr);
#define fileIO(x)                                     \
    freopen(((string)x + ".in").c_str(), "r", stdin); \
    freopen(((string)x + ".out").c_str(), "w", stdout);
#ifdef PRAGM
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,tune=native")
#endif

int smartGcd(int a, int b)
{
    if (a == -1)
        return b;
    if (b == -1)
        return a;
    return __gcd(a, b);
}

int interact(int x)
{
    cout << x << endl;
    cout.flush();
    int res;
    cin >> res;
    return res;
}

inline void solve()
{
    string s;
    cin >> s;
    int k;
    cin >> k;
    int n = s.size();

    map<char, set<int>> indexes;
    for (char c = '0'; c <= '9'; ++c)
    {
        indexes[c] = set<int>();
    }

    for (int i = 0; i < n; ++i)
    {
        indexes[s[i]].insert(i);
    }

    string ans;
    for (int i = 0; i < n && k; ++i)
    {
        for (char c = '0'; c <= '9'; ++c)
        {
            if (!indexes[c].empty())
            {
                int min_index = *indexes[c].begin();
                if (min_index - i <= k)
                {
                    k -= min_index - i;
                    ans += c;
                    indexes[c].erase(min_index);
                    break;
                }
            }
        }
    }

    while (ans.size() < n)
    {
        int next_index = n;
        char next_char = '0';
        for (char c = '0'; c <= '9'; ++c)
        {
            if (indexes[c].empty())
                continue;

            int cur_index = *indexes[c].begin();
            if (cur_index < next_index)
            {
                next_index = cur_index;
                next_char = c;
            }
        }
        ans += next_char;
        indexes[next_char].erase(next_index);
    }

    cout << ans << '\n';
}

signed main()
{
    // freopen("b2.txt", "r", stdin);
    help me

#ifdef ULTRA_MEGA_COOL_RAND
        srand(clock());
#endif

    int cases = 1;
#ifndef SINGLE_TEST
    cin >> cases;
#endif
    while (cases--)
        solve();
    return 0;
}
