#include <iostream>
//#include "optimization.h"
#include <vector>
#include <utility>
#include <map>
#include <string>
#include <set>
#include <unordered_set>
#include <stack>
#include <cmath>
#include <iomanip>
#include <queue>
#include <iterator>
//#include <algorithm>
#include <unordered_map>
#include <deque>
#include <cstdlib>
#include <numeric>
#include <functional>

using namespace std;
#define int long long

//#define int __int128_t
#define INT128_MIN (-INF - 1)
#define INTMAX 2147483647
//#define MAX 10001
//#define INF 1e14
const int MAX = 1e5+1;
//const int INF = 2e17;

//void dfs(int v, int p ) {
//    if (colors[v])
//        return;
//    time_now++;
//    colors[v] = color;
//    time_in[v] = time_now;
//    up[v][0] = p;
//    for (int i = 1; i <= k; i++)
//        up[v][i] = up[up[v][i - 1]][i - 1];
//    for (int i: g[v]) if (i != p)
//            dfs(i, v);
//    time_now++;
//    time_out[v] = time_now;
//}
//
//bool is_ancestor(int u, int v) {
//    return time_in[u] <= time_in[v] && time_out[u] >= time_out[v];
//}


#include <iomanip>

struct Point {
    int x, y;
};

signed main() {
#ifdef LOCAL
    freopen("main.in", "r", stdin);
#endif
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n;
    cin >> n;

    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    int maxYPoint = 0;

    Point minXPoint = {1001, 0};
    Point maxXPoint = {-1001, 0};

    for (const auto& p : points) {
        if (p.y == 0) {
            if (p.x < minXPoint.x) minXPoint = p;
            if (p.x > maxXPoint.x) maxXPoint = p;
        }
        if (abs(p.y) > abs(maxYPoint)) {
            maxYPoint = abs(p.y);
        }
    }

    if (minXPoint.x == 1001 || maxXPoint.x == -1001 || maxYPoint == 0) {
        cout << "0" << endl;
        return 0;
    }

    double maxArea = maxYPoint * (maxXPoint.x -  minXPoint.x);
    maxArea /= 2;
    std::cout << std::fixed << std::setprecision(10) << maxArea << std::endl;
    return 0;
}