#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();
        for (int i = 0; i < n && k > 0; ++i) {
            int min_pos = i;
            for (int j = i + 1; j < n && j - i <= k; ++j) {
                if (s[j] < s[min_pos]) {
                    min_pos = j;
                }
            }
            if (min_pos != i) {
                char min_char = s[min_pos];
                for (int j = min_pos; j > i; --j) {
                    s[j] = s[j - 1];
                }
                s[i] = min_char;
                k -= min_pos - i;
            }
        }
        cout << s << '\n';
    }
    return 0;
}