#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<bool> presence(26, false);
    
    for (int i = 0; i < n; ++i) {
        string program;
        cin >> program;
        char first_letter = program[0];
        presence[first_letter - 'a'] = true;
    }
    
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 6; ++j) {
            int index = i * 6 + j;
            if (index < 26) {
                cout << (presence[index] ? (char)('a' + index) : '.');
            } else {
                cout << '.';
            }
        }
        cout << "\n";
    }

    for (int j = 0; j < 2; ++j) {
        int index = 24 + j;
        if (index < 26) {
            cout << (presence[index] ? (char)('a' + index) : '.');
        } else {
            cout << '.';
        }
    }
    cout << "\n";

    return 0;
}
