def find_min_number(s, k):
    n = len(s)
    s = list(map(int, list(s)))

    if k >= n * (n - 1) // 2:
        return ''.join(map(str, sorted(s)))

    available = s.copy()
    result = ['0'] * n
    remaining_k = k

    for pos in range(n):
        min_moves = float('inf')
        min_digit = float('inf')
        min_digit_pos = -1

        for j in range(n):
            if available[j] == -1:
                continue

            moves = abs(j - pos)

            if moves <= remaining_k:
                if available[j] < min_digit or (available[j] == min_digit and moves < min_moves):
                    min_digit = available[j]
                    min_moves = moves
                    min_digit_pos = j

        if min_digit_pos != -1:
            result[pos] = str(min_digit)
            available[min_digit_pos] = -1
            remaining_k -= min_moves
        else:
            for j in range(n):
                if available[j] != -1:
                    result[pos] = str(available[j])
                    available[j] = -1
                    break

    return ''.join(result)


t = int(input())

for _ in range(t):
    s, k = input().split()
    k = int(k)
    print(find_min_number(s, k))