#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

int main() {
    int n;
    std::cin >> n;
    std::cin.ignore();
    std::vector<std::string> words;
    std::string input;

    for (int i = 0; i < n; i++) {
        std::getline(std::cin, input);
        words.push_back(input);
    }

    std::set<char> firstLetters;

    for (const auto& word : words) {
        if (!word.empty()) {
            firstLetters.insert(word[0]);
        }
    }

    std::string alphabet = "abcdefghijklmnopqrstuvwxyz";
    std::vector<char> result(26, '.');

    for (int i = 0; i < 22; ++i) {
        char letter = alphabet[i];
        if (firstLetters.find(letter) != firstLetters.end()) {
            result[i] = letter;
        }
    }

    for (int i = 0; i < 26; ++i) {
        if (i == 6 || i == 12 || i == 18 || i == 24) {
            std::cout << std::endl;
        }
        std::cout << result[i];
    }
    std::cout << std::endl;

    return 0;
}
