
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>


typedef long long ll;
using namespace std;
string alph = "abcdefghijklmnopqrstuvwxyz";

/*
aba
aaaaaba
*/
//struct node {
//    ll ans, left, right, sum;
//};
//
//vector<node> tree;
//vector<int> a;
//
//void build(int v, int l, int r) {
//    if (l + 1 == r) {
//        tree[v] = { max(a[l], 0), a[l], a[l], a[l] };
//        return;
//    }
//    int m = (l + r) / 2;
//    build(2 * v + 1, l, m);
//    build(2 * v + 2, m, r);
//    tree[v].ans = max(max(tree[2 * v + 1].ans, tree[2 * v + 2].ans), tree[2 * v + 1].right + tree[2 * v + 2].left);
//    tree[v].left = max(tree[2 * v + 1].left, tree[2 * v + 1].sum + tree[2 * v + 2].left);
//    tree[v].right = max(tree[2 * v + 2].right, tree[2 * v + 2].sum + tree[2 * v + 1].right);
//    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
//}
//
//void upd(int v, int l, int r, int pos, int x) {
//    if (l + 1 == r) {
//        tree[v] = { max(x, 0), x, x, x };
//        return;
//    }
//    int m = (l + r) / 2;
//    if (pos < m)
//        upd(2 * v + 1, l, m, pos, x);
//    else
//        upd(2 * v + 2, m, r, pos, x);
//    tree[v].ans = max(max(tree[2 * v + 1].ans, tree[2 * v + 2].ans), tree[2 * v + 1].right + tree[2 * v + 2].left);
//    tree[v].left = max(tree[2 * v + 1].left, tree[2 * v + 1].sum + tree[2 * v + 2].left);
//    tree[v].right = max(tree[2 * v + 2].right, tree[2 * v + 2].sum + tree[2 * v + 1].right);
//    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
//}
//
//node get(int v, int l, int r, int ql, int qr) {
//    if (l >= qr || r <= ql)
//        return { 0, 0, 0, 0 };
//    if (l >= ql && r <= qr) {
//        return tree[v];
//    }
//    int m = (l + r) / 2;
//    node x, x1 = get(2 * v + 1, l, m, ql, qr), x2 = get(2 * v + 2, m, r, ql, qr);
//    x.ans = max(max(x1.ans, x2.ans), x1.right + x2.left);
//    x.left = max(x1.left, x1.sum + x2.left);
//    x.right = max(x2.right, x2.sum + x1.right);
//    x.sum = x1.sum + x2.sum;
//    return x;
//}
//
//vector<int> p;
//vector<int> sz;
//
//int get(int v) {
//    if (p[v] == v)
//        return v;
//    return p[v] = get(p[v]);
//}
//
//void unite(int a, int b) {
//    a = get(a);
//    b = get(b);
//    if (a == b)
//        return;
//    if (sz[a] > sz[b]) {
//        a = a ^ b;
//        b = a ^ b;
//        a = a ^ b;
//    }
//    p[a] = b;
//    sz[b] += sz[a];
//}

struct point {
    int x, y;
};

vector<vector<int>> c;
vector<int> a, b;

int eq(vector<int> a, vector<int> b) {
    int f = 1;
    for (int i = 0; i < 7; i++) {
        if (a[i] != b[i]) {
            f = 0;
            break;
        }
    }
    return f;
}

int trans(int cur) {
    vector<int> one(7), two(7);
    int f = cur / 10, s = cur % 10;
    one = c[f];
    two = c[s];
    if (f == 0) {
        for (int i = 0; i < 7; i++)
            one[i] = 0;
    }
    for (int i = 0; i < 7; i++) {
        if (a[i] == 0)
            one[i] = 0;
    }
    for (int i = 0; i < 7; i++) {
        if (b[i] == 0)
            two[i] = 0;
    }
    int ansf = -2, anss = -2;
    for (int i = 0; i < 10; i++) {
        if (eq(one, c[i])) {
            ansf = i;
            break;
        }
    }
    for (int i = 0; i < 10; i++) {
        if (eq(two, c[i])) {
            anss = i;
            break;
        }
    }
    vector<int> emp = { 0, 0, 0, 0, 0, 0, 0 };
    if (eq(emp, one)) {
        return anss;
    }
    if (ansf == -2 || anss == -2) 
        return -2;
    return ansf * 10 + anss;
}

void solve() {
    c.resize(10);
    c[0] = { 1, 1, 1, 0, 1, 1, 1 };
    c[1] = { 0, 0, 1, 0, 0, 1, 0 };
    c[2] = { 1, 0, 1, 1, 1, 0, 1 };
    c[3] = { 1, 0, 1, 1, 0, 1, 1 };
    c[4] = { 0, 1, 1, 1, 0, 1, 0 };
    c[5] = { 1, 1, 0, 1, 0, 1, 1 };
    c[6] = { 1, 1, 0, 1, 1, 1, 1 };
    c[7] = { 1, 0, 1, 0, 0, 1, 0 };
    c[8] = { 1, 1, 1, 1, 1, 1, 1 };
    c[9] = { 1, 1, 1, 1, 0, 1, 1 };
    string s1, s2;
    cin >> s1 >> s2;
    for (int i = 0; i < 7; i++) {
        a.push_back((int)s1[i] - 48);
        b.push_back((int)s2[i] - 48);
    }
    vector<int> t(100);
    for (int i = 0; i < 100; i++) {
        t[i] = trans(i);
    }
    int mx = 0, cur = 0;
    for (int i = 98; i >= 0; i--) {
        if (t[i] == t[i + 1] + 1)
            cur++;
        else
            cur = 0;
        mx = max(mx, cur);
    }
    cout << mx;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();

}