#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool isValidRACI(const vector<string>& matrix) {
    for (const string& row : matrix) {
        int countA = 0;
        int countR = 0;

        for (char c : row) {
            switch (c) {
                case 'A':
                case 'a':
                    countA++;
                    break;
                case 'R':
                case 'r':
                    countR++;
                    break;
            }
        }

        if (countA != 1) {
            return false;
        }
    return true;
}

int main() {
    int n, m;
    cin >> n >> m;
    cin.ignore(); 

    vector<string> matrix(n);
    for (int i = 0; i < n; ++i) {
        getline(cin, matrix[i]);
    }

    if (isValidRACI(matrix)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

    return 0;
}
