#define GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

const long long mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

void solve() {
    int n; cin >> n;
    set<char> c;
    for (int i = 0; i < n; ++i)
    {
        string s; cin >> s;
        for (int i = 0; i < 1; ++i)
        {
            c.insert(s[i]);
        }
    }
    vector<char> ans(26, '.');

    for (int i = 0; i < 26; ++i)
    {
        if(c.count(i+'a')){
            ans[i] = i + 'a';
        }
    }
    for (int i = 0; i < 26; ++i)
    {
        cout << ans[i];
        if(i!=0 && i%6==5) cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t--) solve();
}
