#include <iostream>
#include <string>
#include <vector>

using namespace std;

string check(string s, long long k) {
    int n = s.length();
   
    for (int i = 0; i < n; ++i) {
        if (k <= 0) break; 

     
        char min_char = s[i];
        int min_pos = i;

        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < min_char) {
                min_char = s[j];
                min_pos = j;
            }
        }

  
        if (min_pos != i) {
      
            long long swaps_needed = min_pos - i;

       
            if (swaps_needed <= k) {
       
                for (int j = min_pos; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
            
                k -= swaps_needed;
            }
        }
    }

    return s;
}

int main() {
    int t;
    cin >> t;
    while (t>0) {
        string s;
        long long k;
        cin >> s >> k;

        cout << check(s, k) << "\n"; 
        t--;
    }
    return 0;
}

