#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;

#define eb emplace_back

int n;
vector<vector<int>> d;
vector<vector<ii>> g;
vector<bool> used;
set<array<int, 3>> s;

bool dfs(int v, int p, int c, int h = 0) {
    if (d[c][v] != h)
        return false;
    for (auto [u, w] : g[v]) {
        if (u == p)
            continue;
        if (!dfs(u, v, c, h + w))
            return false;
    }
    return true;
}

bool hui() {
    auto [w, v, u] = *s.begin();
    s.erase(s.begin());
    if (used[u])
        return true;
    used[u] = true;
    g[u].eb(v, w);
    g[v].eb(u, w);
    if (!dfs(u, u, u))
        return false;
    for (int i = 0; i < n; ++i) {
        if (i == u)
            continue;
        s.insert({d[u][i], u, i});
    }
    return true;
}

void solve() {
    cin >> n;
    g.resize(n);
    d.assign(n, vector<int> (n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];
        }
    }
    used.assign(n, false);
    used[0] = true;
    for (int i = 1; i < n; ++i) {
        s.insert({d[0][i], 0, i});
    }
    while (!s.empty()) {
        if (!hui()) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
