#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

int size_ = 0;

void push(vector<int> &t, int x)
{
    t[2 * x + 1] += t[x];
    t[2 * x + 2] += t[x];
    t[x] = 0;
}

int get(vector<int> &t, int i, int x, int tl, int tr)
{
    if (tr - tl == 1)
    {
        return t[x];
    }

    push(t, x);
    int tm = (tl + tr) / 2;
    if (i < tm) return get(t, i, 2 * x + 1, tl, tm);
    return get(t, i, 2 * x + 2, tm, tr);
}

void add(vector<int> &t, int l, int r, int val, int x, int tl, int tr)
{
    if (r <= tl || l >= tr) return;
    if (l <= tl && r >= tr)
    {
        t[x] += val;
        return;
    }

    push(t, x);
    int tm = (tl + tr) / 2;
    add(t, l, r, val, 2 * x + 1, tl, tm);
    add(t, l, r, val, 2 * x + 2, tm, tr);
}

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int ptr[10];

    int tt;
    cin >> tt;
    while (tt--)
    {
        string s;
        long long k;
        cin >> s >> k;

        vector<vector<int>> digits(10);
        for (int i = 0; i < 10; ++i)
        {
            ptr[i] = 0;
        }

        for (int i = 0; i < s.size(); ++i)
        {
            digits[s[i] - '0'].push_back(i);
        }

        string ans = "";
        size_ = s.size();
        vector<int> t(4 * size_, 0);

        for (int i = 0; i < s.size(); ++i)
        {
            for (int j = 1; j < 10; ++j)
            {
                if (ptr[j] < digits[j].size())
                {
                    int pos = digits[j][ptr[j]] + get(t, digits[j][ptr[j]], 0, 0, size_);
                    if (pos - i <= k)
                    {
                        k -= pos - i;
                        ans += char('0' + j);
                        add(t, 0, digits[j][ptr[j]], 1, 0, 0, size_);
                        ++ptr[j];
                        break;
                    }
                }
            }
        }

        cout << ans << endl;
    }
}