#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef map<int, int> mii;
typedef priority_queue<int> pqi;
typedef pair<int, int> pii;

#define mod(A, B) (((A) % (B) + B) % (B))

const int MOD1 = 998244353;
const int MOD2 = 1000013011;
const int BASE1 = 100003;
const int BASE2 = 31;
const ll LINF = 2e18;
const int INF = 2e9;
const int SIZE = 1e7;
const ld EPS = 5e-10;

int n;
vector<vector<pii>> g;
vector<ll> dist;
vector<bool> used;

void solve() {
  cin >> n;
  vector<vi> m(n, vi(n));
  for(int i=0; i<n; ++i) {
    for(int j=0; j<n; ++j) {
      cin >> m[i][j];
    }
  }
  for(int i=0; i<n; ++i) {
    for(int j=i + 1; j<n; ++j) {
      for(int k=j+1; k<n; ++k) {
        if(m[i][j] + m[j][k] < m[i][k]) {
          cout << "No\n";
          return;
        }
      }
    }
  }
  cout << "Yes\n";
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  int tt = 1;
  // cin >> tt;
  for (int i = 0; i < tt; ++i)
    solve();
}