#include <algorithm>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <vector>
using namespace std;
#define int long long
#define M9 2286661337LL
#define mod 998244353
#define INF (M9 * M9)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define eps 1e-6

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
// int get_rnd(int l, int r) { return rnd() % (r - l + 1) + l; }

void solve() {

  int n; cin >> n;
  vector<int> oY;
  vector<int> oX;
  for(int i = 0; i < n; i++){
    int x, y; cin >> x >> y;
    if (y == 0) {
      oX.emplace_back(x);
    } else {
      oY.emplace_back(abs(y));
    }
  }

  if (oX.size() < 2) {
    std::cout << 0;
    return;
  }

  sort(ALL(oX));
  sort(ALL(oY));

  double a = (oX.back() - oX.front());
  double h = (oY.back());
  double ans = a*h/2;

  std::cout << fixed << setprecision(4);
  std::cout << ans;

}

signed main() {
#ifdef LOCAL_ARTEM
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
//  cin >> t;
  while (t--)
    solve();

#ifdef LOCAL_ARTEM
  cout << '\n'
       << fixed << setprecision(3) << 1. * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
  return 0;
}
