#include <algorithm>
#include <fstream>
#include <iostream>
#include <set>
#include <utility>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

int main() {
  int n;
  vector<int> h;

  cin >> n;
  h.resize(n);
  for (int i = 0; i < n; i++) {
    cin >> h[i];
  }
  sort(h.begin(), h.end());
  int prev = 0;
  int res = 0;

  for (int i = 0; i < n; i++) {
    int cur = h[i] - prev;
    if (cur % 2 != 0) {
      res ^= n - i;
    }
    prev = h[i];
  }
  
  if (res == 0) {
    cout << "Dmitry\n";
  } else {
    cout << "Alice\n";
  }
}