#include <bits/stdc++.h>

#define fastIO cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define rep(i, a, b) for (int i = a; i < b; i++)
#define full(vec) vec.begin(), vec.end()
#define eb emplace_back
#define pb push_back
#define fr first
#define sc second

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

typedef vector <ll> vl;
typedef vector <vector <ll>> vvl;

const ld EPS = 1e-9;
const ll P = 307;
const ld PI = acos(-1);

template<class T>
istream &operator>>(istream &input, vector<T>& v) {
    for (auto &i : v) {
        input >> i;
    }
    return input;
}

template<class T>
ostream &operator<<(ostream &output, vector<T>& v) {
    for (auto &i : v) {
        output << i << ' ';
    }
    return output;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void cok(bool t) { cout << (t ? "YES" : "NO") << '\n'; }

#define bits_s(a) bitset<64>(a).to_string()
string bits(ll m) {
    string s = bits_s(m);
    //reverse(full(s));
    return s;
}

const ll N = 2e5 + 10;
const ll MAXN = 1e16;
const ll MOD = 1e9 + 7;

struct pnt{
    int x, y;
};

int mult(pnt i, pnt j) {
    return i.x * j.y - i.y * j.x;
}

pnt mns(pnt i, pnt j) {
    return {i.x - j.x, i.y - j.y};
}

bool cmp(pair <int, int> i, pair <int, int> j) {
    if (i.second != j.second) {
        return i.second < j.second;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector <pnt> vc(n);
    vector <pair <int, int>> zero;
    for (int i = 0; i < n; i++) {
        cin >> vc[i].x >> vc[i].y;
        if (vc[i].y == 0) {
            zero.push_back({i, vc[i].x});
        }
    }
    sort(zero.begin(), zero.end(), cmp);
    int ans = 0;

    for (int i = 0; i < n; i++) {
        auto p1 = vc[i];
        for (int j = 0; j < n; j++) {
            auto p2 = vc[j];
            if (i == j) {
                continue;
            }
            if (!(p1.y == 0 && p2.y != 0)) {
                continue;
            }
            //cout << i << ' ' << j << endl;
            if (zero[0].first != i) {
                ans = max(ans, mult(mns(p1, {zero[0].second, 0}), mns(p2, {zero[0].second, 0})));
            }
            if (zero[zero.size() - 1].first != i) {
                ans = max(ans, mult(mns(p1, {zero[zero.size() - 1].second, 0}), mns(p2, {zero[zero.size() - 1].second, 0})));
            }
        }
    }
    cout << ans / 2.0 << endl;
}

signed main() {
    fastIO
    auto start_time = chrono::high_resolution_clock::now();
    ll _ = 1;
    cout.precision(10);
    cout << fixed;
    // cin >> _;
    while (_--) {
        solve();
    }
    auto end_time = chrono::high_resolution_clock::now();
    //cerr << "Execution time: " << chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
    return 0;
}
