#include <bits/stdc++.h>

#define fastIO cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define rep(i, a, b) for (int i = a; i < b; i++)
#define full(vec) vec.begin(), vec.end()
#define eb emplace_back
#define pb push_back
#define fr first
#define sc second

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

typedef vector <ll> vl;
typedef vector <vector <ll>> vvl;

const ld EPS = 1e-9;
const ll P = 307;
const ld PI = acos(-1);

template<class T>
istream &operator>>(istream &input, vector<T>& v) {
    for (auto &i : v) {
        input >> i;
    }
    return input;
}

template<class T>
ostream &operator<<(ostream &output, vector<T>& v) {
    for (auto &i : v) {
        output << i << ' ';
    }
    return output;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void cok(bool t) { cout << (t ? "Yes" : "No") << '\n'; }

#define bits_s(a) bitset<64>(a).to_string()
string bits(ll m) {
    string s = bits_s(m);
    //reverse(full(s));
    return s;
}

const ll N = 2e5 + 10;
const ll MAXN = 1e16;
const ll MOD = 1e9 + 7;

map <string, ll> mp;
map <ll, string> mp1;
map <string, bool> e;

string s, s1;
string Ats(ll x) {
    ll a = x / 10;
    ll b = x % 10;
    string rez = "";
    if (a != 0) {
        rez += mp1[a];
    }
    rez += mp1[b];
    string ans = "";
    if (rez.size() == 7) {
        for (ll i = 0; i < 7; i++) {
            if (s1[i] == '0' || rez[i] == '0') {
                ans += '0';
            } else {
                ans += '1';
            }
        }
    } else {
        for (ll i = 0; i < 7; i++) {
            if (s[i] == '0' || rez[i] == '0') {
                ans += '0';
            } else {
                ans += '1';
            }
        }
        for (ll i = 0; i < 7; i++) {
            if (s1[i] == '0' || rez[i + 7] == '0') {
                ans += '0';
            } else {
                ans += '1';
            }
        }
    }
    return ans;
}

ll Atx(string& s) {
    ll rez = 0;
    if (s.size() == 7) {
        if (e[s]) rez = mp[s];
        else return -1;
    } else {
        if (e[s.substr(0, 7)]) rez += mp[s.substr(0, 7)];
        else return -1;
        rez *= 10;
        if (e[s.substr(7, 7)]) rez += mp[s.substr(7, 7)];
        else return -1;
    }
    return rez;
}

void solve() {
    cin >> s >> s1;
    mp["1110111"] = 0;
    mp["0010010"] = 1;
    mp["1011101"] = 2;
    mp["1011011"] = 3;
    mp["0111010"] = 4;
    mp["1101011"] = 5;
    mp["1101111"] = 6;
    mp["1010010"] = 7;
    mp["1111111"] = 8;
    mp["1111011"] = 9;
    for (auto [f, t]: mp) {mp1[t] = f; e[f] = true;}
    ll ans = 0;
    ll cnt = 0;
    for (ll i = 99; i >= 2; i--) {
        string a = Ats(i);
        string b = Ats(i - 1);
        ll fa = Atx(a), fb = Atx(b);
        if (fa != -1 && fb != -1 && fa + 1 == fb) {
            cnt++;
        } else {
            ans = max(ans, cnt);
            cnt = 0;
        }
    }
    cout << ans << '\n';
}

signed main() {
    fastIO
    auto start_time = chrono::high_resolution_clock::now();
    ll _ = 1;
    // cin >> _;
    while (_--) {
        solve();
    }
    auto end_time = chrono::high_resolution_clock::now();
    //cerr << "Execution time: " << chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
    return 0;
}
