#ifdef LOCAL  // -DLOCAL

#include "debug.h"
#include "headers.h"

// #define debug(...) 42

std::ifstream in("test.in");
auto _ = std::cin.rdbuf(in.rdbuf());

#else

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define debug(...) 42
#define assert(...) 42

#endif

using std::array;
using std::bitset;
using std::cin;
using std::cout;
using std::deque, std::priority_queue;
using std::endl;
using std::fstream, std::ifstream, std::ofstream;
using std::get;
using std::ios;
using std::iterator;
using std::list, std::forward_list;
using std::lower_bound, std::upper_bound;
using std::map, std::multimap, std::unordered_map;
using std::pair, std::make_pair;
using std::queue;
using std::set, std::multiset, std::unordered_set;
using std::sort;
using std::stack;
using std::string;
using std::swap;
using std::tie;
using std::tuple, std::make_tuple;
using std::vector;

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;
using vi = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vb = vector<bool>;
using vpi = vector<pi>;
using vpll = vector<pll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using vvb = vector<vb>;
using vvpi = vector<vpi>;
using vvpll = vector<vpll>;

#define all(obj) obj.begin(), obj.end()

void precalc() {
  
}

void solve() {
  int n;
  cin >> n;

  int min_ox = INT32_MAX;
  int max_ox = INT32_MIN;
  int max_abs_y = 0;

  while(n--) {
    int x, y;
    cin >> x >> y;
    if (y == 0) {
      min_ox = std::min(min_ox, x);
      max_ox = std::max(max_ox, x);
    } 
    max_abs_y = std::max(max_abs_y, std::abs(y));
  }

  if (min_ox != INT32_MAX) {
    cout << (max_ox - min_ox) * max_abs_y / 2. << '\n';
  } else {
    cout << "0\n";
  }
}

int main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  std::cout.precision(15);

  precalc();
  int t = 1;
  // std::cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}