#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<pair<int, int> > points(n);
    int minX = INT_MAX, maxX = INT_MIN;
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
        if (points[i].second == 0) {
            minX = std::min(minX, points[i].first);
            maxX = std::max(maxX, points[i].first);
        }
    }

    if (minX >= maxX) {
        std::cout << 0 << std::endl;
        return 0;
    }

    int maxY = INT_MIN;
    for (auto& point: points) {
        maxY = std::max(maxY, std::abs(point.second));
    }

    std::cout << (double)maxY * (double)(maxX - minX) / 2 << std::endl;

    return 0;
}
