#include <iomanip>
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

long long absl(long long x) {
    return x < 0 ? -x : x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    long long n;
    cin >> n;
    if (n < 3) {
        cout << 0 << endl;
        return 0;
    }
    vector<pair<long long, long long> > points(n);
    long long minX = LLONG_MAX, maxX = LLONG_MIN;
    for (long long i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
        if (points[i].second == 0) {
            minX = std::min(minX, points[i].first);
            maxX = std::max(maxX, points[i].first);
        }
    }

    if (minX >= maxX) {
        std::cout << 0 << std::endl;
        return 0;
    }

    long long maxY = 0;
    for (auto& point: points) {
        maxY = std::max(maxY, absl(point.second));
    }

    std::cout << setprecision(1) << fixed << (double)(maxX - minX) * maxY / 2  << std::endl;

    return 0;
}
