
#pragma GCC optimize("O3,unroll-loops")
  
#include <iostream>
#include <vector>
#include <cstdint>
#include <queue>
#include <algorithm>

using namespace std;
 
int INF = INT32_MAX;

int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int> (n));
    vector<vector<pair<int, int>>> graph(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            if(j > i){ 
                graph[i].push_back({j, matr[i][j]});
                graph[j].push_back({i, matr[i][j]});
            }
        }
    }
    vector<vector<int>> d = matr;
    for (int k=0; k<n; ++k) {
    	for (int i=0; i<n; ++i) {
    		for (int j=0; j<n; ++j) {
    			d[i][j] = min (d[i][j], d[i][k] + d[k][j]);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (j < i) continue;
            if (d[i][j] < matr[i][j]) {
                //cout << d[i][j] << " " << matr[i][j] << "\n";
                cout << "No";
                return 0;
            }
        }
    }
    
    cout << "Yes";
}