#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

int getInt(vector<int> &i) {
    for (int &j : i) j--;
    int res = 0;
    for (int j : i) res += 1 << j;
    return res;
}

void solve() {
    string s, t;
    cin >> s >> t;
    int V1 = 0, V2 = 0;
    for (int i = 0; i < 7; i++) {
        if (s[i] == '1') V1 += 1 << i;
        if (t[i] == '1') V2 += 1 << i;
    }
    map<int, int> mp1, mp2;
    vector<vector<int>> bits = {
            {1, 2, 3, 5, 6, 7},
            {3, 6},
            {1, 3, 4, 5, 7},
            {1, 3, 4, 6, 7},
            {2, 3, 4, 6},
            {1, 2, 4, 6, 7},
            {1, 2, 4, 5, 6, 7},
            {1, 3, 6},
            {1, 2, 3, 4, 5, 6, 7},
            {1, 2, 3, 4, 6, 7}
    };
    for (int i = 0; i < 10; i++) {
        mp1[i] = getInt(bits[i]); // num -> mask
        mp2[mp1[i]] = i; // mask -> num
    }
    vector<int> val1(10, -1), val2(10, -1);
    for (int i = 0; i < 10; i++) {
        int cur_val1 = mp1[i] & V1;
        if (mp2.find(cur_val1) != mp2.end())
            val1[i] = mp2[cur_val1];
        int cur_val2 = mp1[i] & V2;
        if (mp2.find(cur_val2) != mp2.end())
            val2[i] = mp2[cur_val2];
    }
    vector<int> real(100, -1);
    for (int i = 0; i < 10; i++) {
        real[i] = val2[i];
    }
    for (int i = 0; i < 100; i++) {
        if (val1[i / 10] == -1 || val2[i % 10] == -1)
            continue;
        real[i] = 10 * val1[i / 10] + val2[i % 10];
    }
    vector<int> dp(100, 0);
    dp[0] = (int)(real[0] != -1);
    for (int i = 1; i < 100; i++) {
        if (real[i] == -1)
            continue;
        if (real[i] == real[i - 1] - 1)
            dp[i] = dp[i - 1] + 1;
        else
            dp[i] = 1;
    }
    int res = *max_element(dp.begin(), dp.end());
    if (res <= 1) {
        cout << 0;
        return;
    }
    cout << *max_element(dp.begin(), dp.end()) - 1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
