#include <bits/stdc++.h>
#define int long long
using namespace std;

void solve() {
    string s; cin >> s;
    int k; cin >> k;
    int n = s.size();
    vector<pair<int, int>> a(n);
    vector<vector<int>> pref(n, vector<int>(10, 0));
    for (int i = 0; i < n; ++i) {
        a[i] = {(s[i] - '0'), i};
        for (int d = 1; d < 10; ++d) {
            pref[i][d] = (a[i].first == d);
            if (i > 0)
                pref[i][d] += pref[i - 1][d];
        }
    }
    auto srt = a;
    sort(srt.begin(), srt.end());
    vector<int> left_gr(n);
    int need = 0;
    for (int i = 0; i < n; ++i) {
        for (int d = a[i].first + 1; d < 10; ++d)
            left_gr[i] += pref[i][d];
        need += left_gr[i];
    }

    vector<int> b;
    for (int i = n - 1; i >= -1; --i) {
        if (need <= k) {
            k -= need;
            vector<bool> have(n);
            for (int j = 0; j <= i; ++j) {
                b.push_back(srt[j].first);
                have[srt[j].second] = true;
            }
            for (int j = 0; j < n; ++j) {
                if (!have[j])
                    b.push_back(a[j].first);
            }
            break;
        }
        assert(i >= 0);
        need -= left_gr[srt[i].second];
    }
    assert(b.size() == n && k <= n);
    vector<set<int>> pos(10);
    for (int i = 0; i < n; ++i) {
        pos[b[i]].insert(i);
    }
    for (int i = 0; i < n; ++i) {
        for (int d = 1; d < 10; ++d) {
            if (!pos[d].empty() && *pos[d].begin() - i <= k) {
                int j = *pos[d].begin();
                k -= j - i;
                for (int t = j; t > i; --t) {
                    pos[b[t]].erase(t);
                    pos[b[t - 1]].erase(t - 1);
                    pos[b[t]].insert(t - 1);
                    pos[b[t - 1]].insert(t);
                    swap(b[t], b[t - 1]);
                }
                pos[b[i]].erase(i);
                break;
            }
        }
    }
    for (int x : b) cout << x;
    cout << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.precision(20);

    int T; cin >> T;
    while (T--)
        solve();
}