#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    // cin >> t;
    while (t --> 0) {
        solve();
        cout << '\n';
    }

    return 0;
}

const int NO = -100;

vector<string> num = {
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011"
};

string do_mask(string a, string mask)
{
    string ret = "";
    for (int i = 0; i < 7; i++) {
        if (a[i] == '1' && mask[i] == '1')
            ret += '1';
        else
            ret += '0';
    }

    return ret;
}

int find_digit(string x)
{
    for (int i = 0; i < 10; i++) {
        if (num[i] == x)
            return i;
    }

    return NO;
}

void solve()
{
    string m1, m2;
    cin >> m1 >> m2;

    vector<int> a;
    for (int i = 99; i >= 1; i--) {
        if (i / 10 > 0) {
            int b = find_digit(do_mask(num[i / 10], m1));

            if (b == NO || b == 0) {
                a.pb(NO);
                continue;
            }

            int c = find_digit(do_mask(num[i % 10], m2));        
            if (c == NO)
                a.pb(NO);
            else
                a.pb(10 * b + c);
        }
        else {
            int b = find_digit(do_mask(num[i], m2));
            a.pb(b);
        }     
    }
    
    int ans = 0;
    int cur = 1;
    for (int i = 1; i < (int)a.size(); i++) {
        if (a[i] == a[i-1] + 1)
            cur++;
        else
            cur = 1;

        ans = max(ans, cur - 1);
    }

    cout << ans;
}