#include "bits/stdc++.h"
using namespace std;

#define int long long

std::vector<set<int>> seg = {
    {0, 1, 2, 4, 5, 6}, // 0
    {2, 5}, // 1
    {0, 2, 3, 4, 6}, // 2
    {0, 2, 3, 5, 6}, // 3
    {1, 2, 3, 5}, // 4
    {0, 1, 3, 5, 6}, // 5
    {0, 1, 3, 4, 5, 6}, // 6
    {0, 2, 5}, // 7
    {0, 1, 2, 3, 4, 5, 6}, // 8
    {0, 1, 2, 3, 5, 6}, // 9

};

void solve() {

    map<set<int>, int> m;
    for (int i = 0; i < 10; i++) {
        m[seg[i]] = i;
    }
    string s1, s2;
    cin >> s1 >> s2;
    swap(s1, s2);
    int prev = -1;
    for (int i = 1; i < 100; i++) {
        int d1 = i / 10;
        int d2 = i % 10;

        // int D1 = (i + 1) / 10;
        // int D2 = i % 10;

        set<int> seg1 = seg[d1], seg2 = seg[d2];
        for (int j = 0; j < 7; j++) {
            if (s2[j] == '0') {
                seg1.erase(j);
            }
        }

        for (int j = 0; j < 7; j++) {
            if (s1[j] == '0') {
                seg2.erase(j);
            }
        }

        int temp = prev;

        if (seg1.size() == 0) {
            if (m.count(seg2) == 0) {
                prev = -1;
            } else {
                prev = m[seg2];
            }
        } else {
            if (m.count(seg1) == 0 || m.count(seg2) == 0) {
                prev = -1;
            } else {
                prev = 10 * m[seg1] + m[seg2];
            }
        }

        // cout << i << " " << prev << endl;

        if (prev + 1 == temp) {
            cout << 1 << endl;
            return;
        }

    }
    cout << "0\n";
    return;
    
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
