#include <iostream>
#include "bits/stdc++.h"

using namespace std;

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    vector<long long int> factorials(100001);
    factorials[0] = 1;
    factorials[1] = 1;
    for (int i = 2; i < 100001; ++i) {
        factorials[i] = (factorials[i - 1] * i) % 998244353;
    }

    int r, g, b;
    cin >> r >> g >> b;

    if (r > g + b + 1 || g > r + b + 1 || b > r + g + 1) {
        cout << 0;
        return 0;
    }

    vector<int> c = {r, g, b};
    std::sort(c.begin(), c.end());
    long long int answer = ((factorials[c[0] + c[1]] * factorials[c[0] + c[1] + 1]) /
                           (factorials[c[0]] * factorials[c[1]] * factorials[c[2]] *
                            factorials[c[0] + c[1] + 1 - c[2]])) % 998244353;

    cout << answer;
    return 0;
}
