from functools import cache

@cache
def solve(n, k, f):
    if n > 1 and k == 0 and f:
        return int(2e18)
    if n == 1:
        return 0
    if not f and k == 0:
        return n - 1
    return 1 + min(
        max(
            solve(n // 2, k, f),
            solve(n - n // 2, k - (1 if f else 0), not f)
        ),
        max(
            solve(n - n // 2, k, f),
            solve(n // 2, k - (1 if f else 0), not f)
        ),
        n - 2 if not f else int(2e18)
    )

t = int(input())
for _ in range(t):
    n, k = map(int, input().split())
    print(solve(n, k, True))
