#include <bits/stdc++.h>
using namespace std;

#pragma optimize ("g",on)
#pragma GCC optimize ("inline")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("03")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
#pragma comment(linker, "/stack:200000000")

#define PI 3.1415926535897932384626433832795
#define MOD 1000000007
#define int long long
using ll = long long;
const int inf = (int)2e9;

const int MAX_N = 200100;


vector<string> nums{
"1110111",  // 0
"0010010",  // 1
"1011101",  // 2
"1011011",  // 3
"0111010",  // 4
"1101011",  // 5
"1101111",  // 6
"1010010",  // 7
"1111111",  // 8
"1111011"   // 9
    };
/*
bool check(string s, string ch) {
    for(int p = 0; p < s.size(); p++) {
        if(ch[p] == '1' && s[p] == '0') {
            return false;
        }
    }
    return true;
}
*/
void solve(){
    /*
    vector<bool> F(7);
    for(int i = 0; i < 8; i++) {
        for(int j = 0; j < 7; j++) {
            if(j < i) F[j] = false;
            else F[j] = true;
            cout<< F[j];
        }
        cout<< endl;
        do {
            for(auto e : F) cout<< e;
            cout<< endl;
        } while(next_permutation(F.begin(),F.end()));
        cout<< endl;
    }
    */
    

    string s1; cin>> s1;
    string s2; cin>> s2;
    vector<int> F1(10);
    for(int i = 0; i < 10; i++) {
        string k = nums[i];
        for(int j = 0; j < 8; j++) {
            if(s1[j] == '0') k[j] = '0';
        }
        bool f = false;
        for(int j = 1; j < 10; j++) {
            if(nums[j] == k) {
                F1[i] = j;
                f = true;
            }
        }
        if(k == "0000000") F1[i] = -inf;
        else if(!f) F1[i] = inf;
    }
    vector<int> F2(10);
    for(int i = 0; i < 10; i++) {
        string k = nums[i];
        for(int j = 0; j < 8; j++) {
            if(s2[j] == '0') k[j] = '0';
        }
        bool f = false;
        for(int j = 0; j < 10; j++) {
            if(nums[j] == k) {
                F2[i] = j;
                f = true;
            }
        }
        if(!f) F2[i] = inf;
    }
    int ans = 0;
    int prev = inf;
    int count = 0;
    for(int tm = 99; tm > 0; tm--) {
        if(F1[tm / 10] == inf || F2[tm % 10] == inf) {
            prev = inf;
            count = 0;
            continue;
        }
        if(prev == inf) {
            if(F1[tm / 10] == -inf) prev = F2[tm % 10];
            else prev = F1[tm / 10] * 10 + F2[tm % 10];
            continue;
        }
        if(F1[tm / 10] == -inf) {
            if(F2[tm % 10] == prev + 1) {
                prev++;
                count++;
                ans = max(ans, count);
            }
            else {
                prev = F2[tm % 10];
                count = 0;
            }
        }
        else {
            if(F1[tm / 10] * 10 + F2[tm % 10] == prev + 1) {
                prev++;
                count++;
                ans = max(ans, count);
            }
            else {
                prev = F1[tm / 10] * 10 + F2[tm % 10];
                count = 0;
            }
        }
        
    }
    cout<< ans;
    /*
    if(check(s1, nums[0])) F1[0] = 0;
    else if(check(s1, nums[7])) F1[0] = 7;
    else if(check(s1, nums[1])) F1[0] = 1;
    else F1[0] = inf;
    
    if(check(s1, nums[1])) F1[1] = 1;
    else F1[1] = inf;

    if(check(s1, nums[2])) F1[2] = 2;
    else F1[2] = inf;

    if(check(s1, nums[3])) F1[3] = 3;
    else if(check(s1, nums[7])) F1[3] = 7;
    else if(check(s1, nums[1])) F1[3] = 1;
    else F1[3] = inf;
    */
}
 
int32_t main(){
    /*
#ifndef ONLINE_JUDGE
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
#endif
*/
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;  //cin>> t;
    while (t--)
    {
        solve();
    }
    return 0;
}