#include <algorithm>
#include <array>
#include <iostream>
#include <map>
#include <string>
#include <string_view>
#include <vector>

using namespace std;

int pos(map<char, int>& m, char c) {
    if (m.find(c) != m.end()) {
        for (char i = c; i <= '9'; ++i) {
            if (m.find(i) != m.end()) {
                ++m[i];
            }
        }
    } else {
        char i = c - 1;
        for (; i > '0'; --i) {
            if (m.find(i) != m.end()) {
                break;
            }
        }
        if (i == '0') {
            m[c] = 0;
        } else {
            m[c] = m[i] + 1;
        }
        for (char j = c + 1; j <= '9'; ++j) {
            if (m.find(j) != m.end()) {
                ++m[j];
            }
        }
    }
    return m[c];
}

void solve() {
    string s;
    int k;
    cin >> s >> k;
    map<char, int> m;
    int i;
    for (i = 0; i < s.size(); ++i) {
        int p = pos(m, s[i]);
        if (k < i - p) {
            break;
        }
        k -= i - p;
    }
    if (i == s.size()) {
        sort(s.begin(), s.end());
    } else {
        sort(s.begin(), s.begin() + i - 1);
        while (k > 0) {
            swap(s[i], s[i - 1]);
            --k;
        }
    }
    cout << s << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}

//4
//321 0
//9 1
//21241127 10
//692 1