#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

struct edge {
    long long d;
    int u, v;
};

void solve()
{
    int n;
    cin >> n;
    vector<vector<long long>> d(n, vector<long long>(n));
    vector<vector<long long>> curr(n, vector<long long>(n, 1e9 + 157));
    vector<edge> e;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
            if (i < j) {
                e.push_back({d[i][j], i, j});
            }
        }
    }
    sort(all(e), [](const edge& x, const edge& y){
        return x.d < y.d;
    });
    for (auto [dist, u, v] : e) {
        if (curr[u][v] > dist) {
            curr[u][v] = curr[v][u] = dist;
            for (int i = 0; i < n; i++) {
                curr[u][i] = curr[i][u] = min(curr[u][i], curr[u][v] + curr[v][i]);
            }
            for (int i = 0; i < n; i++) {
                curr[v][i] = curr[i][v] = min(curr[v][i], curr[v][u] + curr[u][i]);
            }
        } else if (curr[u][v] < dist) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}

int32_t main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int tt = 1;
    while (tt--)
    {
        solve();
    }
}