#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ll long long 
#define f(i, n) for (int i = 0; i < (int)(n); ++i)
#define F(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)
#define all(x) (x).begin(), (x).end()

const int INF = 1e9;
const int SZ = 1024 * 1024 * 2;
const int mod = 1e9 + 7;
const double eps = 1e-10;
const double long PI = acos(-1);

int tree[SZ];
int N;
int dp[SZ];
vector<int>pos[11];
int uk[11];
int get(int x, int L = 0, int R = N, int v = 1){
    // cout << "get " << L << " " << R << endl;
    if(L > x) return 0;
    if(R <= x){
        return tree[v];
    }
    if (R - L == 1) return tree[v];
    int m = (R + L) / 2;
    return get(x, L, m, 2 * v) +  get(x, m, R, 2 * v + 1);
}   
void update(int x, int z, int L = 0, int R = N, int v = 1){
    if(R <= x || L > x) return;
    if(R - L == 1){
        tree[v] = z;
        return;
    }
    int m = (R + L) / 2;
    update(x, z, L, m, 2 * v);
    update(x, z, m, R, 2 * v + 1);
    tree[v] = tree[v * 2 ] + tree[2 * v + 1];  
}
void solve(){
    string s; cin >> s;
    int k; cin >> k;
    N = 1;
    while(N <= s.size()) N *= 2;
    set<pair<int, int>>qwe;
    for(int  i = 0; i < s.size(); i++){
        qwe.insert({(int)(s[i] - '0'), i});
        dp[i] = 0;
        update(i, 1);
    }
    string ans;
    while(ans.size() < s.size()){
        auto to = qwe.begin();
        // cout << "call get " << to -> second << endl;
        int h = get((*to).second) - 1;
        if(h > k) break;
        // cout << "call update " << to -> second << endl;
        update((*to).second, 0);
        ans.push_back((*to).first + '0');
        dp[(*to).second] = 1;
        qwe.erase(to);
        k -= h;
    }
    if(ans.size() == s.size()){
        cout << ans;
        return;
    } 
    string ans2;
    for(int i = 0 ; i < 10; i++){
        pos[i].clear();
        uk[i] = 0;
    }
    for(int  i = 0; i < s.size();i++)
        if(!dp[i]){
            ans2.push_back(s[i]);
            pos[(int)(s[i] - '0')].push_back(i);
        }
    for(int i = 0; i < s.size(); i++){
        if(dp[i] == 1) continue;
        int f = 0; 
        for(int j = 0; j < (int)(s[i]  - '0'); j++){
            if(uk[j] == pos[j].size()) continue;
            int h = get(pos[j][uk[j]]) - 1;
            if(h  <= k){
                k -= h;
                ans.push_back(j  + '0');
                f = 1;
                update(pos[j][uk[j]], 0);
                dp[pos[j][uk[j]]] = 1;
                uk[j]++;
                break;
            }
        }
        if(f) i--;
        if(!f){
            ans.push_back(s[i]);
            update(i, 0);
            dp[i] = 1;
            uk[(int)(s[i]  - '0')]++;
        }
    }
    cout << ans;
   
}
signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T = 1;
    // cout << fixed;
    // cout.precision(7);
    cin >> T;
    while (T--){
        solve();
        cout << '\n';
    }
}