#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <map>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const ll INF = 1e12;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var
vector<vll> b;
vector<vector<pll>> g2;
///

void dfs(int s, int v, ll sum, int p) {
    b[s][v] = sum;
    for (auto &to: g2[v]) {
        if (to.fi == p) continue;
        dfs(s, to.fi, sum + to.se, v);
    }
}

void solve(){
    int n; cin >> n;
    vector<vll> g(n, vll(n));
    g2.resize(n);
    b.resize(n, vll(n, 0));
    rep(i, n) rep(j, n) cin >> g[i][j];
    
    vector<bool> used (n);
    vll min_e (n, INF), sel_e (n, -1);
    min_e[0] = 0;
    for (int i=0; i<n; ++i) {
        int v = -1;
        for (int j=0; j<n; ++j)
            if (!used[j] && (v == -1 || min_e[j] < min_e[v]))
                v = j;
        if (min_e[v] == INF) {
            cout << "No"; re;
        }
    
        used[v] = true;
        if (sel_e[v] != -1){
            g2[v].push_back({sel_e[v], g[v][sel_e[v]]});
            g2[sel_e[v]].push_back({v, g[v][sel_e[v]]});
        }
    
        for (int to=0; to<n; ++to)
            if (g[v][to] < min_e[to]) {
                min_e[to] = g[v][to];
                sel_e[to] = v;
            }
    }

    rep(i, n) dfs(i, i, 0, -1);

    if (g == b) cout << "Yes";
    else cout << "No";
}

signed main() {
    GO();
    int Q = 1; 
    while (Q--) solve();
}
