#include <bits\stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define t third

void solution() {
    string s; cin >> s;
    ll k; cin >> k;

    ll n = (int) s.size();
    priority_queue<pair<char, int>, vector<pair<char, int>>, greater<pair<char, int>>> minHeap;

    for (int i = 0; i < n; ++i) {
        minHeap.push({s[i], i});

        if (i >= k) {
            minHeap.pop();
        }

        if (i >= k) {
            auto [minChar, minIndex] = minHeap.top();

            if (minIndex < i) {
                swap(s[i], s[minIndex]);
                k -= (minIndex - i);
            }
        }
    }

    cout << s << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solution();
    }

}
