#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <queue>
#include <tuple>
#include <set>

using namespace std;

constexpr int INF = INT_MAX;

void solve() {
    int n;
    cin >> n;
    vector d(n, vector(n, 0));
    for (auto &row: d) {
        for (auto &el: row) {
            cin >> el;
        }
    }

    for (int u = 1; u < n; u++) {
        for (int v = u + 1; v < n; v++) {
            if (d[0][v] != d[0][u] + d[u][v]) {
                cout << "No";
                return;
            }
        }
    }

    cout << "Yes";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
