#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define ull unsigned ll
#define int ll
#define ld long double
#define F first
#define S second
#ifndef OlegSanders
#define cerr if (false) cerr
#endif

using namespace std;

int INF = 1e9+7;

int sqr(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    pair<int, int> v1 = {b.first - a.first, b.second - a.second};
    pair<int, int> v2 = {c.first - a.first, c.second - a.second};
    return abs(v1.first * v2.second - v2.first * v1.second);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> a;
    pair<int, int> left = {+INF, +INF};
    pair<int, int> right = {-INF, -INF};
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.pb({x, y});
        if (y == 0) {
            left = min(left, {x, 0});
            right = max(right, {x, 0});
        }
    }
    if (left.first == INF || right.first == -INF) {
        cout << 0;
        return 0;
    }

//    cout << left.first << ' ' << left.second << endl;
//    cout << right.first << ' ' << right.second << endl;

    int mx = 0;

    for (int i = 0; i < n; i++) {
        mx = max(mx, sqr(left, right, a[i]));
    }
    cout << fixed << setprecision(10) << mx / 2.0;
}
