#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    vector<string> results;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        for (int i = 0; i < n; ++i) {
            if (k <= 0) break;

            int min_pos = i;
            for (int j = i + 1; j < n && j <= i + k; ++j) {
                if (s[j] < s[min_pos]) {
                    min_pos = j;
                }
            }

            int cost = min_pos - i;

            if (cost <= k) {
                char min_digit = s[min_pos];
                s.erase(s.begin() + min_pos);
                s.insert(s.begin() + i, min_digit);
                k -= cost;
            }
        }
        
        results.push_back(s);
    }

    for (const string& result : results) {
        cout << result << endl;
    }

    return 0;
}
