#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>

#define fr first
#define sc second
#define pb push_back

using namespace std;
using ll = long long;
using pl = pair<ll, ll>;
using str = string;

ll findn(str &s) {
	ll ibeg = s.find('<') + 2;
	ll iend = s.find(';', ibeg);
	return stoll(s.substr(ibeg, iend - ibeg));
}
pl findp(str& s) {
	pl res;
	ll ibeg = s.find('==') + 2;
	ll iend = s.find(')');
	res.fr = stoll(s.substr(ibeg, iend - ibeg));

	ibeg = s.find('=', ibeg) + 2;
	iend = s.find(';');
	res.sc = stoll(s.substr(ibeg, iend - ibeg));
	return res;
}

void dfs(ll u, vector<pl>&gr, vector<ll>&g, vector<pl>&v) {
	if (gr[u].fr != -1) return;
	if (g[u] == -1) { gr[u] = { u, 1 }; return; }
	dfs(g[u], gr, g, v);
	gr[u] = { gr[g[u]].first, gr[g[u]].second + 1 };
}

void fill_nv(ll& n, vector<pl>& v) {
	str s; getline(cin, s);
	n = findn(s);
	while (getline(cin, s)) {
		if (s.find("work") != s.npos || s.find('}') != s.npos)
			break;
		v.pb(findp(s));
	}
}
void fill_mym(map<ll, ll>& mym, vector<pl>&v) {
	for (int i = 0; i < v.size(); i++)
		if (mym.find(v[i].fr) == mym.end())
			mym[v[i].fr] = i;
}
void fill_g(vector<ll>& g, vector<pl>& v) {
	unordered_map<ll, ll> m;
	for (int i = v.size() - 1; i >= 0; i--) {
		if (m.find(v[i].sc) != m.end())
			g[i] = m[v[i].sc];
		m[v[i].fr] = i;
	}
}
void fill_gr(vector<pl>& gr, vector<ll>& g, vector<pl>& v) {
	for (int i = 0; i < gr.size(); i++)
		dfs(i, gr, g, v);
}


signed main() {
	ll n; vector<pl> v; fill_nv(n, v);
	map<ll, ll> mym; fill_mym(mym, v);
	vector<ll> g(v.size(), -1); fill_g(g, v);
	vector<pl> gr(v.size(), { -1, -1 }); fill_gr(gr, g, v);

	ll res = 2;
	ll base = 3 + v.size();
	ll i = 0;
	set<ll> mys;
	while (1) {
		if (mys.find(i) != mys.end()) {
			cout << -1;
			return 0;
		}
		mys.insert(i);

		auto it = mym.lower_bound(i);
		if (it == mym.end() || (*it).fr >= n) {
			res += base * (n - i);
			break;
		}
		res += base * ((*it).fr - i + 1) + gr[(*it).sc].sc;
		ll nj = v[gr[(*it).sc].fr].sc;
		i = nj + 1;

		mys.insert((*it).fr);
	}
	cout << res;
}