digits = [
    "1110111",  # 0
    "0010010",  # 1
    "1011101",  # 2
    "1011011",  # 3
    "0111010",  # 4
    "1101011",  # 5
    "1101111",  # 6
    "1010010",  # 7
    "1111111",  # 8
    "1111011"  # 9
]


def possible_digits(state):
    possible = []
    for i, digit_mask in enumerate(digits):
        match = True
        for s, d in zip(state, digit_mask):
            if s == '0' and d == '1':
                match = False
                break
        if match:
            possible.append(i)
    return possible


first_state = input().strip()
second_state = input().strip()
flag = 1
if first_state == '0000000' and second_state != "0000000":
    flag = 0
first_digits = possible_digits(first_state)
second_digits = possible_digits(second_state)

illusion_possible = 0
for d1 in first_digits:
    for d2 in second_digits:
        if (d1 * 10 + d2 + 1) in [x * 10 + y for x in first_digits for y in second_digits]:
            illusion_possible = 1
            break
    if illusion_possible:
        break
if flag == 0:
    print(1)
else:
    print(illusion_possible)