#include <iostream>
#include <cmath>

uint64_t BS(uint64_t x){
    uint64_t L = 0, R = 64, M;
    while (R - L > 1){
        M = (L + R) / 2;
        if (pow(2, M) < x){
            L = M;
        }
        else{
            R = M;
        }
    }
    return R;
}

int main(){
    int t;
    std::cin >> t;
    uint64_t n, k;
    for (int i = 0; i < t; i++){
        std::cin >> n >> k;
        std::cout << BS(n) << "\n";
    }
    return 0;
}