#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <math.h>
#include <numeric>
#include <fstream>

using namespace std;
typedef long long ll;

string to_disp(int& num) {
	switch(num) {
	case 0:
		return "1110111";
	case 1:
		return "0010010";
	case 2:
		return "1011101";
	case 3:
		return "1011011";
	case 4:
		return "0111010";
	case 5:
		return "1101011";
	case 6:
		return "1101111";
	case 7:
		return "1010010";
	case 8:
		return "1111111";
	case 9:
		return "1111011";
	}
	return "-";
}
int to_int(string& s) {
	if (s == "1110111") return 0;
	else if (s == "0010010") return 1;
	else if (s == "1011101") return 2;
	else if (s == "1011011") return 3;
	else if (s == "0111010") return 4;
	else if (s == "1101011") return 5;
	else if (s == "1101111") return 6;
	else if (s == "1010010") return 7;
	else if (s == "1111111") return 8;
	else if (s == "1111011") return 9;
	else return -1;
}

int func(string f, string s, int num) {
	int fi = num / 10, si = num % 10;
	string fn = to_disp(fi), sn = to_disp(si);
	for (int i = 0; i < 7; ++i) {
		fn[i] = (f[i] == '1' && fn[i] == '1' ? '1' : '0');
		sn[i] = (s[i] == '1' && sn[i] == '1' ? '1' : '0');
	}
	if (to_int(fn) == -1 && fi != 0 || to_int(sn) == -1) {
		return -1;
	}
	return 10 * to_int(fn) * (fi != 0) + to_int(sn);
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t, flag;
	string f, s;
	cin >> f >> s;
	for (int k = 98; k >= 0; --k) {
		if (k == 0) {
			cout << 0;
			break;
		}
		for (int y = 99; y >= k + 1; --y) {
			flag = 1;
			for (int i = 0; i <= k; ++i) {
				//cout << y - i << ' ' << func(f, s, y - 1) << '\n';
				if (func(f, s, y - i) == -1) {
					flag = 0;
					//cout << "BREAK: -1\n";
					break;
				}
				if (i) {
					if (func(f, s, y - i) - t != 1) {
						flag = 0;
						//cout << "BREAK: LESS\n";
						break;
					}
				}
				t = func(f, s, y - i);
			}
			if (flag) {
				cout << k;
				return 0;
			}
		}
	}

	return 0;
}