#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>

using namespace std;

#define int long long
int a[1001][1001];
std::vector<int> d;
std::vector<vector<std::pair<int, int> > > g;
int n;

bool dfs_check(int v) {
    bool flag = true;
    for (size_t i = 0; i < n - 1; i++) {
        std::pair<int, int> k = g[v][i];
        if (d[k.first] == -1) {
            d[k.first] = d[v] + k.second;
            flag &= dfs_check(k.first);
        } else {
            if (d[k.first] != d[v] + k.second && d[k.first] + k.second != d[v]) {
                return false;
            }
        }
    }
    return flag;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    g.resize(n);
    d.resize(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            if (i != j) {
                g[i].emplace_back(j, a[i][j]);
            }
        }
    }

    d[0] = 0;
    bool flag = dfs_check(0);
    if (flag) {
        std::cout << "Yes" << std::endl;
    } else {
        std::cout << "No" << std::endl;
    }
}
