#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <codecvt>
#include <forward_list>
#include <initializer_list>
#include <random>
//#include <scoped_aintocator>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#if __cplusplus >= 201402L
#include <shared_mutex>
#endif

using namespace std;

//using namespace std;

#define int long long

int gcd(int a, int b) {
    if (b == 0) return a;
    else return gcd(b, a % b);
}

void solve() {
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int st, fin;
    cin >> st >> fin;
    if (st == fin){
        cout << "Kaban-" << st << " " << st << " " << fin << "\n";
        return;
    }
    st--;
    fin--;
    bool pos = true;
    vector<pair<pair<int, int>, int> > v;
    bool rev = false;
    if (st > fin){
        rev = true;
    }
    if (true){
        for(int i = min(st, fin); i<max(st, fin); i++){
            int j=i+1;
            if (abs(a[i] - a[j]) == 1){
                pos = false;
                cout << "Impossible\n";
                return;
            }
            int g = abs(a[i] - a[j]);
            int last_g = abs(a[i] - a[j]);
            while(abs(g) != 1 && j<=max(st, fin)){
                last_g = abs(g);
                j++;
                g = gcd(g, abs(a[j]-a[i]));
            }
            v.push_back({{i+1, j-1+1}, last_g});
            i = j-2;
        }
    }
    if (rev){
        std::reverse(v.begin(), v.end());
    }
    for(auto k:v){
        if (k.second == 0){
            k.second = 2;
        }
        if(rev){
            swap(k.first.first, k.first.second);
        }
        cout << "Kaban-" << abs(k.second) << " " <<  k.first.first << " " << k.first.second  << "\n";
    }
}

signed main() {
    solve();
}



//int main() {
//    int n;
//    cin >> n;
//    for(int _=0; _<n; _++){
//        string s;
//        cin >> s;
//        int k;
//        cin >> k;
//        vector<vector<int>>v(10);
//        vector<int>inds(10, 0);
//        for (int i=0; i<s.size(); i++){
//            v[s[i]-'0'].push_back(i);
//        }
//        for(int i=0; i<n; i++){
//            for(int dig =1; dig<10; dig++){
//                if (v[dig][inds[dig]] - i <=k){
//                    k -= (v[dig][inds[dig]] - i);
//                    cout << dig+'0';
//                    break;
//                }
//            }
//
//        }
//    }
//    return 0;
//}
