package vertalingen;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;


public class Amogus {
    public static void main(String[] args) throws IOException {
        var reader = new BufferedReader(new InputStreamReader(System.in));
        var line = reader.readLine();

        var firstStringParsed = line.split(" ");
        var start = Character.getNumericValue(firstStringParsed[4].charAt(0));
        var finish = Character.getNumericValue(firstStringParsed[7].charAt(0));

        var stringArray = new ArrayList<String[]>();
        var iValues = new HashSet<Integer>();

        line = reader.readLine();
        while (line != null) {
            var parsedLine = line.split(" ");
            if (parsedLine.length > 2) {
                stringArray.add(parsedLine);
                line = reader.readLine();
            } else {
                reader.readLine();
                break;
            }
        }

        var operationCounter = 1;

        var i = start;
        while (i < finish) {
            if (iValues.contains(i)) {
                System.out.print("-1");
                return;
            }
            iValues.add(i);

            operationCounter++;

            for (var strParsed : stringArray) {
                var comp = Character.getNumericValue(strParsed[3].charAt(0));

                if (i == comp) {
                    i = Character.getNumericValue(strParsed[6].charAt(0));
                    operationCounter++;
                }
                operationCounter++;
            }

            i++;
            operationCounter++;

            // work (i);
            operationCounter++;
        }

        // i < finish
        operationCounter++;

        System.out.print(operationCounter);
    }
}
