package vertalingen;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;


public class Amogus {
    public static int getThatInteger(String str) {
        return Integer.parseInt(str.substring(0, str.length() - 1));
    }

    public static void main(String[] args) throws IOException {
        var reader = new BufferedReader(new InputStreamReader(System.in));
        var line = reader.readLine();

        var firstStringParsed = line.split(" ");
        var start = getThatInteger(firstStringParsed[4]);
        var finish = getThatInteger(firstStringParsed[7]);

        var stringArray = new ArrayList<int[]>();
        var iValues = new HashSet<Integer>();

        line = reader.readLine();
        while (line != null) {
            var parsedLine = line.split(" ");
            if (parsedLine.length > 6) {
                stringArray.add(new int[]{getThatInteger(parsedLine[7]), getThatInteger(parsedLine[10])});
            }
            line = reader.readLine();
        }

        var operationCounter = 1;

        var i = start;
        while (i < finish) {
            if (iValues.contains(i)) {
                System.out.print("-1");
                return;
            }
            iValues.add(i);

            operationCounter++;

            for (var strParsed : stringArray) {
                var comp = strParsed[0];

                if (i == comp) {
                    i = strParsed[1];
                    operationCounter++;
                }
                operationCounter++;
            }

            i++;
            operationCounter++;

            // work (i);
            operationCounter++;
        }

        // i < finish
        operationCounter++;

        System.out.print(operationCounter);
    }
}
