import java.util.Scanner;

public class OrdinalNumbers {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        String input = scanner.nextLine();
        System.out.println(findOrdinalNumber(input));
    }

    private static int findOrdinalNumber(String input) {
        if (input.equals("{}")) {
            return 0;
        }
        return countElements(input.substring(1, input.length() - 1));
    }

    private static int countElements(String input) {
        int count = 0;
        int balance = 0;
        for (char c : input.toCharArray()) {
            if (c == '{') {
                balance++;
            } else if (c == '}') {
                balance--;
            } else if (c == ',' && balance == 0) {
                count++;
            }
        }

        return count + 1;
    }
}
