import java.util.Scanner;

public class Triangle {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][] points = new int[n][2];

        for (int i = 0; i < n; i++) {
            points[i][0] = scanner.nextInt();
            points[i][1] = scanner.nextInt();
        }

        double maxArea = 0;

        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (points[i][1] == points[j][1]) {
                    for (int k = 0; k < n; k++) {
                        if (k != i && k != j) {
                            double base = Math.abs(points[i][0] - points[j][0]);
                            double height = Math.abs(points[k][1] - points[i][1]);
                            double area = 0.5 * base * height;

                            maxArea = Math.max(maxArea, area);
                        }
                    }
                }
            }
        }

        // Вывод результата
        if (maxArea == 0) {
            System.out.println(0);
        } else {
            System.out.println(maxArea);
        }
    }
}
