import java.util.Scanner;

public class WoodenMatrixChecker {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        long[][] d = new long[n][n];

        // Read the matrix
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = scanner.nextLong();
            }
        }

        // Check for triangle inequality
        boolean isWooden = true;
        for (int i = 0; i < n && isWooden; i++) {
            for (int j = 0; j < n && isWooden; j++) {
                for (int k = 0; k < n && isWooden; k++) {
                    if (d[i][j] > d[i][k] + d[k][j]) {
                        isWooden = false;
                    }
                }
            }
        }

        // Output result
        System.out.println(isWooden ? "Yes" : "No");
    }
}
