#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

//using namespace __gnu_pbds;
//template<class c, class cmp = less<c> > using ordered_set = tree<c, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

//#pragma GCC optimize("O3, unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#define int long long
#define str string
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second
#define ll long long
#define db long double
#define ld long double
#define ull unsigned long long
#define sz(a) (int) a.size()
#define debug(x) cerr << (#x) << ": " << x << endl

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &i: arr) in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto i: arr) out << i << ' ';
    out << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.first >> p.second;
    return in;
}

const ll INF = 1e18;
const db EPS = 1e-6;
const int MOD = 1e9 + 7;
const int MOD2 = 998244353;
const int MAXN = 1e3 + 10;
//const int p = 123;
//const int q = 1789
mt19937 rnd(time(0));

void solve();

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    double start_time = clock();
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
#ifdef LOCAL
        cout << "----------------------\n";
#endif
    }
#ifdef LOCAL
    cerr << "Time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}

int n;
int a[MAXN][MAXN];
vector<pair<int, int>> g[MAXN];
int d[MAXN];

bool dfs(int v, int p = -1) {
    bool flag = true;
    for (auto [to, w]: g[v]) {
        if (to == p)
            continue;
        if (d[to] != INF) {
            flag = false;
            break;
        }
        d[to] = d[v] + w;
        dfs(to, v);
    }
    return flag;
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j)
            cin >> a[i][j];
        a[i][i] = INF;
    }
    for (int i = 0; i < n; ++i) {
        int mn = *min_element(a[i], a[i] + n);
        for (int j = 0; j < n; ++j)
            if (a[i][j] == mn && a[i][j] != INF)
                g[i].emplace_back(j, a[i][j]);
    }
    for (int i = 0; i < n; ++i) {
        fill(d, d + n, INF);
        d[i] = 0;
        bool flag = dfs(i);
        for (int j = 0; j < n; ++j)
            if (i != j && d[j] != a[i][j])
                flag = false;
        if (!flag) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}