#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <sstream>
#include <fstream>
#include <cassert>
#include <bitset>

#include <sstream>
#include <istream>
#include <string>

#define optimization_lvl_GOD          \
    ios_base::sync_with_stdio(false); \
    cin.tie(nullptr);                 \
    cout.tie(nullptr)

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define YES cout << "YES\n"
#define NO cout << "NO\n"
#define line cout << "----------\n"

#define pb push_back
#define re return
#define last(x) x[x.size() - 1]

#define pll pair<ll,ll>
#define pld pair<ld,ld>

#define vec vector
#define vll vec<ll>
#define vld vec<ld>
#define vvll vec<vll>
#define vull vec<ull>
#define vvld vec<vld>
#define vb vec<bool>
#define vvb vec<vb>

#define all(vec) vec.begin(), vec.end()

#define print(a) for(auto &elem : a) cout << elem << ' '; cout << '\n'

#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define input(vec) for(auto &elem : vec) cin >> elem;

using namespace std;

/*
ll step(ll a, ll n) {
    if (n == 1)
        return a;

    if (n % 2)
        return (step(a, n - 1) % MOD * a) % MOD;

    ll prev = step(a, n / 2) % MOD;
    return (prev * prev) % MOD;
}
*/

/*
set<ll> ez;
void resheto(ll n) {
    ez.clear();

    vec<bool> numbs(n, true);
    for (ll i = 2; i < n; i++)
        if (numbs[i]) {
            ez.insert(i);
            for (ll j = i; j < n; j += i)
                numbs[j] = false;
        }
}*/

/*bool Kuhn(ll &v, vvll &g, vb &visited, vll &ans) {
    if (visited[v]) {
        return false;
    }

    visited[v] = true;

    for(auto &i : g[v]) {
        if (ans[i] == -1 || Kuhn(ans[i], g, visited, ans)) {
            ans[i] = v;
            return true;
        }
    }

    return false;
}*/

//vec<pll> moveC{{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

const ll MOD = 998244353,
        inf = INFINITY;
const ld PI = 3.141592653589793,
        eps = 1e-9,
        cfPI = PI / ld(180);

/*
bool binSearch(string &s, ll &len, ll k) {
    ll n = s.size();
    for(ll i = 0; (i < n) && k; ++i) {
        ll ptr = 0;
        bool check = true;
        while(true) {
            if (ptr == len) {
                break;
            }

            if ((s[i + ptr] != s[ptr]) || (i + ptr >= n)) {
                check = false;
                break;
            }

            ++ptr;
        }

        if (check) {
            i += ptr - 1;
            --k;
        }
    }

    return !k;
}
*/

map<string, ll> numb;
map<ll, string> s;
vector<string> s1(2);

ll findReal(ll n, int ind) {
    auto it = s.find(n);
    string f = it->second;

    for(int i = 0; i < s1[ind].size(); ++i) {
        if (s1[ind][i] == '0') {
            f[i] = '0';
        }
    }

    auto it2 = numb.find(f);

    if (it2 == numb.end()) {
        return -1;
    }

    return it2->second;
}

void solve() {
    cin >> s1[0] >> s1[1];

    numb["1110111"] = 0;
    numb["0010010"] = 1;
    numb["1011101"] = 2;
    numb["1011011"] = 3;
    numb["0111010"] = 4;
    numb["1101011"] = 5;
    numb["1101111"] = 6;
    numb["1010010"] = 7;
    numb["1111111"] = 8;
    numb["1111011"] = 9;

    for(auto &i : numb) {
        s[i.second] = i.first;
    }

    ll last = 1000, ans = 0, cans = 0;
    for(ll cur = 99; cur >= 1; --cur) {
        ll c = 0;

        if (findReal(cur % 10, 1) == -1) {
            cans = 0;
            last = 1000;
            continue;
        } else {
            c += findReal(cur % 10, 1);
        }

        if (cur / 10 > 0 && findReal(cur / 10, 0) == -1) {
            cans = 0;
            last = 1000;
            continue;
        } else {
            c += findReal(cur / 10, 0) * 10;
        }

        //cout << cur << ' ' << findReal(cur / 10, 0) << ' ' << findReal(cur % 10, 1) << ' ' << c << '\n';

        if (c - last == 1) {
            cans++;
            ans = max(cans, ans);
            last = c;
        }

        last = c;
    }

    cout << ans;
}

int main() {
    optimization_lvl_GOD;

    ll t = 1;
    //cin >> t;

    while (t--)
        solve();
}

/*
                #################
              ############__######
           ######__#####__#####
          ######__####__######
           ####__####__####
            ###__###__###
             ##__##__##
               #__#__#
            ############################
        #+++==     =========       #############
      #==          ==========        ################
     #==          ==========          #################
#++++++             ===========          ##################
    #==          ==========           ####################
     #==         ===========          ###################
      #++         ===========        ##################
       #+++==      ============    ################
         ################################
             ==========================
              ###            ###
                ####           ####
                   ####           ####
*/
