# s = '''for (int i = 0; i < 3; i++) {
# work (i);
# }
# '''
#
# # s = '''for (int i = 0; i < 5; i++) {
# # if (i == 3) i = 1;
# # if (i == 1) i = 3;
# # if (i == 3) i = 4;
# # work (i);
# # }
# # '''
#
# l = s.split('\n')
# # ['for (int i = 12; i < 20; i++) {',
#     # 'if (i == 3) i = 1;',
#     # 'if (i == 1) i = 3;',
#     # 'if (i == 3) i = 4;',
#     # 'work (i);',
# # '}', '']
# first = l[0][l[0].index('(')+1:l[0].index(')')].split(';')  # ['int i = 12', ' i < 20', ' i++']
# start = int(first[0].split()[-1])  # 12
# finish = int(first[1].split()[-1])  # 20
# iters = 1
#
# coms = []
# for com in l[1:-3]:
#     n = com.split('==')[1].strip()
#     coms.append(n)
#
# for i in range(start, finish):
#     # iters += 1
#     if i in coms:
#         iters += 1
#     if i < finish:
#         iters += 1
#     iters += 2
#
# print(iters)


def analyze_program(n, conditions):
    operations_count = 0
    visited = set()

    i = 0
    while True:
        if i >= n:
            break

        operations_count += 1

        for x, y in conditions:
            operations_count += 1  # для i == x
            if i == x:
                i = y
                operations_count += 1  # для i = y
                break

        else:
            operations_count += 1  # для работы work(i)

        visited.add(i)

        if i in visited:
            return -1  # Программа зацикливается

    return operations_count


import sys

input_data = sys.stdin.read().strip().splitlines()
n = None
conditions = []

for line in input_data:
    if line.startswith("for"):
        n = int(line.split("<")[1].split()[0])
    elif line.startswith("if"):
        parts = line.split()
        x = int(parts[2])
        y = int(parts[4].rstrip(';'))
        conditions.append((x, y))
    elif line.startswith("work"):
        continue  # Условие `work` - просто пропускаем

result = analyze_program(n, conditions)
print(result)
