#include <iostream>
#include <cmath> // Для использования abs
#include <limits> // Для использования numeric_limits

using namespace std;

int main() {
    int n, x, y;
    int a = numeric_limits<int>::max(); // Инициализация для a
    int b = numeric_limits<int>::min(); // Инициализация для b
    int h = 0; // Максимальная абсолютная величина y
    int s = 0; // Результирующее значение
    int k = 0; // Счетчик случаев, когда y = 0

    cin >> n; // Чтение количества пар (x, y)
    
    for (int i = 0; i < n; ++i) {
        cin >> x >> y; // Чтение значений x и y
        
        if (y == 0) {
            k++;
            if (x < a) {
                a = x; // Обновление a
            }
            if (x > b) {
                b = x; // Обновление b
            }
        } else if (abs(y) > h) {
            h = abs(y); // Обновление h
        }
    }

    // Вычисление s
    if (k >= 2) {
        s = (b - a) * h;
    } else {
        s = 0;
    }

    // Вывод результата
    if (s % 2 == 1) {
        cout << fixed << s / 2.0 << endl; // Форматируем вывод с одним знаком после запятой
    } else {
        cout << s / 2 << endl; // Целочисленное деление
    }

    return 0;
}